"""
Shift-JIS characters download from: https://www.romhacking.net/documents/179/
"""
const kanji = Dict{AbstractChar, Int}(
    '　' => 0x0,
    '、' => 0x1,
    '。' => 0x2,
    '，' => 0x3,
    '．' => 0x4,
    '・' => 0x5,
    '：' => 0x6,
    '；' => 0x7,
    '？' => 0x8,
    '！' => 0x9,
    '゛' => 0xa,
    '゜' => 0xb,
    '´' => 0xc,
    '｀' => 0xd,
    '¨' => 0xe,
    '＾' => 0xf,
    '￣' => 0x10,
    '＿' => 0x11,
    'ヽ' => 0x12,
    'ヾ' => 0x13,
    'ゝ' => 0x14,
    'ゞ' => 0x15,
    '〃' => 0x16,
    '仝' => 0x17,
    '々' => 0x18,
    '〆' => 0x19,
    '〇' => 0x1a,
    'ー' => 0x1b,
    '―' => 0x1c,
    '‐' => 0x1d,
    '／' => 0x1e,
    '\\' => 0x1f,
    '〜' => 0x20,
    '‖' => 0x21,
    '｜' => 0x22,
    '…' => 0x23,
    '‥' => 0x24,
    '‘' => 0x25,
    '’' => 0x26,
    '“' => 0x27,
    '”' => 0x28,
    '（' => 0x29,
    '）' => 0x2a,
    '〔' => 0x2b,
    '〕' => 0x2c,
    '［' => 0x2d,
    '］' => 0x2e,
    '｛' => 0x2f,
    '｝' => 0x30,
    '〈' => 0x31,
    '〉' => 0x32,
    '《' => 0x33,
    '》' => 0x34,
    '「' => 0x35,
    '」' => 0x36,
    '『' => 0x37,
    '』' => 0x38,
    '【' => 0x39,
    '】' => 0x3a,
    '＋' => 0x3b,
    '−' => 0x3c,
    '±' => 0x3d,
    '×' => 0x3e,
    '÷' => 0x40,
    '＝' => 0x41,
    '≠' => 0x42,
    '＜' => 0x43,
    '＞' => 0x44,
    '≦' => 0x45,
    '≧' => 0x46,
    '∞' => 0x47,
    '∴' => 0x48,
    '♂' => 0x49,
    '♀' => 0x4a,
    '°' => 0x4b,
    '′' => 0x4c,
    '″' => 0x4d,
    '℃' => 0x4e,
    '￥' => 0x4f,
    '＄' => 0x50,
    '¢' => 0x51,
    '£' => 0x52,
    '％' => 0x53,
    '＃' => 0x54,
    '＆' => 0x55,
    '＊' => 0x56,
    '＠' => 0x57,
    '§' => 0x58,
    '☆' => 0x59,
    '★' => 0x5a,
    '○' => 0x5b,
    '●' => 0x5c,
    '◎' => 0x5d,
    '◇' => 0x5e,
    '◆' => 0x5f,
    '□' => 0x60,
    '■' => 0x61,
    '△' => 0x62,
    '▲' => 0x63,
    '▽' => 0x64,
    '▼' => 0x65,
    '※' => 0x66,
    '〒' => 0x67,
    '→' => 0x68,
    '←' => 0x69,
    '↑' => 0x6a,
    '↓' => 0x6b,
    '〓' => 0x6c,
    '∈' => 0x78,
    '∋' => 0x79,
    '⊆' => 0x7a,
    '⊇' => 0x7b,
    '⊂' => 0x7c,
    '⊃' => 0x7d,
    '∪' => 0x7e,
    '∩' => 0x7f,
    '∧' => 0x88,
    '∨' => 0x89,
    '¬' => 0x8a,
    '⇒' => 0x8b,
    '⇔' => 0x8c,
    '∀' => 0x8d,
    '∃' => 0x8e,
    '∠' => 0x9a,
    '⊥' => 0x9b,
    '⌒' => 0x9c,
    '∂' => 0x9d,
    '∇' => 0x9e,
    '≡' => 0x9f,
    '≒' => 0xa0,
    '≪' => 0xa1,
    '≫' => 0xa2,
    '√' => 0xa3,
    '∽' => 0xa4,
    '∝' => 0xa5,
    '∵' => 0xa6,
    '∫' => 0xa7,
    '∬' => 0xa8,
    'Å' => 0xb0,
    '‰' => 0xb1,
    '♯' => 0xb2,
    '♭' => 0xb3,
    '♪' => 0xb4,
    '†' => 0xb5,
    '‡' => 0xb6,
    '¶' => 0xb7,
    '◯' => 0xbc,
    '０' => 0xcf,
    '１' => 0xd0,
    '２' => 0xd1,
    '３' => 0xd2,
    '４' => 0xd3,
    '５' => 0xd4,
    '６' => 0xd5,
    '７' => 0xd6,
    '８' => 0xd7,
    '９' => 0xd8,
    'Ａ' => 0xe0,
    'Ｂ' => 0xe1,
    'Ｃ' => 0xe2,
    'Ｄ' => 0xe3,
    'Ｅ' => 0xe4,
    'Ｆ' => 0xe5,
    'Ｇ' => 0xe6,
    'Ｈ' => 0xe7,
    'Ｉ' => 0xe8,
    'Ｊ' => 0xe9,
    'Ｋ' => 0xea,
    'Ｌ' => 0xeb,
    'Ｍ' => 0xec,
    'Ｎ' => 0xed,
    'Ｏ' => 0xee,
    'Ｐ' => 0xef,
    'Ｑ' => 0xf0,
    'Ｒ' => 0xf1,
    'Ｓ' => 0xf2,
    'Ｔ' => 0xf3,
    'Ｕ' => 0xf4,
    'Ｖ' => 0xf5,
    'Ｗ' => 0xf6,
    'Ｘ' => 0xf7,
    'Ｙ' => 0xf8,
    'Ｚ' => 0xf9,
    'ａ' => 0x101,
    'ｂ' => 0x102,
    'ｃ' => 0x103,
    'ｄ' => 0x104,
    'ｅ' => 0x105,
    'ｆ' => 0x106,
    'ｇ' => 0x107,
    'ｈ' => 0x108,
    'ｉ' => 0x109,
    'ｊ' => 0x10a,
    'ｋ' => 0x10b,
    'ｌ' => 0x10c,
    'ｍ' => 0x10d,
    'ｎ' => 0x10e,
    'ｏ' => 0x10f,
    'ｐ' => 0x110,
    'ｑ' => 0x111,
    'ｒ' => 0x112,
    'ｓ' => 0x113,
    'ｔ' => 0x114,
    'ｕ' => 0x115,
    'ｖ' => 0x116,
    'ｗ' => 0x117,
    'ｘ' => 0x118,
    'ｙ' => 0x119,
    'ｚ' => 0x11a,
    'ぁ' => 0x11f,
    'あ' => 0x120,
    'ぃ' => 0x121,
    'い' => 0x122,
    'ぅ' => 0x123,
    'う' => 0x124,
    'ぇ' => 0x125,
    'え' => 0x126,
    'ぉ' => 0x127,
    'お' => 0x128,
    'か' => 0x129,
    'が' => 0x12a,
    'き' => 0x12b,
    'ぎ' => 0x12c,
    'く' => 0x12d,
    'ぐ' => 0x12e,
    'け' => 0x12f,
    'げ' => 0x130,
    'こ' => 0x131,
    'ご' => 0x132,
    'さ' => 0x133,
    'ざ' => 0x134,
    'し' => 0x135,
    'じ' => 0x136,
    'す' => 0x137,
    'ず' => 0x138,
    'せ' => 0x139,
    'ぜ' => 0x13a,
    'そ' => 0x13b,
    'ぞ' => 0x13c,
    'た' => 0x13d,
    'だ' => 0x13e,
    'ち' => 0x13f,
    'ぢ' => 0x140,
    'っ' => 0x141,
    'つ' => 0x142,
    'づ' => 0x143,
    'て' => 0x144,
    'で' => 0x145,
    'と' => 0x146,
    'ど' => 0x147,
    'な' => 0x148,
    'に' => 0x149,
    'ぬ' => 0x14a,
    'ね' => 0x14b,
    'の' => 0x14c,
    'は' => 0x14d,
    'ば' => 0x14e,
    'ぱ' => 0x14f,
    'ひ' => 0x150,
    'び' => 0x151,
    'ぴ' => 0x152,
    'ふ' => 0x153,
    'ぶ' => 0x154,
    'ぷ' => 0x155,
    'へ' => 0x156,
    'べ' => 0x157,
    'ぺ' => 0x158,
    'ほ' => 0x159,
    'ぼ' => 0x15a,
    'ぽ' => 0x15b,
    'ま' => 0x15c,
    'み' => 0x15d,
    'む' => 0x15e,
    'め' => 0x15f,
    'も' => 0x160,
    'ゃ' => 0x161,
    'や' => 0x162,
    'ゅ' => 0x163,
    'ゆ' => 0x164,
    'ょ' => 0x165,
    'よ' => 0x166,
    'ら' => 0x167,
    'り' => 0x168,
    'る' => 0x169,
    'れ' => 0x16a,
    'ろ' => 0x16b,
    'ゎ' => 0x16c,
    'わ' => 0x16d,
    'ゐ' => 0x16e,
    'ゑ' => 0x16f,
    'を' => 0x170,
    'ん' => 0x171,
    'ァ' => 0x180,
    'ア' => 0x181,
    'ィ' => 0x182,
    'イ' => 0x183,
    'ゥ' => 0x184,
    'ウ' => 0x185,
    'ェ' => 0x186,
    'エ' => 0x187,
    'ォ' => 0x188,
    'オ' => 0x189,
    'カ' => 0x18a,
    'ガ' => 0x18b,
    'キ' => 0x18c,
    'ギ' => 0x18d,
    'ク' => 0x18e,
    'グ' => 0x18f,
    'ケ' => 0x190,
    'ゲ' => 0x191,
    'コ' => 0x192,
    'ゴ' => 0x193,
    'サ' => 0x194,
    'ザ' => 0x195,
    'シ' => 0x196,
    'ジ' => 0x197,
    'ス' => 0x198,
    'ズ' => 0x199,
    'セ' => 0x19a,
    'ゼ' => 0x19b,
    'ソ' => 0x19c,
    'ゾ' => 0x19d,
    'タ' => 0x19e,
    'ダ' => 0x19f,
    'チ' => 0x1a0,
    'ヂ' => 0x1a1,
    'ッ' => 0x1a2,
    'ツ' => 0x1a3,
    'ヅ' => 0x1a4,
    'テ' => 0x1a5,
    'デ' => 0x1a6,
    'ト' => 0x1a7,
    'ド' => 0x1a8,
    'ナ' => 0x1a9,
    'ニ' => 0x1aa,
    'ヌ' => 0x1ab,
    'ネ' => 0x1ac,
    'ノ' => 0x1ad,
    'ハ' => 0x1ae,
    'バ' => 0x1af,
    'パ' => 0x1b0,
    'ヒ' => 0x1b1,
    'ビ' => 0x1b2,
    'ピ' => 0x1b3,
    'フ' => 0x1b4,
    'ブ' => 0x1b5,
    'プ' => 0x1b6,
    'ヘ' => 0x1b7,
    'ベ' => 0x1b8,
    'ペ' => 0x1b9,
    'ホ' => 0x1ba,
    'ボ' => 0x1bb,
    'ポ' => 0x1bc,
    'マ' => 0x1bd,
    'ミ' => 0x1be,
    'ム' => 0x1c0,
    'メ' => 0x1c1,
    'モ' => 0x1c2,
    'ャ' => 0x1c3,
    'ヤ' => 0x1c4,
    'ュ' => 0x1c5,
    'ユ' => 0x1c6,
    'ョ' => 0x1c7,
    'ヨ' => 0x1c8,
    'ラ' => 0x1c9,
    'リ' => 0x1ca,
    'ル' => 0x1cb,
    'レ' => 0x1cc,
    'ロ' => 0x1cd,
    'ヮ' => 0x1ce,
    'ワ' => 0x1cf,
    'ヰ' => 0x1d0,
    'ヱ' => 0x1d1,
    'ヲ' => 0x1d2,
    'ン' => 0x1d3,
    'ヴ' => 0x1d4,
    'ヵ' => 0x1d5,
    'ヶ' => 0x1d6,
    'Α' => 0x1df,
    'Β' => 0x1e0,
    'Γ' => 0x1e1,
    'Δ' => 0x1e2,
    'Ε' => 0x1e3,
    'Ζ' => 0x1e4,
    'Η' => 0x1e5,
    'Θ' => 0x1e6,
    'Ι' => 0x1e7,
    'Κ' => 0x1e8,
    'Λ' => 0x1e9,
    'Μ' => 0x1ea,
    'Ν' => 0x1eb,
    'Ξ' => 0x1ec,
    'Ο' => 0x1ed,
    'Π' => 0x1ee,
    'Ρ' => 0x1ef,
    'Σ' => 0x1f0,
    'Τ' => 0x1f1,
    'Υ' => 0x1f2,
    'Φ' => 0x1f3,
    'Χ' => 0x1f4,
    'Ψ' => 0x1f5,
    'Ω' => 0x1f6,
    'α' => 0x1ff,
    'β' => 0x200,
    'γ' => 0x201,
    'δ' => 0x202,
    'ε' => 0x203,
    'ζ' => 0x204,
    'η' => 0x205,
    'θ' => 0x206,
    'ι' => 0x207,
    'κ' => 0x208,
    'λ' => 0x209,
    'μ' => 0x20a,
    'ν' => 0x20b,
    'ξ' => 0x20c,
    'ο' => 0x20d,
    'π' => 0x20e,
    'ρ' => 0x20f,
    'σ' => 0x210,
    'τ' => 0x211,
    'υ' => 0x212,
    'φ' => 0x213,
    'χ' => 0x214,
    'ψ' => 0x215,
    'ω' => 0x216,
    'А' => 0x240,
    'Б' => 0x241,
    'В' => 0x242,
    'Г' => 0x243,
    'Д' => 0x244,
    'Е' => 0x245,
    'Ё' => 0x246,
    'Ж' => 0x247,
    'З' => 0x248,
    'И' => 0x249,
    'Й' => 0x24a,
    'К' => 0x24b,
    'Л' => 0x24c,
    'М' => 0x24d,
    'Н' => 0x24e,
    'О' => 0x24f,
    'П' => 0x250,
    'Р' => 0x251,
    'С' => 0x252,
    'Т' => 0x253,
    'У' => 0x254,
    'Ф' => 0x255,
    'Х' => 0x256,
    'Ц' => 0x257,
    'Ч' => 0x258,
    'Ш' => 0x259,
    'Щ' => 0x25a,
    'Ъ' => 0x25b,
    'Ы' => 0x25c,
    'Ь' => 0x25d,
    'Э' => 0x25e,
    'Ю' => 0x25f,
    'Я' => 0x260,
    'а' => 0x270,
    'б' => 0x271,
    'в' => 0x272,
    'г' => 0x273,
    'д' => 0x274,
    'е' => 0x275,
    'ё' => 0x276,
    'ж' => 0x277,
    'з' => 0x278,
    'и' => 0x279,
    'й' => 0x27a,
    'к' => 0x27b,
    'л' => 0x27c,
    'м' => 0x27d,
    'н' => 0x27e,
    'о' => 0x280,
    'п' => 0x281,
    'р' => 0x282,
    'с' => 0x283,
    'т' => 0x284,
    'у' => 0x285,
    'ф' => 0x286,
    'х' => 0x287,
    'ц' => 0x288,
    'ч' => 0x289,
    'ш' => 0x28a,
    'щ' => 0x28b,
    'ъ' => 0x28c,
    'ы' => 0x28d,
    'ь' => 0x28e,
    'э' => 0x28f,
    'ю' => 0x290,
    'я' => 0x291,
    '─' => 0x29f,
    '│' => 0x2a0,
    '┌' => 0x2a1,
    '┐' => 0x2a2,
    '┘' => 0x2a3,
    '└' => 0x2a4,
    '├' => 0x2a5,
    '┬' => 0x2a6,
    '┤' => 0x2a7,
    '┴' => 0x2a8,
    '┼' => 0x2a9,
    '━' => 0x2aa,
    '┃' => 0x2ab,
    '┏' => 0x2ac,
    '┓' => 0x2ad,
    '┛' => 0x2ae,
    '┗' => 0x2af,
    '┣' => 0x2b0,
    '┳' => 0x2b1,
    '┫' => 0x2b2,
    '┻' => 0x2b3,
    '╋' => 0x2b4,
    '┠' => 0x2b5,
    '┯' => 0x2b6,
    '┨' => 0x2b7,
    '┷' => 0x2b8,
    '┿' => 0x2b9,
    '┝' => 0x2ba,
    '┰' => 0x2bb,
    '┥' => 0x2bc,
    '┸' => 0x2bd,
    '╂' => 0x2be,
    '①' => 0x480,
    '②' => 0x481,
    '③' => 0x482,
    '④' => 0x483,
    '⑤' => 0x484,
    '⑥' => 0x485,
    '⑦' => 0x486,
    '⑧' => 0x487,
    '⑨' => 0x488,
    '⑩' => 0x489,
    '⑪' => 0x48a,
    '⑫' => 0x48b,
    '⑬' => 0x48c,
    '⑭' => 0x48d,
    '⑮' => 0x48e,
    '⑯' => 0x48f,
    '⑰' => 0x490,
    '⑱' => 0x491,
    '⑲' => 0x492,
    '⑳' => 0x493,
    'Ⅰ' => 0x494,
    'Ⅱ' => 0x495,
    'Ⅲ' => 0x496,
    'Ⅳ' => 0x497,
    'Ⅴ' => 0x498,
    'Ⅵ' => 0x499,
    'Ⅶ' => 0x49a,
    'Ⅷ' => 0x49b,
    'Ⅸ' => 0x49c,
    'Ⅹ' => 0x49d,
    '㍉' => 0x49f,
    '㌔' => 0x4a0,
    '㌢' => 0x4a1,
    '㍍' => 0x4a2,
    '㌘' => 0x4a3,
    '㌧' => 0x4a4,
    '㌃' => 0x4a5,
    '㌶' => 0x4a6,
    '㍑' => 0x4a7,
    '㍗' => 0x4a8,
    '㌍' => 0x4a9,
    '㌦' => 0x4aa,
    '㌣' => 0x4ab,
    '㌫' => 0x4ac,
    '㍊' => 0x4ad,
    '㌻' => 0x4ae,
    '㎜' => 0x4af,
    '㎝' => 0x4b0,
    '㎞' => 0x4b1,
    '㎎' => 0x4b2,
    '㎏' => 0x4b3,
    '㏄' => 0x4b4,
    '㎡' => 0x4b5,
    '㍻' => 0x4bf,
    '亜' => 0x59f,
    '唖' => 0x5a0,
    '娃' => 0x5a1,
    '阿' => 0x5a2,
    '哀' => 0x5a3,
    '愛' => 0x5a4,
    '挨' => 0x5a5,
    '姶' => 0x5a6,
    '逢' => 0x5a7,
    '葵' => 0x5a8,
    '茜' => 0x5a9,
    '穐' => 0x5aa,
    '悪' => 0x5ab,
    '握' => 0x5ac,
    '渥' => 0x5ad,
    '旭' => 0x5ae,
    '葦' => 0x5af,
    '芦' => 0x5b0,
    '鯵' => 0x5b1,
    '梓' => 0x5b2,
    '圧' => 0x5b3,
    '斡' => 0x5b4,
    '扱' => 0x5b5,
    '宛' => 0x5b6,
    '姐' => 0x5b7,
    '虻' => 0x5b8,
    '飴' => 0x5b9,
    '絢' => 0x5ba,
    '綾' => 0x5bb,
    '鮎' => 0x5bc,
    '或' => 0x5bd,
    '粟' => 0x5be,
    '袷' => 0x5bf,
    '安' => 0x5c0,
    '庵' => 0x5c1,
    '按' => 0x5c2,
    '暗' => 0x5c3,
    '案' => 0x5c4,
    '闇' => 0x5c5,
    '鞍' => 0x5c6,
    '杏' => 0x5c7,
    '以' => 0x5c8,
    '伊' => 0x5c9,
    '位' => 0x5ca,
    '依' => 0x5cb,
    '偉' => 0x5cc,
    '囲' => 0x5cd,
    '夷' => 0x5ce,
    '委' => 0x5cf,
    '威' => 0x5d0,
    '尉' => 0x5d1,
    '惟' => 0x5d2,
    '意' => 0x5d3,
    '慰' => 0x5d4,
    '易' => 0x5d5,
    '椅' => 0x5d6,
    '為' => 0x5d7,
    '畏' => 0x5d8,
    '異' => 0x5d9,
    '移' => 0x5da,
    '維' => 0x5db,
    '緯' => 0x5dc,
    '胃' => 0x5dd,
    '萎' => 0x5de,
    '衣' => 0x5df,
    '謂' => 0x5e0,
    '違' => 0x5e1,
    '遺' => 0x5e2,
    '医' => 0x5e3,
    '井' => 0x5e4,
    '亥' => 0x5e5,
    '域' => 0x5e6,
    '育' => 0x5e7,
    '郁' => 0x5e8,
    '磯' => 0x5e9,
    '一' => 0x5ea,
    '壱' => 0x5eb,
    '溢' => 0x5ec,
    '逸' => 0x5ed,
    '稲' => 0x5ee,
    '茨' => 0x5ef,
    '芋' => 0x5f0,
    '鰯' => 0x5f1,
    '允' => 0x5f2,
    '印' => 0x5f3,
    '咽' => 0x5f4,
    '員' => 0x5f5,
    '因' => 0x5f6,
    '姻' => 0x5f7,
    '引' => 0x5f8,
    '飲' => 0x5f9,
    '淫' => 0x5fa,
    '胤' => 0x5fb,
    '蔭' => 0x5fc,
    '院' => 0x600,
    '陰' => 0x601,
    '隠' => 0x602,
    '韻' => 0x603,
    '吋' => 0x604,
    '右' => 0x605,
    '宇' => 0x606,
    '烏' => 0x607,
    '羽' => 0x608,
    '迂' => 0x609,
    '雨' => 0x60a,
    '卯' => 0x60b,
    '鵜' => 0x60c,
    '窺' => 0x60d,
    '丑' => 0x60e,
    '碓' => 0x60f,
    '臼' => 0x610,
    '渦' => 0x611,
    '嘘' => 0x612,
    '唄' => 0x613,
    '欝' => 0x614,
    '蔚' => 0x615,
    '鰻' => 0x616,
    '姥' => 0x617,
    '厩' => 0x618,
    '浦' => 0x619,
    '瓜' => 0x61a,
    '閏' => 0x61b,
    '噂' => 0x61c,
    '云' => 0x61d,
    '運' => 0x61e,
    '雲' => 0x61f,
    '荏' => 0x620,
    '餌' => 0x621,
    '叡' => 0x622,
    '営' => 0x623,
    '嬰' => 0x624,
    '影' => 0x625,
    '映' => 0x626,
    '曳' => 0x627,
    '栄' => 0x628,
    '永' => 0x629,
    '泳' => 0x62a,
    '洩' => 0x62b,
    '瑛' => 0x62c,
    '盈' => 0x62d,
    '穎' => 0x62e,
    '頴' => 0x62f,
    '英' => 0x630,
    '衛' => 0x631,
    '詠' => 0x632,
    '鋭' => 0x633,
    '液' => 0x634,
    '疫' => 0x635,
    '益' => 0x636,
    '駅' => 0x637,
    '悦' => 0x638,
    '謁' => 0x639,
    '越' => 0x63a,
    '閲' => 0x63b,
    '榎' => 0x63c,
    '厭' => 0x63d,
    '円' => 0x63e,
    '園' => 0x640,
    '堰' => 0x641,
    '奄' => 0x642,
    '宴' => 0x643,
    '延' => 0x644,
    '怨' => 0x645,
    '掩' => 0x646,
    '援' => 0x647,
    '沿' => 0x648,
    '演' => 0x649,
    '炎' => 0x64a,
    '焔' => 0x64b,
    '煙' => 0x64c,
    '燕' => 0x64d,
    '猿' => 0x64e,
    '縁' => 0x64f,
    '艶' => 0x650,
    '苑' => 0x651,
    '薗' => 0x652,
    '遠' => 0x653,
    '鉛' => 0x654,
    '鴛' => 0x655,
    '塩' => 0x656,
    '於' => 0x657,
    '汚' => 0x658,
    '甥' => 0x659,
    '凹' => 0x65a,
    '央' => 0x65b,
    '奥' => 0x65c,
    '往' => 0x65d,
    '応' => 0x65e,
    '押' => 0x65f,
    '旺' => 0x660,
    '横' => 0x661,
    '欧' => 0x662,
    '殴' => 0x663,
    '王' => 0x664,
    '翁' => 0x665,
    '襖' => 0x666,
    '鴬' => 0x667,
    '鴎' => 0x668,
    '黄' => 0x669,
    '岡' => 0x66a,
    '沖' => 0x66b,
    '荻' => 0x66c,
    '億' => 0x66d,
    '屋' => 0x66e,
    '憶' => 0x66f,
    '臆' => 0x670,
    '桶' => 0x671,
    '牡' => 0x672,
    '乙' => 0x673,
    '俺' => 0x674,
    '卸' => 0x675,
    '恩' => 0x676,
    '温' => 0x677,
    '穏' => 0x678,
    '音' => 0x679,
    '下' => 0x67a,
    '化' => 0x67b,
    '仮' => 0x67c,
    '何' => 0x67d,
    '伽' => 0x67e,
    '価' => 0x67f,
    '佳' => 0x680,
    '加' => 0x681,
    '可' => 0x682,
    '嘉' => 0x683,
    '夏' => 0x684,
    '嫁' => 0x685,
    '家' => 0x686,
    '寡' => 0x687,
    '科' => 0x688,
    '暇' => 0x689,
    '果' => 0x68a,
    '架' => 0x68b,
    '歌' => 0x68c,
    '河' => 0x68d,
    '火' => 0x68e,
    '珂' => 0x68f,
    '禍' => 0x690,
    '禾' => 0x691,
    '稼' => 0x692,
    '箇' => 0x693,
    '花' => 0x694,
    '苛' => 0x695,
    '茄' => 0x696,
    '荷' => 0x697,
    '華' => 0x698,
    '菓' => 0x699,
    '蝦' => 0x69a,
    '課' => 0x69b,
    '嘩' => 0x69c,
    '貨' => 0x69d,
    '迦' => 0x69e,
    '過' => 0x69f,
    '霞' => 0x6a0,
    '蚊' => 0x6a1,
    '俄' => 0x6a2,
    '峨' => 0x6a3,
    '我' => 0x6a4,
    '牙' => 0x6a5,
    '画' => 0x6a6,
    '臥' => 0x6a7,
    '芽' => 0x6a8,
    '蛾' => 0x6a9,
    '賀' => 0x6aa,
    '雅' => 0x6ab,
    '餓' => 0x6ac,
    '駕' => 0x6ad,
    '介' => 0x6ae,
    '会' => 0x6af,
    '解' => 0x6b0,
    '回' => 0x6b1,
    '塊' => 0x6b2,
    '壊' => 0x6b3,
    '廻' => 0x6b4,
    '快' => 0x6b5,
    '怪' => 0x6b6,
    '悔' => 0x6b7,
    '恢' => 0x6b8,
    '懐' => 0x6b9,
    '戒' => 0x6ba,
    '拐' => 0x6bb,
    '改' => 0x6bc,
    '魁' => 0x6c0,
    '晦' => 0x6c1,
    '械' => 0x6c2,
    '海' => 0x6c3,
    '灰' => 0x6c4,
    '界' => 0x6c5,
    '皆' => 0x6c6,
    '絵' => 0x6c7,
    '芥' => 0x6c8,
    '蟹' => 0x6c9,
    '開' => 0x6ca,
    '階' => 0x6cb,
    '貝' => 0x6cc,
    '凱' => 0x6cd,
    '劾' => 0x6ce,
    '外' => 0x6cf,
    '咳' => 0x6d0,
    '害' => 0x6d1,
    '崖' => 0x6d2,
    '慨' => 0x6d3,
    '概' => 0x6d4,
    '涯' => 0x6d5,
    '碍' => 0x6d6,
    '蓋' => 0x6d7,
    '街' => 0x6d8,
    '該' => 0x6d9,
    '鎧' => 0x6da,
    '骸' => 0x6db,
    '浬' => 0x6dc,
    '馨' => 0x6dd,
    '蛙' => 0x6de,
    '垣' => 0x6df,
    '柿' => 0x6e0,
    '蛎' => 0x6e1,
    '鈎' => 0x6e2,
    '劃' => 0x6e3,
    '嚇' => 0x6e4,
    '各' => 0x6e5,
    '廓' => 0x6e6,
    '拡' => 0x6e7,
    '撹' => 0x6e8,
    '格' => 0x6e9,
    '核' => 0x6ea,
    '殻' => 0x6eb,
    '獲' => 0x6ec,
    '確' => 0x6ed,
    '穫' => 0x6ee,
    '覚' => 0x6ef,
    '角' => 0x6f0,
    '赫' => 0x6f1,
    '較' => 0x6f2,
    '郭' => 0x6f3,
    '閣' => 0x6f4,
    '隔' => 0x6f5,
    '革' => 0x6f6,
    '学' => 0x6f7,
    '岳' => 0x6f8,
    '楽' => 0x6f9,
    '額' => 0x6fa,
    '顎' => 0x6fb,
    '掛' => 0x6fc,
    '笠' => 0x6fd,
    '樫' => 0x6fe,
    '橿' => 0x700,
    '梶' => 0x701,
    '鰍' => 0x702,
    '潟' => 0x703,
    '割' => 0x704,
    '喝' => 0x705,
    '恰' => 0x706,
    '括' => 0x707,
    '活' => 0x708,
    '渇' => 0x709,
    '滑' => 0x70a,
    '葛' => 0x70b,
    '褐' => 0x70c,
    '轄' => 0x70d,
    '且' => 0x70e,
    '鰹' => 0x70f,
    '叶' => 0x710,
    '椛' => 0x711,
    '樺' => 0x712,
    '鞄' => 0x713,
    '株' => 0x714,
    '兜' => 0x715,
    '竃' => 0x716,
    '蒲' => 0x717,
    '釜' => 0x718,
    '鎌' => 0x719,
    '噛' => 0x71a,
    '鴨' => 0x71b,
    '栢' => 0x71c,
    '茅' => 0x71d,
    '萱' => 0x71e,
    '粥' => 0x71f,
    '刈' => 0x720,
    '苅' => 0x721,
    '瓦' => 0x722,
    '乾' => 0x723,
    '侃' => 0x724,
    '冠' => 0x725,
    '寒' => 0x726,
    '刊' => 0x727,
    '勘' => 0x728,
    '勧' => 0x729,
    '巻' => 0x72a,
    '喚' => 0x72b,
    '堪' => 0x72c,
    '姦' => 0x72d,
    '完' => 0x72e,
    '官' => 0x72f,
    '寛' => 0x730,
    '干' => 0x731,
    '幹' => 0x732,
    '患' => 0x733,
    '感' => 0x734,
    '慣' => 0x735,
    '憾' => 0x736,
    '換' => 0x737,
    '敢' => 0x738,
    '柑' => 0x739,
    '桓' => 0x73a,
    '棺' => 0x73b,
    '款' => 0x73c,
    '歓' => 0x73d,
    '汗' => 0x73e,
    '漢' => 0x73f,
    '澗' => 0x740,
    '潅' => 0x741,
    '環' => 0x742,
    '甘' => 0x743,
    '監' => 0x744,
    '看' => 0x745,
    '竿' => 0x746,
    '管' => 0x747,
    '簡' => 0x748,
    '緩' => 0x749,
    '缶' => 0x74a,
    '翰' => 0x74b,
    '肝' => 0x74c,
    '艦' => 0x74d,
    '莞' => 0x74e,
    '観' => 0x74f,
    '諌' => 0x750,
    '貫' => 0x751,
    '還' => 0x752,
    '鑑' => 0x753,
    '間' => 0x754,
    '閑' => 0x755,
    '関' => 0x756,
    '陥' => 0x757,
    '韓' => 0x758,
    '館' => 0x759,
    '舘' => 0x75a,
    '丸' => 0x75b,
    '含' => 0x75c,
    '岸' => 0x75d,
    '巌' => 0x75e,
    '玩' => 0x75f,
    '癌' => 0x760,
    '眼' => 0x761,
    '岩' => 0x762,
    '翫' => 0x763,
    '贋' => 0x764,
    '雁' => 0x765,
    '頑' => 0x766,
    '顔' => 0x767,
    '願' => 0x768,
    '企' => 0x769,
    '伎' => 0x76a,
    '危' => 0x76b,
    '喜' => 0x76c,
    '器' => 0x76d,
    '基' => 0x76e,
    '奇' => 0x76f,
    '嬉' => 0x770,
    '寄' => 0x771,
    '岐' => 0x772,
    '希' => 0x773,
    '幾' => 0x774,
    '忌' => 0x775,
    '揮' => 0x776,
    '机' => 0x777,
    '旗' => 0x778,
    '既' => 0x779,
    '期' => 0x77a,
    '棋' => 0x77b,
    '棄' => 0x77c,
    '機' => 0x780,
    '帰' => 0x781,
    '毅' => 0x782,
    '気' => 0x783,
    '汽' => 0x784,
    '畿' => 0x785,
    '祈' => 0x786,
    '季' => 0x787,
    '稀' => 0x788,
    '紀' => 0x789,
    '徽' => 0x78a,
    '規' => 0x78b,
    '記' => 0x78c,
    '貴' => 0x78d,
    '起' => 0x78e,
    '軌' => 0x78f,
    '輝' => 0x790,
    '飢' => 0x791,
    '騎' => 0x792,
    '鬼' => 0x793,
    '亀' => 0x794,
    '偽' => 0x795,
    '儀' => 0x796,
    '妓' => 0x797,
    '宜' => 0x798,
    '戯' => 0x799,
    '技' => 0x79a,
    '擬' => 0x79b,
    '欺' => 0x79c,
    '犠' => 0x79d,
    '疑' => 0x79e,
    '祇' => 0x79f,
    '義' => 0x7a0,
    '蟻' => 0x7a1,
    '誼' => 0x7a2,
    '議' => 0x7a3,
    '掬' => 0x7a4,
    '菊' => 0x7a5,
    '鞠' => 0x7a6,
    '吉' => 0x7a7,
    '吃' => 0x7a8,
    '喫' => 0x7a9,
    '桔' => 0x7aa,
    '橘' => 0x7ab,
    '詰' => 0x7ac,
    '砧' => 0x7ad,
    '杵' => 0x7ae,
    '黍' => 0x7af,
    '却' => 0x7b0,
    '客' => 0x7b1,
    '脚' => 0x7b2,
    '虐' => 0x7b3,
    '逆' => 0x7b4,
    '丘' => 0x7b5,
    '久' => 0x7b6,
    '仇' => 0x7b7,
    '休' => 0x7b8,
    '及' => 0x7b9,
    '吸' => 0x7ba,
    '宮' => 0x7bb,
    '弓' => 0x7bc,
    '急' => 0x7bd,
    '救' => 0x7be,
    '朽' => 0x7c0,
    '求' => 0x7c1,
    '汲' => 0x7c2,
    '泣' => 0x7c3,
    '灸' => 0x7c4,
    '球' => 0x7c5,
    '究' => 0x7c6,
    '窮' => 0x7c7,
    '笈' => 0x7c8,
    '級' => 0x7c9,
    '糾' => 0x7ca,
    '給' => 0x7cb,
    '旧' => 0x7cc,
    '牛' => 0x7cd,
    '去' => 0x7ce,
    '居' => 0x7cf,
    '巨' => 0x7d0,
    '拒' => 0x7d1,
    '拠' => 0x7d2,
    '挙' => 0x7d3,
    '渠' => 0x7d4,
    '虚' => 0x7d5,
    '許' => 0x7d6,
    '距' => 0x7d7,
    '鋸' => 0x7d8,
    '漁' => 0x7d9,
    '禦' => 0x7da,
    '魚' => 0x7db,
    '亨' => 0x7dc,
    '享' => 0x7dd,
    '京' => 0x7de,
    '供' => 0x7df,
    '侠' => 0x7e0,
    '僑' => 0x7e1,
    '兇' => 0x7e2,
    '競' => 0x7e3,
    '共' => 0x7e4,
    '凶' => 0x7e5,
    '協' => 0x7e6,
    '匡' => 0x7e7,
    '卿' => 0x7e8,
    '叫' => 0x7e9,
    '喬' => 0x7ea,
    '境' => 0x7eb,
    '峡' => 0x7ec,
    '強' => 0x7ed,
    '彊' => 0x7ee,
    '怯' => 0x7ef,
    '恐' => 0x7f0,
    '恭' => 0x7f1,
    '挟' => 0x7f2,
    '教' => 0x7f3,
    '橋' => 0x7f4,
    '況' => 0x7f5,
    '狂' => 0x7f6,
    '狭' => 0x7f7,
    '矯' => 0x7f8,
    '胸' => 0x7f9,
    '脅' => 0x7fa,
    '興' => 0x7fb,
    '蕎' => 0x7fc,
    '郷' => 0x7fd,
    '鏡' => 0x7fe,
    '響' => 0x7ff,
    '饗' => 0x800,
    '驚' => 0x801,
    '仰' => 0x802,
    '凝' => 0x803,
    '尭' => 0x804,
    '暁' => 0x805,
    '業' => 0x806,
    '局' => 0x807,
    '曲' => 0x808,
    '極' => 0x809,
    '玉' => 0x80a,
    '桐' => 0x80b,
    '粁' => 0x80c,
    '僅' => 0x80d,
    '勤' => 0x80e,
    '均' => 0x80f,
    '巾' => 0x810,
    '錦' => 0x811,
    '斤' => 0x812,
    '欣' => 0x813,
    '欽' => 0x814,
    '琴' => 0x815,
    '禁' => 0x816,
    '禽' => 0x817,
    '筋' => 0x818,
    '緊' => 0x819,
    '芹' => 0x81a,
    '菌' => 0x81b,
    '衿' => 0x81c,
    '襟' => 0x81d,
    '謹' => 0x81e,
    '近' => 0x81f,
    '金' => 0x820,
    '吟' => 0x821,
    '銀' => 0x822,
    '九' => 0x823,
    '倶' => 0x824,
    '句' => 0x825,
    '区' => 0x826,
    '狗' => 0x827,
    '玖' => 0x828,
    '矩' => 0x829,
    '苦' => 0x82a,
    '躯' => 0x82b,
    '駆' => 0x82c,
    '駈' => 0x82d,
    '駒' => 0x82e,
    '具' => 0x82f,
    '愚' => 0x830,
    '虞' => 0x831,
    '喰' => 0x832,
    '空' => 0x833,
    '偶' => 0x834,
    '寓' => 0x835,
    '遇' => 0x836,
    '隅' => 0x837,
    '串' => 0x838,
    '櫛' => 0x839,
    '釧' => 0x83a,
    '屑' => 0x83b,
    '屈' => 0x83c,
    '掘' => 0x840,
    '窟' => 0x841,
    '沓' => 0x842,
    '靴' => 0x843,
    '轡' => 0x844,
    '窪' => 0x845,
    '熊' => 0x846,
    '隈' => 0x847,
    '粂' => 0x848,
    '栗' => 0x849,
    '繰' => 0x84a,
    '桑' => 0x84b,
    '鍬' => 0x84c,
    '勲' => 0x84d,
    '君' => 0x84e,
    '薫' => 0x84f,
    '訓' => 0x850,
    '群' => 0x851,
    '軍' => 0x852,
    '郡' => 0x853,
    '卦' => 0x854,
    '袈' => 0x855,
    '祁' => 0x856,
    '係' => 0x857,
    '傾' => 0x858,
    '刑' => 0x859,
    '兄' => 0x85a,
    '啓' => 0x85b,
    '圭' => 0x85c,
    '珪' => 0x85d,
    '型' => 0x85e,
    '契' => 0x85f,
    '形' => 0x860,
    '径' => 0x861,
    '恵' => 0x862,
    '慶' => 0x863,
    '慧' => 0x864,
    '憩' => 0x865,
    '掲' => 0x866,
    '携' => 0x867,
    '敬' => 0x868,
    '景' => 0x869,
    '桂' => 0x86a,
    '渓' => 0x86b,
    '畦' => 0x86c,
    '稽' => 0x86d,
    '系' => 0x86e,
    '経' => 0x86f,
    '継' => 0x870,
    '繋' => 0x871,
    '罫' => 0x872,
    '茎' => 0x873,
    '荊' => 0x874,
    '蛍' => 0x875,
    '計' => 0x876,
    '詣' => 0x877,
    '警' => 0x878,
    '軽' => 0x879,
    '頚' => 0x87a,
    '鶏' => 0x87b,
    '芸' => 0x87c,
    '迎' => 0x87d,
    '鯨' => 0x87e,
    '劇' => 0x880,
    '戟' => 0x881,
    '撃' => 0x882,
    '激' => 0x883,
    '隙' => 0x884,
    '桁' => 0x885,
    '傑' => 0x886,
    '欠' => 0x887,
    '決' => 0x888,
    '潔' => 0x889,
    '穴' => 0x88a,
    '結' => 0x88b,
    '血' => 0x88c,
    '訣' => 0x88d,
    '月' => 0x88e,
    '件' => 0x88f,
    '倹' => 0x890,
    '倦' => 0x891,
    '健' => 0x892,
    '兼' => 0x893,
    '券' => 0x894,
    '剣' => 0x895,
    '喧' => 0x896,
    '圏' => 0x897,
    '堅' => 0x898,
    '嫌' => 0x899,
    '建' => 0x89a,
    '憲' => 0x89b,
    '懸' => 0x89c,
    '拳' => 0x89d,
    '捲' => 0x89e,
    '検' => 0x89f,
    '権' => 0x8a0,
    '牽' => 0x8a1,
    '犬' => 0x8a2,
    '献' => 0x8a3,
    '研' => 0x8a4,
    '硯' => 0x8a5,
    '絹' => 0x8a6,
    '県' => 0x8a7,
    '肩' => 0x8a8,
    '見' => 0x8a9,
    '謙' => 0x8aa,
    '賢' => 0x8ab,
    '軒' => 0x8ac,
    '遣' => 0x8ad,
    '鍵' => 0x8ae,
    '険' => 0x8af,
    '顕' => 0x8b0,
    '験' => 0x8b1,
    '鹸' => 0x8b2,
    '元' => 0x8b3,
    '原' => 0x8b4,
    '厳' => 0x8b5,
    '幻' => 0x8b6,
    '弦' => 0x8b7,
    '減' => 0x8b8,
    '源' => 0x8b9,
    '玄' => 0x8ba,
    '現' => 0x8bb,
    '絃' => 0x8bc,
    '舷' => 0x8bd,
    '言' => 0x8be,
    '諺' => 0x8bf,
    '限' => 0x8c0,
    '乎' => 0x8c1,
    '個' => 0x8c2,
    '古' => 0x8c3,
    '呼' => 0x8c4,
    '固' => 0x8c5,
    '姑' => 0x8c6,
    '孤' => 0x8c7,
    '己' => 0x8c8,
    '庫' => 0x8c9,
    '弧' => 0x8ca,
    '戸' => 0x8cb,
    '故' => 0x8cc,
    '枯' => 0x8cd,
    '湖' => 0x8ce,
    '狐' => 0x8cf,
    '糊' => 0x8d0,
    '袴' => 0x8d1,
    '股' => 0x8d2,
    '胡' => 0x8d3,
    '菰' => 0x8d4,
    '虎' => 0x8d5,
    '誇' => 0x8d6,
    '跨' => 0x8d7,
    '鈷' => 0x8d8,
    '雇' => 0x8d9,
    '顧' => 0x8da,
    '鼓' => 0x8db,
    '五' => 0x8dc,
    '互' => 0x8dd,
    '伍' => 0x8de,
    '午' => 0x8df,
    '呉' => 0x8e0,
    '吾' => 0x8e1,
    '娯' => 0x8e2,
    '後' => 0x8e3,
    '御' => 0x8e4,
    '悟' => 0x8e5,
    '梧' => 0x8e6,
    '檎' => 0x8e7,
    '瑚' => 0x8e8,
    '碁' => 0x8e9,
    '語' => 0x8ea,
    '誤' => 0x8eb,
    '護' => 0x8ec,
    '醐' => 0x8ed,
    '乞' => 0x8ee,
    '鯉' => 0x8ef,
    '交' => 0x8f0,
    '佼' => 0x8f1,
    '侯' => 0x8f2,
    '候' => 0x8f3,
    '倖' => 0x8f4,
    '光' => 0x8f5,
    '公' => 0x8f6,
    '功' => 0x8f7,
    '効' => 0x8f8,
    '勾' => 0x8f9,
    '厚' => 0x8fa,
    '口' => 0x8fb,
    '向' => 0x8fc,
    '后' => 0x900,
    '喉' => 0x901,
    '坑' => 0x902,
    '垢' => 0x903,
    '好' => 0x904,
    '孔' => 0x905,
    '孝' => 0x906,
    '宏' => 0x907,
    '工' => 0x908,
    '巧' => 0x909,
    '巷' => 0x90a,
    '幸' => 0x90b,
    '広' => 0x90c,
    '庚' => 0x90d,
    '康' => 0x90e,
    '弘' => 0x90f,
    '恒' => 0x910,
    '慌' => 0x911,
    '抗' => 0x912,
    '拘' => 0x913,
    '控' => 0x914,
    '攻' => 0x915,
    '昂' => 0x916,
    '晃' => 0x917,
    '更' => 0x918,
    '杭' => 0x919,
    '校' => 0x91a,
    '梗' => 0x91b,
    '構' => 0x91c,
    '江' => 0x91d,
    '洪' => 0x91e,
    '浩' => 0x91f,
    '港' => 0x920,
    '溝' => 0x921,
    '甲' => 0x922,
    '皇' => 0x923,
    '硬' => 0x924,
    '稿' => 0x925,
    '糠' => 0x926,
    '紅' => 0x927,
    '紘' => 0x928,
    '絞' => 0x929,
    '綱' => 0x92a,
    '耕' => 0x92b,
    '考' => 0x92c,
    '肯' => 0x92d,
    '肱' => 0x92e,
    '腔' => 0x92f,
    '膏' => 0x930,
    '航' => 0x931,
    '荒' => 0x932,
    '行' => 0x933,
    '衡' => 0x934,
    '講' => 0x935,
    '貢' => 0x936,
    '購' => 0x937,
    '郊' => 0x938,
    '酵' => 0x939,
    '鉱' => 0x93a,
    '砿' => 0x93b,
    '鋼' => 0x93c,
    '閤' => 0x93d,
    '降' => 0x93e,
    '項' => 0x940,
    '香' => 0x941,
    '高' => 0x942,
    '鴻' => 0x943,
    '剛' => 0x944,
    '劫' => 0x945,
    '号' => 0x946,
    '合' => 0x947,
    '壕' => 0x948,
    '拷' => 0x949,
    '濠' => 0x94a,
    '豪' => 0x94b,
    '轟' => 0x94c,
    '麹' => 0x94d,
    '克' => 0x94e,
    '刻' => 0x94f,
    '告' => 0x950,
    '国' => 0x951,
    '穀' => 0x952,
    '酷' => 0x953,
    '鵠' => 0x954,
    '黒' => 0x955,
    '獄' => 0x956,
    '漉' => 0x957,
    '腰' => 0x958,
    '甑' => 0x959,
    '忽' => 0x95a,
    '惚' => 0x95b,
    '骨' => 0x95c,
    '狛' => 0x95d,
    '込' => 0x95e,
    '此' => 0x95f,
    '頃' => 0x960,
    '今' => 0x961,
    '困' => 0x962,
    '坤' => 0x963,
    '墾' => 0x964,
    '婚' => 0x965,
    '恨' => 0x966,
    '懇' => 0x967,
    '昏' => 0x968,
    '昆' => 0x969,
    '根' => 0x96a,
    '梱' => 0x96b,
    '混' => 0x96c,
    '痕' => 0x96d,
    '紺' => 0x96e,
    '艮' => 0x96f,
    '魂' => 0x970,
    '些' => 0x971,
    '佐' => 0x972,
    '叉' => 0x973,
    '唆' => 0x974,
    '嵯' => 0x975,
    '左' => 0x976,
    '差' => 0x977,
    '査' => 0x978,
    '沙' => 0x979,
    '瑳' => 0x97a,
    '砂' => 0x97b,
    '詐' => 0x97c,
    '鎖' => 0x97d,
    '裟' => 0x97e,
    '坐' => 0x97f,
    '座' => 0x980,
    '挫' => 0x981,
    '債' => 0x982,
    '催' => 0x983,
    '再' => 0x984,
    '最' => 0x985,
    '哉' => 0x986,
    '塞' => 0x987,
    '妻' => 0x988,
    '宰' => 0x989,
    '彩' => 0x98a,
    '才' => 0x98b,
    '採' => 0x98c,
    '栽' => 0x98d,
    '歳' => 0x98e,
    '済' => 0x98f,
    '災' => 0x990,
    '采' => 0x991,
    '犀' => 0x992,
    '砕' => 0x993,
    '砦' => 0x994,
    '祭' => 0x995,
    '斎' => 0x996,
    '細' => 0x997,
    '菜' => 0x998,
    '裁' => 0x999,
    '載' => 0x99a,
    '際' => 0x99b,
    '剤' => 0x99c,
    '在' => 0x99d,
    '材' => 0x99e,
    '罪' => 0x99f,
    '財' => 0x9a0,
    '冴' => 0x9a1,
    '坂' => 0x9a2,
    '阪' => 0x9a3,
    '堺' => 0x9a4,
    '榊' => 0x9a5,
    '肴' => 0x9a6,
    '咲' => 0x9a7,
    '崎' => 0x9a8,
    '埼' => 0x9a9,
    '碕' => 0x9aa,
    '鷺' => 0x9ab,
    '作' => 0x9ac,
    '削' => 0x9ad,
    '咋' => 0x9ae,
    '搾' => 0x9af,
    '昨' => 0x9b0,
    '朔' => 0x9b1,
    '柵' => 0x9b2,
    '窄' => 0x9b3,
    '策' => 0x9b4,
    '索' => 0x9b5,
    '錯' => 0x9b6,
    '桜' => 0x9b7,
    '鮭' => 0x9b8,
    '笹' => 0x9b9,
    '匙' => 0x9ba,
    '冊' => 0x9bb,
    '刷' => 0x9bc,
    '察' => 0x9c0,
    '拶' => 0x9c1,
    '撮' => 0x9c2,
    '擦' => 0x9c3,
    '札' => 0x9c4,
    '殺' => 0x9c5,
    '薩' => 0x9c6,
    '雑' => 0x9c7,
    '皐' => 0x9c8,
    '鯖' => 0x9c9,
    '捌' => 0x9ca,
    '錆' => 0x9cb,
    '鮫' => 0x9cc,
    '皿' => 0x9cd,
    '晒' => 0x9ce,
    '三' => 0x9cf,
    '傘' => 0x9d0,
    '参' => 0x9d1,
    '山' => 0x9d2,
    '惨' => 0x9d3,
    '撒' => 0x9d4,
    '散' => 0x9d5,
    '桟' => 0x9d6,
    '燦' => 0x9d7,
    '珊' => 0x9d8,
    '産' => 0x9d9,
    '算' => 0x9da,
    '纂' => 0x9db,
    '蚕' => 0x9dc,
    '讃' => 0x9dd,
    '賛' => 0x9de,
    '酸' => 0x9df,
    '餐' => 0x9e0,
    '斬' => 0x9e1,
    '暫' => 0x9e2,
    '残' => 0x9e3,
    '仕' => 0x9e4,
    '仔' => 0x9e5,
    '伺' => 0x9e6,
    '使' => 0x9e7,
    '刺' => 0x9e8,
    '司' => 0x9e9,
    '史' => 0x9ea,
    '嗣' => 0x9eb,
    '四' => 0x9ec,
    '士' => 0x9ed,
    '始' => 0x9ee,
    '姉' => 0x9ef,
    '姿' => 0x9f0,
    '子' => 0x9f1,
    '屍' => 0x9f2,
    '市' => 0x9f3,
    '師' => 0x9f4,
    '志' => 0x9f5,
    '思' => 0x9f6,
    '指' => 0x9f7,
    '支' => 0x9f8,
    '孜' => 0x9f9,
    '斯' => 0x9fa,
    '施' => 0x9fb,
    '旨' => 0x9fc,
    '枝' => 0x9fd,
    '止' => 0x9fe,
    '死' => 0xa00,
    '氏' => 0xa01,
    '獅' => 0xa02,
    '祉' => 0xa03,
    '私' => 0xa04,
    '糸' => 0xa05,
    '紙' => 0xa06,
    '紫' => 0xa07,
    '肢' => 0xa08,
    '脂' => 0xa09,
    '至' => 0xa0a,
    '視' => 0xa0b,
    '詞' => 0xa0c,
    '詩' => 0xa0d,
    '試' => 0xa0e,
    '誌' => 0xa0f,
    '諮' => 0xa10,
    '資' => 0xa11,
    '賜' => 0xa12,
    '雌' => 0xa13,
    '飼' => 0xa14,
    '歯' => 0xa15,
    '事' => 0xa16,
    '似' => 0xa17,
    '侍' => 0xa18,
    '児' => 0xa19,
    '字' => 0xa1a,
    '寺' => 0xa1b,
    '慈' => 0xa1c,
    '持' => 0xa1d,
    '時' => 0xa1e,
    '次' => 0xa1f,
    '滋' => 0xa20,
    '治' => 0xa21,
    '爾' => 0xa22,
    '璽' => 0xa23,
    '痔' => 0xa24,
    '磁' => 0xa25,
    '示' => 0xa26,
    '而' => 0xa27,
    '耳' => 0xa28,
    '自' => 0xa29,
    '蒔' => 0xa2a,
    '辞' => 0xa2b,
    '汐' => 0xa2c,
    '鹿' => 0xa2d,
    '式' => 0xa2e,
    '識' => 0xa2f,
    '鴫' => 0xa30,
    '竺' => 0xa31,
    '軸' => 0xa32,
    '宍' => 0xa33,
    '雫' => 0xa34,
    '七' => 0xa35,
    '叱' => 0xa36,
    '執' => 0xa37,
    '失' => 0xa38,
    '嫉' => 0xa39,
    '室' => 0xa3a,
    '悉' => 0xa3b,
    '湿' => 0xa3c,
    '漆' => 0xa3d,
    '疾' => 0xa3e,
    '質' => 0xa3f,
    '実' => 0xa40,
    '蔀' => 0xa41,
    '篠' => 0xa42,
    '偲' => 0xa43,
    '柴' => 0xa44,
    '芝' => 0xa45,
    '屡' => 0xa46,
    '蕊' => 0xa47,
    '縞' => 0xa48,
    '舎' => 0xa49,
    '写' => 0xa4a,
    '射' => 0xa4b,
    '捨' => 0xa4c,
    '赦' => 0xa4d,
    '斜' => 0xa4e,
    '煮' => 0xa4f,
    '社' => 0xa50,
    '紗' => 0xa51,
    '者' => 0xa52,
    '謝' => 0xa53,
    '車' => 0xa54,
    '遮' => 0xa55,
    '蛇' => 0xa56,
    '邪' => 0xa57,
    '借' => 0xa58,
    '勺' => 0xa59,
    '尺' => 0xa5a,
    '杓' => 0xa5b,
    '灼' => 0xa5c,
    '爵' => 0xa5d,
    '酌' => 0xa5e,
    '釈' => 0xa5f,
    '錫' => 0xa60,
    '若' => 0xa61,
    '寂' => 0xa62,
    '弱' => 0xa63,
    '惹' => 0xa64,
    '主' => 0xa65,
    '取' => 0xa66,
    '守' => 0xa67,
    '手' => 0xa68,
    '朱' => 0xa69,
    '殊' => 0xa6a,
    '狩' => 0xa6b,
    '珠' => 0xa6c,
    '種' => 0xa6d,
    '腫' => 0xa6e,
    '趣' => 0xa6f,
    '酒' => 0xa70,
    '首' => 0xa71,
    '儒' => 0xa72,
    '受' => 0xa73,
    '呪' => 0xa74,
    '寿' => 0xa75,
    '授' => 0xa76,
    '樹' => 0xa77,
    '綬' => 0xa78,
    '需' => 0xa79,
    '囚' => 0xa7a,
    '収' => 0xa7b,
    '周' => 0xa7c,
    '宗' => 0xa80,
    '就' => 0xa81,
    '州' => 0xa82,
    '修' => 0xa83,
    '愁' => 0xa84,
    '拾' => 0xa85,
    '洲' => 0xa86,
    '秀' => 0xa87,
    '秋' => 0xa88,
    '終' => 0xa89,
    '繍' => 0xa8a,
    '習' => 0xa8b,
    '臭' => 0xa8c,
    '舟' => 0xa8d,
    '蒐' => 0xa8e,
    '衆' => 0xa8f,
    '襲' => 0xa90,
    '讐' => 0xa91,
    '蹴' => 0xa92,
    '輯' => 0xa93,
    '週' => 0xa94,
    '酋' => 0xa95,
    '酬' => 0xa96,
    '集' => 0xa97,
    '醜' => 0xa98,
    '什' => 0xa99,
    '住' => 0xa9a,
    '充' => 0xa9b,
    '十' => 0xa9c,
    '従' => 0xa9d,
    '戎' => 0xa9e,
    '柔' => 0xa9f,
    '汁' => 0xaa0,
    '渋' => 0xaa1,
    '獣' => 0xaa2,
    '縦' => 0xaa3,
    '重' => 0xaa4,
    '銃' => 0xaa5,
    '叔' => 0xaa6,
    '夙' => 0xaa7,
    '宿' => 0xaa8,
    '淑' => 0xaa9,
    '祝' => 0xaaa,
    '縮' => 0xaab,
    '粛' => 0xaac,
    '塾' => 0xaad,
    '熟' => 0xaae,
    '出' => 0xaaf,
    '術' => 0xab0,
    '述' => 0xab1,
    '俊' => 0xab2,
    '峻' => 0xab3,
    '春' => 0xab4,
    '瞬' => 0xab5,
    '竣' => 0xab6,
    '舜' => 0xab7,
    '駿' => 0xab8,
    '准' => 0xab9,
    '循' => 0xaba,
    '旬' => 0xabb,
    '楯' => 0xabc,
    '殉' => 0xabd,
    '淳' => 0xabe,
    '準' => 0xac0,
    '潤' => 0xac1,
    '盾' => 0xac2,
    '純' => 0xac3,
    '巡' => 0xac4,
    '遵' => 0xac5,
    '醇' => 0xac6,
    '順' => 0xac7,
    '処' => 0xac8,
    '初' => 0xac9,
    '所' => 0xaca,
    '暑' => 0xacb,
    '曙' => 0xacc,
    '渚' => 0xacd,
    '庶' => 0xace,
    '緒' => 0xacf,
    '署' => 0xad0,
    '書' => 0xad1,
    '薯' => 0xad2,
    '藷' => 0xad3,
    '諸' => 0xad4,
    '助' => 0xad5,
    '叙' => 0xad6,
    '女' => 0xad7,
    '序' => 0xad8,
    '徐' => 0xad9,
    '恕' => 0xada,
    '鋤' => 0xadb,
    '除' => 0xadc,
    '傷' => 0xadd,
    '償' => 0xade,
    '勝' => 0xadf,
    '匠' => 0xae0,
    '升' => 0xae1,
    '召' => 0xae2,
    '哨' => 0xae3,
    '商' => 0xae4,
    '唱' => 0xae5,
    '嘗' => 0xae6,
    '奨' => 0xae7,
    '妾' => 0xae8,
    '娼' => 0xae9,
    '宵' => 0xaea,
    '将' => 0xaeb,
    '小' => 0xaec,
    '少' => 0xaed,
    '尚' => 0xaee,
    '庄' => 0xaef,
    '床' => 0xaf0,
    '廠' => 0xaf1,
    '彰' => 0xaf2,
    '承' => 0xaf3,
    '抄' => 0xaf4,
    '招' => 0xaf5,
    '掌' => 0xaf6,
    '捷' => 0xaf7,
    '昇' => 0xaf8,
    '昌' => 0xaf9,
    '昭' => 0xafa,
    '晶' => 0xafb,
    '松' => 0xafc,
    '梢' => 0xafd,
    '樟' => 0xafe,
    '樵' => 0xaff,
    '沼' => 0xb00,
    '消' => 0xb01,
    '渉' => 0xb02,
    '湘' => 0xb03,
    '焼' => 0xb04,
    '焦' => 0xb05,
    '照' => 0xb06,
    '症' => 0xb07,
    '省' => 0xb08,
    '硝' => 0xb09,
    '礁' => 0xb0a,
    '祥' => 0xb0b,
    '称' => 0xb0c,
    '章' => 0xb0d,
    '笑' => 0xb0e,
    '粧' => 0xb0f,
    '紹' => 0xb10,
    '肖' => 0xb11,
    '菖' => 0xb12,
    '蒋' => 0xb13,
    '蕉' => 0xb14,
    '衝' => 0xb15,
    '裳' => 0xb16,
    '訟' => 0xb17,
    '証' => 0xb18,
    '詔' => 0xb19,
    '詳' => 0xb1a,
    '象' => 0xb1b,
    '賞' => 0xb1c,
    '醤' => 0xb1d,
    '鉦' => 0xb1e,
    '鍾' => 0xb1f,
    '鐘' => 0xb20,
    '障' => 0xb21,
    '鞘' => 0xb22,
    '上' => 0xb23,
    '丈' => 0xb24,
    '丞' => 0xb25,
    '乗' => 0xb26,
    '冗' => 0xb27,
    '剰' => 0xb28,
    '城' => 0xb29,
    '場' => 0xb2a,
    '壌' => 0xb2b,
    '嬢' => 0xb2c,
    '常' => 0xb2d,
    '情' => 0xb2e,
    '擾' => 0xb2f,
    '条' => 0xb30,
    '杖' => 0xb31,
    '浄' => 0xb32,
    '状' => 0xb33,
    '畳' => 0xb34,
    '穣' => 0xb35,
    '蒸' => 0xb36,
    '譲' => 0xb37,
    '醸' => 0xb38,
    '錠' => 0xb39,
    '嘱' => 0xb3a,
    '埴' => 0xb3b,
    '飾' => 0xb3c,
    '拭' => 0xb40,
    '植' => 0xb41,
    '殖' => 0xb42,
    '燭' => 0xb43,
    '織' => 0xb44,
    '職' => 0xb45,
    '色' => 0xb46,
    '触' => 0xb47,
    '食' => 0xb48,
    '蝕' => 0xb49,
    '辱' => 0xb4a,
    '尻' => 0xb4b,
    '伸' => 0xb4c,
    '信' => 0xb4d,
    '侵' => 0xb4e,
    '唇' => 0xb4f,
    '娠' => 0xb50,
    '寝' => 0xb51,
    '審' => 0xb52,
    '心' => 0xb53,
    '慎' => 0xb54,
    '振' => 0xb55,
    '新' => 0xb56,
    '晋' => 0xb57,
    '森' => 0xb58,
    '榛' => 0xb59,
    '浸' => 0xb5a,
    '深' => 0xb5b,
    '申' => 0xb5c,
    '疹' => 0xb5d,
    '真' => 0xb5e,
    '神' => 0xb5f,
    '秦' => 0xb60,
    '紳' => 0xb61,
    '臣' => 0xb62,
    '芯' => 0xb63,
    '薪' => 0xb64,
    '親' => 0xb65,
    '診' => 0xb66,
    '身' => 0xb67,
    '辛' => 0xb68,
    '進' => 0xb69,
    '針' => 0xb6a,
    '震' => 0xb6b,
    '人' => 0xb6c,
    '仁' => 0xb6d,
    '刃' => 0xb6e,
    '塵' => 0xb6f,
    '壬' => 0xb70,
    '尋' => 0xb71,
    '甚' => 0xb72,
    '尽' => 0xb73,
    '腎' => 0xb74,
    '訊' => 0xb75,
    '迅' => 0xb76,
    '陣' => 0xb77,
    '靭' => 0xb78,
    '笥' => 0xb79,
    '諏' => 0xb7a,
    '須' => 0xb7b,
    '酢' => 0xb7c,
    '図' => 0xb7d,
    '厨' => 0xb7e,
    '逗' => 0xb80,
    '吹' => 0xb81,
    '垂' => 0xb82,
    '帥' => 0xb83,
    '推' => 0xb84,
    '水' => 0xb85,
    '炊' => 0xb86,
    '睡' => 0xb87,
    '粋' => 0xb88,
    '翠' => 0xb89,
    '衰' => 0xb8a,
    '遂' => 0xb8b,
    '酔' => 0xb8c,
    '錐' => 0xb8d,
    '錘' => 0xb8e,
    '随' => 0xb8f,
    '瑞' => 0xb90,
    '髄' => 0xb91,
    '崇' => 0xb92,
    '嵩' => 0xb93,
    '数' => 0xb94,
    '枢' => 0xb95,
    '趨' => 0xb96,
    '雛' => 0xb97,
    '据' => 0xb98,
    '杉' => 0xb99,
    '椙' => 0xb9a,
    '菅' => 0xb9b,
    '頗' => 0xb9c,
    '雀' => 0xb9d,
    '裾' => 0xb9e,
    '澄' => 0xb9f,
    '摺' => 0xba0,
    '寸' => 0xba1,
    '世' => 0xba2,
    '瀬' => 0xba3,
    '畝' => 0xba4,
    '是' => 0xba5,
    '凄' => 0xba6,
    '制' => 0xba7,
    '勢' => 0xba8,
    '姓' => 0xba9,
    '征' => 0xbaa,
    '性' => 0xbab,
    '成' => 0xbac,
    '政' => 0xbad,
    '整' => 0xbae,
    '星' => 0xbaf,
    '晴' => 0xbb0,
    '棲' => 0xbb1,
    '栖' => 0xbb2,
    '正' => 0xbb3,
    '清' => 0xbb4,
    '牲' => 0xbb5,
    '生' => 0xbb6,
    '盛' => 0xbb7,
    '精' => 0xbb8,
    '聖' => 0xbb9,
    '声' => 0xbba,
    '製' => 0xbbb,
    '西' => 0xbbc,
    '誠' => 0xbbd,
    '誓' => 0xbbe,
    '請' => 0xbbf,
    '逝' => 0xbc0,
    '醒' => 0xbc1,
    '青' => 0xbc2,
    '静' => 0xbc3,
    '斉' => 0xbc4,
    '税' => 0xbc5,
    '脆' => 0xbc6,
    '隻' => 0xbc7,
    '席' => 0xbc8,
    '惜' => 0xbc9,
    '戚' => 0xbca,
    '斥' => 0xbcb,
    '昔' => 0xbcc,
    '析' => 0xbcd,
    '石' => 0xbce,
    '積' => 0xbcf,
    '籍' => 0xbd0,
    '績' => 0xbd1,
    '脊' => 0xbd2,
    '責' => 0xbd3,
    '赤' => 0xbd4,
    '跡' => 0xbd5,
    '蹟' => 0xbd6,
    '碩' => 0xbd7,
    '切' => 0xbd8,
    '拙' => 0xbd9,
    '接' => 0xbda,
    '摂' => 0xbdb,
    '折' => 0xbdc,
    '設' => 0xbdd,
    '窃' => 0xbde,
    '節' => 0xbdf,
    '説' => 0xbe0,
    '雪' => 0xbe1,
    '絶' => 0xbe2,
    '舌' => 0xbe3,
    '蝉' => 0xbe4,
    '仙' => 0xbe5,
    '先' => 0xbe6,
    '千' => 0xbe7,
    '占' => 0xbe8,
    '宣' => 0xbe9,
    '専' => 0xbea,
    '尖' => 0xbeb,
    '川' => 0xbec,
    '戦' => 0xbed,
    '扇' => 0xbee,
    '撰' => 0xbef,
    '栓' => 0xbf0,
    '栴' => 0xbf1,
    '泉' => 0xbf2,
    '浅' => 0xbf3,
    '洗' => 0xbf4,
    '染' => 0xbf5,
    '潜' => 0xbf6,
    '煎' => 0xbf7,
    '煽' => 0xbf8,
    '旋' => 0xbf9,
    '穿' => 0xbfa,
    '箭' => 0xbfb,
    '線' => 0xbfc,
    '繊' => 0xc00,
    '羨' => 0xc01,
    '腺' => 0xc02,
    '舛' => 0xc03,
    '船' => 0xc04,
    '薦' => 0xc05,
    '詮' => 0xc06,
    '賎' => 0xc07,
    '践' => 0xc08,
    '選' => 0xc09,
    '遷' => 0xc0a,
    '銭' => 0xc0b,
    '銑' => 0xc0c,
    '閃' => 0xc0d,
    '鮮' => 0xc0e,
    '前' => 0xc0f,
    '善' => 0xc10,
    '漸' => 0xc11,
    '然' => 0xc12,
    '全' => 0xc13,
    '禅' => 0xc14,
    '繕' => 0xc15,
    '膳' => 0xc16,
    '糎' => 0xc17,
    '噌' => 0xc18,
    '塑' => 0xc19,
    '岨' => 0xc1a,
    '措' => 0xc1b,
    '曾' => 0xc1c,
    '曽' => 0xc1d,
    '楚' => 0xc1e,
    '狙' => 0xc1f,
    '疏' => 0xc20,
    '疎' => 0xc21,
    '礎' => 0xc22,
    '祖' => 0xc23,
    '租' => 0xc24,
    '粗' => 0xc25,
    '素' => 0xc26,
    '組' => 0xc27,
    '蘇' => 0xc28,
    '訴' => 0xc29,
    '阻' => 0xc2a,
    '遡' => 0xc2b,
    '鼠' => 0xc2c,
    '僧' => 0xc2d,
    '創' => 0xc2e,
    '双' => 0xc2f,
    '叢' => 0xc30,
    '倉' => 0xc31,
    '喪' => 0xc32,
    '壮' => 0xc33,
    '奏' => 0xc34,
    '爽' => 0xc35,
    '宋' => 0xc36,
    '層' => 0xc37,
    '匝' => 0xc38,
    '惣' => 0xc39,
    '想' => 0xc3a,
    '捜' => 0xc3b,
    '掃' => 0xc3c,
    '挿' => 0xc3d,
    '掻' => 0xc3e,
    '操' => 0xc40,
    '早' => 0xc41,
    '曹' => 0xc42,
    '巣' => 0xc43,
    '槍' => 0xc44,
    '槽' => 0xc45,
    '漕' => 0xc46,
    '燥' => 0xc47,
    '争' => 0xc48,
    '痩' => 0xc49,
    '相' => 0xc4a,
    '窓' => 0xc4b,
    '糟' => 0xc4c,
    '総' => 0xc4d,
    '綜' => 0xc4e,
    '聡' => 0xc4f,
    '草' => 0xc50,
    '荘' => 0xc51,
    '葬' => 0xc52,
    '蒼' => 0xc53,
    '藻' => 0xc54,
    '装' => 0xc55,
    '走' => 0xc56,
    '送' => 0xc57,
    '遭' => 0xc58,
    '鎗' => 0xc59,
    '霜' => 0xc5a,
    '騒' => 0xc5b,
    '像' => 0xc5c,
    '増' => 0xc5d,
    '憎' => 0xc5e,
    '臓' => 0xc5f,
    '蔵' => 0xc60,
    '贈' => 0xc61,
    '造' => 0xc62,
    '促' => 0xc63,
    '側' => 0xc64,
    '則' => 0xc65,
    '即' => 0xc66,
    '息' => 0xc67,
    '捉' => 0xc68,
    '束' => 0xc69,
    '測' => 0xc6a,
    '足' => 0xc6b,
    '速' => 0xc6c,
    '俗' => 0xc6d,
    '属' => 0xc6e,
    '賊' => 0xc6f,
    '族' => 0xc70,
    '続' => 0xc71,
    '卒' => 0xc72,
    '袖' => 0xc73,
    '其' => 0xc74,
    '揃' => 0xc75,
    '存' => 0xc76,
    '孫' => 0xc77,
    '尊' => 0xc78,
    '損' => 0xc79,
    '村' => 0xc7a,
    '遜' => 0xc7b,
    '他' => 0xc7c,
    '多' => 0xc7d,
    '太' => 0xc7e,
    '汰' => 0xc7f,
    '詑' => 0xc80,
    '唾' => 0xc81,
    '堕' => 0xc82,
    '妥' => 0xc83,
    '惰' => 0xc84,
    '打' => 0xc85,
    '柁' => 0xc86,
    '舵' => 0xc87,
    '楕' => 0xc88,
    '陀' => 0xc89,
    '駄' => 0xc8a,
    '騨' => 0xc8b,
    '体' => 0xc8c,
    '堆' => 0xc8d,
    '対' => 0xc8e,
    '耐' => 0xc8f,
    '岱' => 0xc90,
    '帯' => 0xc91,
    '待' => 0xc92,
    '怠' => 0xc93,
    '態' => 0xc94,
    '戴' => 0xc95,
    '替' => 0xc96,
    '泰' => 0xc97,
    '滞' => 0xc98,
    '胎' => 0xc99,
    '腿' => 0xc9a,
    '苔' => 0xc9b,
    '袋' => 0xc9c,
    '貸' => 0xc9d,
    '退' => 0xc9e,
    '逮' => 0xc9f,
    '隊' => 0xca0,
    '黛' => 0xca1,
    '鯛' => 0xca2,
    '代' => 0xca3,
    '台' => 0xca4,
    '大' => 0xca5,
    '第' => 0xca6,
    '醍' => 0xca7,
    '題' => 0xca8,
    '鷹' => 0xca9,
    '滝' => 0xcaa,
    '瀧' => 0xcab,
    '卓' => 0xcac,
    '啄' => 0xcad,
    '宅' => 0xcae,
    '托' => 0xcaf,
    '択' => 0xcb0,
    '拓' => 0xcb1,
    '沢' => 0xcb2,
    '濯' => 0xcb3,
    '琢' => 0xcb4,
    '託' => 0xcb5,
    '鐸' => 0xcb6,
    '濁' => 0xcb7,
    '諾' => 0xcb8,
    '茸' => 0xcb9,
    '凧' => 0xcba,
    '蛸' => 0xcbb,
    '只' => 0xcbc,
    '叩' => 0xcc0,
    '但' => 0xcc1,
    '達' => 0xcc2,
    '辰' => 0xcc3,
    '奪' => 0xcc4,
    '脱' => 0xcc5,
    '巽' => 0xcc6,
    '竪' => 0xcc7,
    '辿' => 0xcc8,
    '棚' => 0xcc9,
    '谷' => 0xcca,
    '狸' => 0xccb,
    '鱈' => 0xccc,
    '樽' => 0xccd,
    '誰' => 0xcce,
    '丹' => 0xccf,
    '単' => 0xcd0,
    '嘆' => 0xcd1,
    '坦' => 0xcd2,
    '担' => 0xcd3,
    '探' => 0xcd4,
    '旦' => 0xcd5,
    '歎' => 0xcd6,
    '淡' => 0xcd7,
    '湛' => 0xcd8,
    '炭' => 0xcd9,
    '短' => 0xcda,
    '端' => 0xcdb,
    '箪' => 0xcdc,
    '綻' => 0xcdd,
    '耽' => 0xcde,
    '胆' => 0xcdf,
    '蛋' => 0xce0,
    '誕' => 0xce1,
    '鍛' => 0xce2,
    '団' => 0xce3,
    '壇' => 0xce4,
    '弾' => 0xce5,
    '断' => 0xce6,
    '暖' => 0xce7,
    '檀' => 0xce8,
    '段' => 0xce9,
    '男' => 0xcea,
    '談' => 0xceb,
    '値' => 0xcec,
    '知' => 0xced,
    '地' => 0xcee,
    '弛' => 0xcef,
    '恥' => 0xcf0,
    '智' => 0xcf1,
    '池' => 0xcf2,
    '痴' => 0xcf3,
    '稚' => 0xcf4,
    '置' => 0xcf5,
    '致' => 0xcf6,
    '蜘' => 0xcf7,
    '遅' => 0xcf8,
    '馳' => 0xcf9,
    '築' => 0xcfa,
    '畜' => 0xcfb,
    '竹' => 0xcfc,
    '筑' => 0xcfd,
    '蓄' => 0xcfe,
    '逐' => 0xd00,
    '秩' => 0xd01,
    '窒' => 0xd02,
    '茶' => 0xd03,
    '嫡' => 0xd04,
    '着' => 0xd05,
    '中' => 0xd06,
    '仲' => 0xd07,
    '宙' => 0xd08,
    '忠' => 0xd09,
    '抽' => 0xd0a,
    '昼' => 0xd0b,
    '柱' => 0xd0c,
    '注' => 0xd0d,
    '虫' => 0xd0e,
    '衷' => 0xd0f,
    '註' => 0xd10,
    '酎' => 0xd11,
    '鋳' => 0xd12,
    '駐' => 0xd13,
    '樗' => 0xd14,
    '瀦' => 0xd15,
    '猪' => 0xd16,
    '苧' => 0xd17,
    '著' => 0xd18,
    '貯' => 0xd19,
    '丁' => 0xd1a,
    '兆' => 0xd1b,
    '凋' => 0xd1c,
    '喋' => 0xd1d,
    '寵' => 0xd1e,
    '帖' => 0xd1f,
    '帳' => 0xd20,
    '庁' => 0xd21,
    '弔' => 0xd22,
    '張' => 0xd23,
    '彫' => 0xd24,
    '徴' => 0xd25,
    '懲' => 0xd26,
    '挑' => 0xd27,
    '暢' => 0xd28,
    '朝' => 0xd29,
    '潮' => 0xd2a,
    '牒' => 0xd2b,
    '町' => 0xd2c,
    '眺' => 0xd2d,
    '聴' => 0xd2e,
    '脹' => 0xd2f,
    '腸' => 0xd30,
    '蝶' => 0xd31,
    '調' => 0xd32,
    '諜' => 0xd33,
    '超' => 0xd34,
    '跳' => 0xd35,
    '銚' => 0xd36,
    '長' => 0xd37,
    '頂' => 0xd38,
    '鳥' => 0xd39,
    '勅' => 0xd3a,
    '捗' => 0xd3b,
    '直' => 0xd3c,
    '朕' => 0xd3d,
    '沈' => 0xd3e,
    '珍' => 0xd3f,
    '賃' => 0xd40,
    '鎮' => 0xd41,
    '陳' => 0xd42,
    '津' => 0xd43,
    '墜' => 0xd44,
    '椎' => 0xd45,
    '槌' => 0xd46,
    '追' => 0xd47,
    '鎚' => 0xd48,
    '痛' => 0xd49,
    '通' => 0xd4a,
    '塚' => 0xd4b,
    '栂' => 0xd4c,
    '掴' => 0xd4d,
    '槻' => 0xd4e,
    '佃' => 0xd4f,
    '漬' => 0xd50,
    '柘' => 0xd51,
    '辻' => 0xd52,
    '蔦' => 0xd53,
    '綴' => 0xd54,
    '鍔' => 0xd55,
    '椿' => 0xd56,
    '潰' => 0xd57,
    '坪' => 0xd58,
    '壷' => 0xd59,
    '嬬' => 0xd5a,
    '紬' => 0xd5b,
    '爪' => 0xd5c,
    '吊' => 0xd5d,
    '釣' => 0xd5e,
    '鶴' => 0xd5f,
    '亭' => 0xd60,
    '低' => 0xd61,
    '停' => 0xd62,
    '偵' => 0xd63,
    '剃' => 0xd64,
    '貞' => 0xd65,
    '呈' => 0xd66,
    '堤' => 0xd67,
    '定' => 0xd68,
    '帝' => 0xd69,
    '底' => 0xd6a,
    '庭' => 0xd6b,
    '廷' => 0xd6c,
    '弟' => 0xd6d,
    '悌' => 0xd6e,
    '抵' => 0xd6f,
    '挺' => 0xd70,
    '提' => 0xd71,
    '梯' => 0xd72,
    '汀' => 0xd73,
    '碇' => 0xd74,
    '禎' => 0xd75,
    '程' => 0xd76,
    '締' => 0xd77,
    '艇' => 0xd78,
    '訂' => 0xd79,
    '諦' => 0xd7a,
    '蹄' => 0xd7b,
    '逓' => 0xd7c,
    '邸' => 0xd80,
    '鄭' => 0xd81,
    '釘' => 0xd82,
    '鼎' => 0xd83,
    '泥' => 0xd84,
    '摘' => 0xd85,
    '擢' => 0xd86,
    '敵' => 0xd87,
    '滴' => 0xd88,
    '的' => 0xd89,
    '笛' => 0xd8a,
    '適' => 0xd8b,
    '鏑' => 0xd8c,
    '溺' => 0xd8d,
    '哲' => 0xd8e,
    '徹' => 0xd8f,
    '撤' => 0xd90,
    '轍' => 0xd91,
    '迭' => 0xd92,
    '鉄' => 0xd93,
    '典' => 0xd94,
    '填' => 0xd95,
    '天' => 0xd96,
    '展' => 0xd97,
    '店' => 0xd98,
    '添' => 0xd99,
    '纏' => 0xd9a,
    '甜' => 0xd9b,
    '貼' => 0xd9c,
    '転' => 0xd9d,
    '顛' => 0xd9e,
    '点' => 0xd9f,
    '伝' => 0xda0,
    '殿' => 0xda1,
    '澱' => 0xda2,
    '田' => 0xda3,
    '電' => 0xda4,
    '兎' => 0xda5,
    '吐' => 0xda6,
    '堵' => 0xda7,
    '塗' => 0xda8,
    '妬' => 0xda9,
    '屠' => 0xdaa,
    '徒' => 0xdab,
    '斗' => 0xdac,
    '杜' => 0xdad,
    '渡' => 0xdae,
    '登' => 0xdaf,
    '菟' => 0xdb0,
    '賭' => 0xdb1,
    '途' => 0xdb2,
    '都' => 0xdb3,
    '鍍' => 0xdb4,
    '砥' => 0xdb5,
    '砺' => 0xdb6,
    '努' => 0xdb7,
    '度' => 0xdb8,
    '土' => 0xdb9,
    '奴' => 0xdba,
    '怒' => 0xdbb,
    '倒' => 0xdbc,
    '党' => 0xdbd,
    '冬' => 0xdbe,
    '凍' => 0xdc0,
    '刀' => 0xdc1,
    '唐' => 0xdc2,
    '塔' => 0xdc3,
    '塘' => 0xdc4,
    '套' => 0xdc5,
    '宕' => 0xdc6,
    '島' => 0xdc7,
    '嶋' => 0xdc8,
    '悼' => 0xdc9,
    '投' => 0xdca,
    '搭' => 0xdcb,
    '東' => 0xdcc,
    '桃' => 0xdcd,
    '梼' => 0xdce,
    '棟' => 0xdcf,
    '盗' => 0xdd0,
    '淘' => 0xdd1,
    '湯' => 0xdd2,
    '涛' => 0xdd3,
    '灯' => 0xdd4,
    '燈' => 0xdd5,
    '当' => 0xdd6,
    '痘' => 0xdd7,
    '祷' => 0xdd8,
    '等' => 0xdd9,
    '答' => 0xdda,
    '筒' => 0xddb,
    '糖' => 0xddc,
    '統' => 0xddd,
    '到' => 0xdde,
    '董' => 0xddf,
    '蕩' => 0xde0,
    '藤' => 0xde1,
    '討' => 0xde2,
    '謄' => 0xde3,
    '豆' => 0xde4,
    '踏' => 0xde5,
    '逃' => 0xde6,
    '透' => 0xde7,
    '鐙' => 0xde8,
    '陶' => 0xde9,
    '頭' => 0xdea,
    '騰' => 0xdeb,
    '闘' => 0xdec,
    '働' => 0xded,
    '動' => 0xdee,
    '同' => 0xdef,
    '堂' => 0xdf0,
    '導' => 0xdf1,
    '憧' => 0xdf2,
    '撞' => 0xdf3,
    '洞' => 0xdf4,
    '瞳' => 0xdf5,
    '童' => 0xdf6,
    '胴' => 0xdf7,
    '萄' => 0xdf8,
    '道' => 0xdf9,
    '銅' => 0xdfa,
    '峠' => 0xdfb,
    '鴇' => 0xdfc,
    '匿' => 0xdfd,
    '得' => 0xdfe,
    '徳' => 0xdff,
    '涜' => 0xe00,
    '特' => 0xe01,
    '督' => 0xe02,
    '禿' => 0xe03,
    '篤' => 0xe04,
    '毒' => 0xe05,
    '独' => 0xe06,
    '読' => 0xe07,
    '栃' => 0xe08,
    '橡' => 0xe09,
    '凸' => 0xe0a,
    '突' => 0xe0b,
    '椴' => 0xe0c,
    '届' => 0xe0d,
    '鳶' => 0xe0e,
    '苫' => 0xe0f,
    '寅' => 0xe10,
    '酉' => 0xe11,
    '瀞' => 0xe12,
    '噸' => 0xe13,
    '屯' => 0xe14,
    '惇' => 0xe15,
    '敦' => 0xe16,
    '沌' => 0xe17,
    '豚' => 0xe18,
    '遁' => 0xe19,
    '頓' => 0xe1a,
    '呑' => 0xe1b,
    '曇' => 0xe1c,
    '鈍' => 0xe1d,
    '奈' => 0xe1e,
    '那' => 0xe1f,
    '内' => 0xe20,
    '乍' => 0xe21,
    '凪' => 0xe22,
    '薙' => 0xe23,
    '謎' => 0xe24,
    '灘' => 0xe25,
    '捺' => 0xe26,
    '鍋' => 0xe27,
    '楢' => 0xe28,
    '馴' => 0xe29,
    '縄' => 0xe2a,
    '畷' => 0xe2b,
    '南' => 0xe2c,
    '楠' => 0xe2d,
    '軟' => 0xe2e,
    '難' => 0xe2f,
    '汝' => 0xe30,
    '二' => 0xe31,
    '尼' => 0xe32,
    '弐' => 0xe33,
    '迩' => 0xe34,
    '匂' => 0xe35,
    '賑' => 0xe36,
    '肉' => 0xe37,
    '虹' => 0xe38,
    '廿' => 0xe39,
    '日' => 0xe3a,
    '乳' => 0xe3b,
    '入' => 0xe3c,
    '如' => 0xe40,
    '尿' => 0xe41,
    '韮' => 0xe42,
    '任' => 0xe43,
    '妊' => 0xe44,
    '忍' => 0xe45,
    '認' => 0xe46,
    '濡' => 0xe47,
    '禰' => 0xe48,
    '祢' => 0xe49,
    '寧' => 0xe4a,
    '葱' => 0xe4b,
    '猫' => 0xe4c,
    '熱' => 0xe4d,
    '年' => 0xe4e,
    '念' => 0xe4f,
    '捻' => 0xe50,
    '撚' => 0xe51,
    '燃' => 0xe52,
    '粘' => 0xe53,
    '乃' => 0xe54,
    '廼' => 0xe55,
    '之' => 0xe56,
    '埜' => 0xe57,
    '嚢' => 0xe58,
    '悩' => 0xe59,
    '濃' => 0xe5a,
    '納' => 0xe5b,
    '能' => 0xe5c,
    '脳' => 0xe5d,
    '膿' => 0xe5e,
    '農' => 0xe5f,
    '覗' => 0xe60,
    '蚤' => 0xe61,
    '巴' => 0xe62,
    '把' => 0xe63,
    '播' => 0xe64,
    '覇' => 0xe65,
    '杷' => 0xe66,
    '波' => 0xe67,
    '派' => 0xe68,
    '琶' => 0xe69,
    '破' => 0xe6a,
    '婆' => 0xe6b,
    '罵' => 0xe6c,
    '芭' => 0xe6d,
    '馬' => 0xe6e,
    '俳' => 0xe6f,
    '廃' => 0xe70,
    '拝' => 0xe71,
    '排' => 0xe72,
    '敗' => 0xe73,
    '杯' => 0xe74,
    '盃' => 0xe75,
    '牌' => 0xe76,
    '背' => 0xe77,
    '肺' => 0xe78,
    '輩' => 0xe79,
    '配' => 0xe7a,
    '倍' => 0xe7b,
    '培' => 0xe7c,
    '媒' => 0xe7d,
    '梅' => 0xe7e,
    '楳' => 0xe80,
    '煤' => 0xe81,
    '狽' => 0xe82,
    '買' => 0xe83,
    '売' => 0xe84,
    '賠' => 0xe85,
    '陪' => 0xe86,
    '這' => 0xe87,
    '蝿' => 0xe88,
    '秤' => 0xe89,
    '矧' => 0xe8a,
    '萩' => 0xe8b,
    '伯' => 0xe8c,
    '剥' => 0xe8d,
    '博' => 0xe8e,
    '拍' => 0xe8f,
    '柏' => 0xe90,
    '泊' => 0xe91,
    '白' => 0xe92,
    '箔' => 0xe93,
    '粕' => 0xe94,
    '舶' => 0xe95,
    '薄' => 0xe96,
    '迫' => 0xe97,
    '曝' => 0xe98,
    '漠' => 0xe99,
    '爆' => 0xe9a,
    '縛' => 0xe9b,
    '莫' => 0xe9c,
    '駁' => 0xe9d,
    '麦' => 0xe9e,
    '函' => 0xe9f,
    '箱' => 0xea0,
    '硲' => 0xea1,
    '箸' => 0xea2,
    '肇' => 0xea3,
    '筈' => 0xea4,
    '櫨' => 0xea5,
    '幡' => 0xea6,
    '肌' => 0xea7,
    '畑' => 0xea8,
    '畠' => 0xea9,
    '八' => 0xeaa,
    '鉢' => 0xeab,
    '溌' => 0xeac,
    '発' => 0xead,
    '醗' => 0xeae,
    '髪' => 0xeaf,
    '伐' => 0xeb0,
    '罰' => 0xeb1,
    '抜' => 0xeb2,
    '筏' => 0xeb3,
    '閥' => 0xeb4,
    '鳩' => 0xeb5,
    '噺' => 0xeb6,
    '塙' => 0xeb7,
    '蛤' => 0xeb8,
    '隼' => 0xeb9,
    '伴' => 0xeba,
    '判' => 0xebb,
    '半' => 0xebc,
    '反' => 0xebd,
    '叛' => 0xebe,
    '帆' => 0xebf,
    '搬' => 0xec0,
    '斑' => 0xec1,
    '板' => 0xec2,
    '氾' => 0xec3,
    '汎' => 0xec4,
    '版' => 0xec5,
    '犯' => 0xec6,
    '班' => 0xec7,
    '畔' => 0xec8,
    '繁' => 0xec9,
    '般' => 0xeca,
    '藩' => 0xecb,
    '販' => 0xecc,
    '範' => 0xecd,
    '釆' => 0xece,
    '煩' => 0xecf,
    '頒' => 0xed0,
    '飯' => 0xed1,
    '挽' => 0xed2,
    '晩' => 0xed3,
    '番' => 0xed4,
    '盤' => 0xed5,
    '磐' => 0xed6,
    '蕃' => 0xed7,
    '蛮' => 0xed8,
    '匪' => 0xed9,
    '卑' => 0xeda,
    '否' => 0xedb,
    '妃' => 0xedc,
    '庇' => 0xedd,
    '彼' => 0xede,
    '悲' => 0xedf,
    '扉' => 0xee0,
    '批' => 0xee1,
    '披' => 0xee2,
    '斐' => 0xee3,
    '比' => 0xee4,
    '泌' => 0xee5,
    '疲' => 0xee6,
    '皮' => 0xee7,
    '碑' => 0xee8,
    '秘' => 0xee9,
    '緋' => 0xeea,
    '罷' => 0xeeb,
    '肥' => 0xeec,
    '被' => 0xeed,
    '誹' => 0xeee,
    '費' => 0xeef,
    '避' => 0xef0,
    '非' => 0xef1,
    '飛' => 0xef2,
    '樋' => 0xef3,
    '簸' => 0xef4,
    '備' => 0xef5,
    '尾' => 0xef6,
    '微' => 0xef7,
    '枇' => 0xef8,
    '毘' => 0xef9,
    '琵' => 0xefa,
    '眉' => 0xefb,
    '美' => 0xefc,
    '鼻' => 0xf00,
    '柊' => 0xf01,
    '稗' => 0xf02,
    '匹' => 0xf03,
    '疋' => 0xf04,
    '髭' => 0xf05,
    '彦' => 0xf06,
    '膝' => 0xf07,
    '菱' => 0xf08,
    '肘' => 0xf09,
    '弼' => 0xf0a,
    '必' => 0xf0b,
    '畢' => 0xf0c,
    '筆' => 0xf0d,
    '逼' => 0xf0e,
    '桧' => 0xf0f,
    '姫' => 0xf10,
    '媛' => 0xf11,
    '紐' => 0xf12,
    '百' => 0xf13,
    '謬' => 0xf14,
    '俵' => 0xf15,
    '彪' => 0xf16,
    '標' => 0xf17,
    '氷' => 0xf18,
    '漂' => 0xf19,
    '瓢' => 0xf1a,
    '票' => 0xf1b,
    '表' => 0xf1c,
    '評' => 0xf1d,
    '豹' => 0xf1e,
    '廟' => 0xf1f,
    '描' => 0xf20,
    '病' => 0xf21,
    '秒' => 0xf22,
    '苗' => 0xf23,
    '錨' => 0xf24,
    '鋲' => 0xf25,
    '蒜' => 0xf26,
    '蛭' => 0xf27,
    '鰭' => 0xf28,
    '品' => 0xf29,
    '彬' => 0xf2a,
    '斌' => 0xf2b,
    '浜' => 0xf2c,
    '瀕' => 0xf2d,
    '貧' => 0xf2e,
    '賓' => 0xf2f,
    '頻' => 0xf30,
    '敏' => 0xf31,
    '瓶' => 0xf32,
    '不' => 0xf33,
    '付' => 0xf34,
    '埠' => 0xf35,
    '夫' => 0xf36,
    '婦' => 0xf37,
    '富' => 0xf38,
    '冨' => 0xf39,
    '布' => 0xf3a,
    '府' => 0xf3b,
    '怖' => 0xf3c,
    '扶' => 0xf3d,
    '敷' => 0xf3e,
    '斧' => 0xf40,
    '普' => 0xf41,
    '浮' => 0xf42,
    '父' => 0xf43,
    '符' => 0xf44,
    '腐' => 0xf45,
    '膚' => 0xf46,
    '芙' => 0xf47,
    '譜' => 0xf48,
    '負' => 0xf49,
    '賦' => 0xf4a,
    '赴' => 0xf4b,
    '阜' => 0xf4c,
    '附' => 0xf4d,
    '侮' => 0xf4e,
    '撫' => 0xf4f,
    '武' => 0xf50,
    '舞' => 0xf51,
    '葡' => 0xf52,
    '蕪' => 0xf53,
    '部' => 0xf54,
    '封' => 0xf55,
    '楓' => 0xf56,
    '風' => 0xf57,
    '葺' => 0xf58,
    '蕗' => 0xf59,
    '伏' => 0xf5a,
    '副' => 0xf5b,
    '復' => 0xf5c,
    '幅' => 0xf5d,
    '服' => 0xf5e,
    '福' => 0xf5f,
    '腹' => 0xf60,
    '複' => 0xf61,
    '覆' => 0xf62,
    '淵' => 0xf63,
    '弗' => 0xf64,
    '払' => 0xf65,
    '沸' => 0xf66,
    '仏' => 0xf67,
    '物' => 0xf68,
    '鮒' => 0xf69,
    '分' => 0xf6a,
    '吻' => 0xf6b,
    '噴' => 0xf6c,
    '墳' => 0xf6d,
    '憤' => 0xf6e,
    '扮' => 0xf6f,
    '焚' => 0xf70,
    '奮' => 0xf71,
    '粉' => 0xf72,
    '糞' => 0xf73,
    '紛' => 0xf74,
    '雰' => 0xf75,
    '文' => 0xf76,
    '聞' => 0xf77,
    '丙' => 0xf78,
    '併' => 0xf79,
    '兵' => 0xf7a,
    '塀' => 0xf7b,
    '幣' => 0xf7c,
    '平' => 0xf7d,
    '弊' => 0xf7e,
    '柄' => 0xf7f,
    '並' => 0xf80,
    '蔽' => 0xf81,
    '閉' => 0xf82,
    '陛' => 0xf83,
    '米' => 0xf84,
    '頁' => 0xf85,
    '僻' => 0xf86,
    '壁' => 0xf87,
    '癖' => 0xf88,
    '碧' => 0xf89,
    '別' => 0xf8a,
    '瞥' => 0xf8b,
    '蔑' => 0xf8c,
    '箆' => 0xf8d,
    '偏' => 0xf8e,
    '変' => 0xf8f,
    '片' => 0xf90,
    '篇' => 0xf91,
    '編' => 0xf92,
    '辺' => 0xf93,
    '返' => 0xf94,
    '遍' => 0xf95,
    '便' => 0xf96,
    '勉' => 0xf97,
    '娩' => 0xf98,
    '弁' => 0xf99,
    '鞭' => 0xf9a,
    '保' => 0xf9b,
    '舗' => 0xf9c,
    '鋪' => 0xf9d,
    '圃' => 0xf9e,
    '捕' => 0xf9f,
    '歩' => 0xfa0,
    '甫' => 0xfa1,
    '補' => 0xfa2,
    '輔' => 0xfa3,
    '穂' => 0xfa4,
    '募' => 0xfa5,
    '墓' => 0xfa6,
    '慕' => 0xfa7,
    '戊' => 0xfa8,
    '暮' => 0xfa9,
    '母' => 0xfaa,
    '簿' => 0xfab,
    '菩' => 0xfac,
    '倣' => 0xfad,
    '俸' => 0xfae,
    '包' => 0xfaf,
    '呆' => 0xfb0,
    '報' => 0xfb1,
    '奉' => 0xfb2,
    '宝' => 0xfb3,
    '峰' => 0xfb4,
    '峯' => 0xfb5,
    '崩' => 0xfb6,
    '庖' => 0xfb7,
    '抱' => 0xfb8,
    '捧' => 0xfb9,
    '放' => 0xfba,
    '方' => 0xfbb,
    '朋' => 0xfbc,
    '法' => 0xfc0,
    '泡' => 0xfc1,
    '烹' => 0xfc2,
    '砲' => 0xfc3,
    '縫' => 0xfc4,
    '胞' => 0xfc5,
    '芳' => 0xfc6,
    '萌' => 0xfc7,
    '蓬' => 0xfc8,
    '蜂' => 0xfc9,
    '褒' => 0xfca,
    '訪' => 0xfcb,
    '豊' => 0xfcc,
    '邦' => 0xfcd,
    '鋒' => 0xfce,
    '飽' => 0xfcf,
    '鳳' => 0xfd0,
    '鵬' => 0xfd1,
    '乏' => 0xfd2,
    '亡' => 0xfd3,
    '傍' => 0xfd4,
    '剖' => 0xfd5,
    '坊' => 0xfd6,
    '妨' => 0xfd7,
    '帽' => 0xfd8,
    '忘' => 0xfd9,
    '忙' => 0xfda,
    '房' => 0xfdb,
    '暴' => 0xfdc,
    '望' => 0xfdd,
    '某' => 0xfde,
    '棒' => 0xfdf,
    '冒' => 0xfe0,
    '紡' => 0xfe1,
    '肪' => 0xfe2,
    '膨' => 0xfe3,
    '謀' => 0xfe4,
    '貌' => 0xfe5,
    '貿' => 0xfe6,
    '鉾' => 0xfe7,
    '防' => 0xfe8,
    '吠' => 0xfe9,
    '頬' => 0xfea,
    '北' => 0xfeb,
    '僕' => 0xfec,
    '卜' => 0xfed,
    '墨' => 0xfee,
    '撲' => 0xfef,
    '朴' => 0xff0,
    '牧' => 0xff1,
    '睦' => 0xff2,
    '穆' => 0xff3,
    '釦' => 0xff4,
    '勃' => 0xff5,
    '没' => 0xff6,
    '殆' => 0xff7,
    '堀' => 0xff8,
    '幌' => 0xff9,
    '奔' => 0xffa,
    '本' => 0xffb,
    '翻' => 0xffc,
    '凡' => 0xffd,
    '盆' => 0xffe,
    '摩' => 0x1000,
    '磨' => 0x1001,
    '魔' => 0x1002,
    '麻' => 0x1003,
    '埋' => 0x1004,
    '妹' => 0x1005,
    '昧' => 0x1006,
    '枚' => 0x1007,
    '毎' => 0x1008,
    '哩' => 0x1009,
    '槙' => 0x100a,
    '幕' => 0x100b,
    '膜' => 0x100c,
    '枕' => 0x100d,
    '鮪' => 0x100e,
    '柾' => 0x100f,
    '鱒' => 0x1010,
    '桝' => 0x1011,
    '亦' => 0x1012,
    '俣' => 0x1013,
    '又' => 0x1014,
    '抹' => 0x1015,
    '末' => 0x1016,
    '沫' => 0x1017,
    '迄' => 0x1018,
    '侭' => 0x1019,
    '繭' => 0x101a,
    '麿' => 0x101b,
    '万' => 0x101c,
    '慢' => 0x101d,
    '満' => 0x101e,
    '漫' => 0x101f,
    '蔓' => 0x1020,
    '味' => 0x1021,
    '未' => 0x1022,
    '魅' => 0x1023,
    '巳' => 0x1024,
    '箕' => 0x1025,
    '岬' => 0x1026,
    '密' => 0x1027,
    '蜜' => 0x1028,
    '湊' => 0x1029,
    '蓑' => 0x102a,
    '稔' => 0x102b,
    '脈' => 0x102c,
    '妙' => 0x102d,
    '粍' => 0x102e,
    '民' => 0x102f,
    '眠' => 0x1030,
    '務' => 0x1031,
    '夢' => 0x1032,
    '無' => 0x1033,
    '牟' => 0x1034,
    '矛' => 0x1035,
    '霧' => 0x1036,
    '鵡' => 0x1037,
    '椋' => 0x1038,
    '婿' => 0x1039,
    '娘' => 0x103a,
    '冥' => 0x103b,
    '名' => 0x103c,
    '命' => 0x103d,
    '明' => 0x103e,
    '盟' => 0x103f,
    '迷' => 0x1040,
    '銘' => 0x1041,
    '鳴' => 0x1042,
    '姪' => 0x1043,
    '牝' => 0x1044,
    '滅' => 0x1045,
    '免' => 0x1046,
    '棉' => 0x1047,
    '綿' => 0x1048,
    '緬' => 0x1049,
    '面' => 0x104a,
    '麺' => 0x104b,
    '摸' => 0x104c,
    '模' => 0x104d,
    '茂' => 0x104e,
    '妄' => 0x104f,
    '孟' => 0x1050,
    '毛' => 0x1051,
    '猛' => 0x1052,
    '盲' => 0x1053,
    '網' => 0x1054,
    '耗' => 0x1055,
    '蒙' => 0x1056,
    '儲' => 0x1057,
    '木' => 0x1058,
    '黙' => 0x1059,
    '目' => 0x105a,
    '杢' => 0x105b,
    '勿' => 0x105c,
    '餅' => 0x105d,
    '尤' => 0x105e,
    '戻' => 0x105f,
    '籾' => 0x1060,
    '貰' => 0x1061,
    '問' => 0x1062,
    '悶' => 0x1063,
    '紋' => 0x1064,
    '門' => 0x1065,
    '匁' => 0x1066,
    '也' => 0x1067,
    '冶' => 0x1068,
    '夜' => 0x1069,
    '爺' => 0x106a,
    '耶' => 0x106b,
    '野' => 0x106c,
    '弥' => 0x106d,
    '矢' => 0x106e,
    '厄' => 0x106f,
    '役' => 0x1070,
    '約' => 0x1071,
    '薬' => 0x1072,
    '訳' => 0x1073,
    '躍' => 0x1074,
    '靖' => 0x1075,
    '柳' => 0x1076,
    '薮' => 0x1077,
    '鑓' => 0x1078,
    '愉' => 0x1079,
    '愈' => 0x107a,
    '油' => 0x107b,
    '癒' => 0x107c,
    '諭' => 0x1080,
    '輸' => 0x1081,
    '唯' => 0x1082,
    '佑' => 0x1083,
    '優' => 0x1084,
    '勇' => 0x1085,
    '友' => 0x1086,
    '宥' => 0x1087,
    '幽' => 0x1088,
    '悠' => 0x1089,
    '憂' => 0x108a,
    '揖' => 0x108b,
    '有' => 0x108c,
    '柚' => 0x108d,
    '湧' => 0x108e,
    '涌' => 0x108f,
    '猶' => 0x1090,
    '猷' => 0x1091,
    '由' => 0x1092,
    '祐' => 0x1093,
    '裕' => 0x1094,
    '誘' => 0x1095,
    '遊' => 0x1096,
    '邑' => 0x1097,
    '郵' => 0x1098,
    '雄' => 0x1099,
    '融' => 0x109a,
    '夕' => 0x109b,
    '予' => 0x109c,
    '余' => 0x109d,
    '与' => 0x109e,
    '誉' => 0x109f,
    '輿' => 0x10a0,
    '預' => 0x10a1,
    '傭' => 0x10a2,
    '幼' => 0x10a3,
    '妖' => 0x10a4,
    '容' => 0x10a5,
    '庸' => 0x10a6,
    '揚' => 0x10a7,
    '揺' => 0x10a8,
    '擁' => 0x10a9,
    '曜' => 0x10aa,
    '楊' => 0x10ab,
    '様' => 0x10ac,
    '洋' => 0x10ad,
    '溶' => 0x10ae,
    '熔' => 0x10af,
    '用' => 0x10b0,
    '窯' => 0x10b1,
    '羊' => 0x10b2,
    '耀' => 0x10b3,
    '葉' => 0x10b4,
    '蓉' => 0x10b5,
    '要' => 0x10b6,
    '謡' => 0x10b7,
    '踊' => 0x10b8,
    '遥' => 0x10b9,
    '陽' => 0x10ba,
    '養' => 0x10bb,
    '慾' => 0x10bc,
    '抑' => 0x10bd,
    '欲' => 0x10be,
    '沃' => 0x10c0,
    '浴' => 0x10c1,
    '翌' => 0x10c2,
    '翼' => 0x10c3,
    '淀' => 0x10c4,
    '羅' => 0x10c5,
    '螺' => 0x10c6,
    '裸' => 0x10c7,
    '来' => 0x10c8,
    '莱' => 0x10c9,
    '頼' => 0x10ca,
    '雷' => 0x10cb,
    '洛' => 0x10cc,
    '絡' => 0x10cd,
    '落' => 0x10ce,
    '酪' => 0x10cf,
    '乱' => 0x10d0,
    '卵' => 0x10d1,
    '嵐' => 0x10d2,
    '欄' => 0x10d3,
    '濫' => 0x10d4,
    '藍' => 0x10d5,
    '蘭' => 0x10d6,
    '覧' => 0x10d7,
    '利' => 0x10d8,
    '吏' => 0x10d9,
    '履' => 0x10da,
    '李' => 0x10db,
    '梨' => 0x10dc,
    '理' => 0x10dd,
    '璃' => 0x10de,
    '痢' => 0x10df,
    '裏' => 0x10e0,
    '裡' => 0x10e1,
    '里' => 0x10e2,
    '離' => 0x10e3,
    '陸' => 0x10e4,
    '律' => 0x10e5,
    '率' => 0x10e6,
    '立' => 0x10e7,
    '葎' => 0x10e8,
    '掠' => 0x10e9,
    '略' => 0x10ea,
    '劉' => 0x10eb,
    '流' => 0x10ec,
    '溜' => 0x10ed,
    '琉' => 0x10ee,
    '留' => 0x10ef,
    '硫' => 0x10f0,
    '粒' => 0x10f1,
    '隆' => 0x10f2,
    '竜' => 0x10f3,
    '龍' => 0x10f4,
    '侶' => 0x10f5,
    '慮' => 0x10f6,
    '旅' => 0x10f7,
    '虜' => 0x10f8,
    '了' => 0x10f9,
    '亮' => 0x10fa,
    '僚' => 0x10fb,
    '両' => 0x10fc,
    '凌' => 0x10fd,
    '寮' => 0x10fe,
    '料' => 0x10ff,
    '梁' => 0x1100,
    '涼' => 0x1101,
    '猟' => 0x1102,
    '療' => 0x1103,
    '瞭' => 0x1104,
    '稜' => 0x1105,
    '糧' => 0x1106,
    '良' => 0x1107,
    '諒' => 0x1108,
    '遼' => 0x1109,
    '量' => 0x110a,
    '陵' => 0x110b,
    '領' => 0x110c,
    '力' => 0x110d,
    '緑' => 0x110e,
    '倫' => 0x110f,
    '厘' => 0x1110,
    '林' => 0x1111,
    '淋' => 0x1112,
    '燐' => 0x1113,
    '琳' => 0x1114,
    '臨' => 0x1115,
    '輪' => 0x1116,
    '隣' => 0x1117,
    '鱗' => 0x1118,
    '麟' => 0x1119,
    '瑠' => 0x111a,
    '塁' => 0x111b,
    '涙' => 0x111c,
    '累' => 0x111d,
    '類' => 0x111e,
    '令' => 0x111f,
    '伶' => 0x1120,
    '例' => 0x1121,
    '冷' => 0x1122,
    '励' => 0x1123,
    '嶺' => 0x1124,
    '怜' => 0x1125,
    '玲' => 0x1126,
    '礼' => 0x1127,
    '苓' => 0x1128,
    '鈴' => 0x1129,
    '隷' => 0x112a,
    '零' => 0x112b,
    '霊' => 0x112c,
    '麗' => 0x112d,
    '齢' => 0x112e,
    '暦' => 0x112f,
    '歴' => 0x1130,
    '列' => 0x1131,
    '劣' => 0x1132,
    '烈' => 0x1133,
    '裂' => 0x1134,
    '廉' => 0x1135,
    '恋' => 0x1136,
    '憐' => 0x1137,
    '漣' => 0x1138,
    '煉' => 0x1139,
    '簾' => 0x113a,
    '練' => 0x113b,
    '聯' => 0x113c,
    '蓮' => 0x1140,
    '連' => 0x1141,
    '錬' => 0x1142,
    '呂' => 0x1143,
    '魯' => 0x1144,
    '櫓' => 0x1145,
    '炉' => 0x1146,
    '賂' => 0x1147,
    '路' => 0x1148,
    '露' => 0x1149,
    '労' => 0x114a,
    '婁' => 0x114b,
    '廊' => 0x114c,
    '弄' => 0x114d,
    '朗' => 0x114e,
    '楼' => 0x114f,
    '榔' => 0x1150,
    '浪' => 0x1151,
    '漏' => 0x1152,
    '牢' => 0x1153,
    '狼' => 0x1154,
    '篭' => 0x1155,
    '老' => 0x1156,
    '聾' => 0x1157,
    '蝋' => 0x1158,
    '郎' => 0x1159,
    '六' => 0x115a,
    '麓' => 0x115b,
    '禄' => 0x115c,
    '肋' => 0x115d,
    '録' => 0x115e,
    '論' => 0x115f,
    '倭' => 0x1160,
    '和' => 0x1161,
    '話' => 0x1162,
    '歪' => 0x1163,
    '賄' => 0x1164,
    '脇' => 0x1165,
    '惑' => 0x1166,
    '枠' => 0x1167,
    '鷲' => 0x1168,
    '亙' => 0x1169,
    '亘' => 0x116a,
    '鰐' => 0x116b,
    '詫' => 0x116c,
    '藁' => 0x116d,
    '蕨' => 0x116e,
    '椀' => 0x116f,
    '湾' => 0x1170,
    '碗' => 0x1171,
    '腕' => 0x1172,
    '弌' => 0x119f,
    '丐' => 0x11a0,
    '丕' => 0x11a1,
    '个' => 0x11a2,
    '丱' => 0x11a3,
    '丶' => 0x11a4,
    '丼' => 0x11a5,
    '丿' => 0x11a6,
    '乂' => 0x11a7,
    '乖' => 0x11a8,
    '乘' => 0x11a9,
    '亂' => 0x11aa,
    '亅' => 0x11ab,
    '豫' => 0x11ac,
    '亊' => 0x11ad,
    '舒' => 0x11ae,
    '弍' => 0x11af,
    '于' => 0x11b0,
    '亞' => 0x11b1,
    '亟' => 0x11b2,
    '亠' => 0x11b3,
    '亢' => 0x11b4,
    '亰' => 0x11b5,
    '亳' => 0x11b6,
    '亶' => 0x11b7,
    '从' => 0x11b8,
    '仍' => 0x11b9,
    '仄' => 0x11ba,
    '仆' => 0x11bb,
    '仂' => 0x11bc,
    '仗' => 0x11bd,
    '仞' => 0x11be,
    '仭' => 0x11bf,
    '仟' => 0x11c0,
    '价' => 0x11c1,
    '伉' => 0x11c2,
    '佚' => 0x11c3,
    '估' => 0x11c4,
    '佛' => 0x11c5,
    '佝' => 0x11c6,
    '佗' => 0x11c7,
    '佇' => 0x11c8,
    '佶' => 0x11c9,
    '侈' => 0x11ca,
    '侏' => 0x11cb,
    '侘' => 0x11cc,
    '佻' => 0x11cd,
    '佩' => 0x11ce,
    '佰' => 0x11cf,
    '侑' => 0x11d0,
    '佯' => 0x11d1,
    '來' => 0x11d2,
    '侖' => 0x11d3,
    '儘' => 0x11d4,
    '俔' => 0x11d5,
    '俟' => 0x11d6,
    '俎' => 0x11d7,
    '俘' => 0x11d8,
    '俛' => 0x11d9,
    '俑' => 0x11da,
    '俚' => 0x11db,
    '俐' => 0x11dc,
    '俤' => 0x11dd,
    '俥' => 0x11de,
    '倚' => 0x11df,
    '倨' => 0x11e0,
    '倔' => 0x11e1,
    '倪' => 0x11e2,
    '倥' => 0x11e3,
    '倅' => 0x11e4,
    '伜' => 0x11e5,
    '俶' => 0x11e6,
    '倡' => 0x11e7,
    '倩' => 0x11e8,
    '倬' => 0x11e9,
    '俾' => 0x11ea,
    '俯' => 0x11eb,
    '們' => 0x11ec,
    '倆' => 0x11ed,
    '偃' => 0x11ee,
    '假' => 0x11ef,
    '會' => 0x11f0,
    '偕' => 0x11f1,
    '偐' => 0x11f2,
    '偈' => 0x11f3,
    '做' => 0x11f4,
    '偖' => 0x11f5,
    '偬' => 0x11f6,
    '偸' => 0x11f7,
    '傀' => 0x11f8,
    '傚' => 0x11f9,
    '傅' => 0x11fa,
    '傴' => 0x11fb,
    '傲' => 0x11fc,
    '僉' => 0x1200,
    '僊' => 0x1201,
    '傳' => 0x1202,
    '僂' => 0x1203,
    '僖' => 0x1204,
    '僞' => 0x1205,
    '僥' => 0x1206,
    '僭' => 0x1207,
    '僣' => 0x1208,
    '僮' => 0x1209,
    '價' => 0x120a,
    '僵' => 0x120b,
    '儉' => 0x120c,
    '儁' => 0x120d,
    '儂' => 0x120e,
    '儖' => 0x120f,
    '儕' => 0x1210,
    '儔' => 0x1211,
    '儚' => 0x1212,
    '儡' => 0x1213,
    '儺' => 0x1214,
    '儷' => 0x1215,
    '儼' => 0x1216,
    '儻' => 0x1217,
    '儿' => 0x1218,
    '兀' => 0x1219,
    '兒' => 0x121a,
    '兌' => 0x121b,
    '兔' => 0x121c,
    '兢' => 0x121d,
    '竸' => 0x121e,
    '兩' => 0x121f,
    '兪' => 0x1220,
    '兮' => 0x1221,
    '冀' => 0x1222,
    '冂' => 0x1223,
    '囘' => 0x1224,
    '册' => 0x1225,
    '冉' => 0x1226,
    '冏' => 0x1227,
    '冑' => 0x1228,
    '冓' => 0x1229,
    '冕' => 0x122a,
    '冖' => 0x122b,
    '冤' => 0x122c,
    '冦' => 0x122d,
    '冢' => 0x122e,
    '冩' => 0x122f,
    '冪' => 0x1230,
    '冫' => 0x1231,
    '决' => 0x1232,
    '冱' => 0x1233,
    '冲' => 0x1234,
    '冰' => 0x1235,
    '况' => 0x1236,
    '冽' => 0x1237,
    '凅' => 0x1238,
    '凉' => 0x1239,
    '凛' => 0x123a,
    '几' => 0x123b,
    '處' => 0x123c,
    '凩' => 0x123d,
    '凭' => 0x123e,
    '凰' => 0x1240,
    '凵' => 0x1241,
    '凾' => 0x1242,
    '刄' => 0x1243,
    '刋' => 0x1244,
    '刔' => 0x1245,
    '刎' => 0x1246,
    '刧' => 0x1247,
    '刪' => 0x1248,
    '刮' => 0x1249,
    '刳' => 0x124a,
    '刹' => 0x124b,
    '剏' => 0x124c,
    '剄' => 0x124d,
    '剋' => 0x124e,
    '剌' => 0x124f,
    '剞' => 0x1250,
    '剔' => 0x1251,
    '剪' => 0x1252,
    '剴' => 0x1253,
    '剩' => 0x1254,
    '剳' => 0x1255,
    '剿' => 0x1256,
    '剽' => 0x1257,
    '劍' => 0x1258,
    '劔' => 0x1259,
    '劒' => 0x125a,
    '剱' => 0x125b,
    '劈' => 0x125c,
    '劑' => 0x125d,
    '辨' => 0x125e,
    '辧' => 0x125f,
    '劬' => 0x1260,
    '劭' => 0x1261,
    '劼' => 0x1262,
    '劵' => 0x1263,
    '勁' => 0x1264,
    '勍' => 0x1265,
    '勗' => 0x1266,
    '勞' => 0x1267,
    '勣' => 0x1268,
    '勦' => 0x1269,
    '飭' => 0x126a,
    '勠' => 0x126b,
    '勳' => 0x126c,
    '勵' => 0x126d,
    '勸' => 0x126e,
    '勹' => 0x126f,
    '匆' => 0x1270,
    '匈' => 0x1271,
    '甸' => 0x1272,
    '匍' => 0x1273,
    '匐' => 0x1274,
    '匏' => 0x1275,
    '匕' => 0x1276,
    '匚' => 0x1277,
    '匣' => 0x1278,
    '匯' => 0x1279,
    '匱' => 0x127a,
    '匳' => 0x127b,
    '匸' => 0x127c,
    '區' => 0x127d,
    '卆' => 0x127e,
    '卅' => 0x127f,
    '丗' => 0x1280,
    '卉' => 0x1281,
    '卍' => 0x1282,
    '凖' => 0x1283,
    '卞' => 0x1284,
    '卩' => 0x1285,
    '卮' => 0x1286,
    '夘' => 0x1287,
    '卻' => 0x1288,
    '卷' => 0x1289,
    '厂' => 0x128a,
    '厖' => 0x128b,
    '厠' => 0x128c,
    '厦' => 0x128d,
    '厥' => 0x128e,
    '厮' => 0x128f,
    '厰' => 0x1290,
    '厶' => 0x1291,
    '參' => 0x1292,
    '簒' => 0x1293,
    '雙' => 0x1294,
    '叟' => 0x1295,
    '曼' => 0x1296,
    '燮' => 0x1297,
    '叮' => 0x1298,
    '叨' => 0x1299,
    '叭' => 0x129a,
    '叺' => 0x129b,
    '吁' => 0x129c,
    '吽' => 0x129d,
    '呀' => 0x129e,
    '听' => 0x129f,
    '吭' => 0x12a0,
    '吼' => 0x12a1,
    '吮' => 0x12a2,
    '吶' => 0x12a3,
    '吩' => 0x12a4,
    '吝' => 0x12a5,
    '呎' => 0x12a6,
    '咏' => 0x12a7,
    '呵' => 0x12a8,
    '咎' => 0x12a9,
    '呟' => 0x12aa,
    '呱' => 0x12ab,
    '呷' => 0x12ac,
    '呰' => 0x12ad,
    '咒' => 0x12ae,
    '呻' => 0x12af,
    '咀' => 0x12b0,
    '呶' => 0x12b1,
    '咄' => 0x12b2,
    '咐' => 0x12b3,
    '咆' => 0x12b4,
    '哇' => 0x12b5,
    '咢' => 0x12b6,
    '咸' => 0x12b7,
    '咥' => 0x12b8,
    '咬' => 0x12b9,
    '哄' => 0x12ba,
    '哈' => 0x12bb,
    '咨' => 0x12bc,
    '咫' => 0x12c0,
    '哂' => 0x12c1,
    '咤' => 0x12c2,
    '咾' => 0x12c3,
    '咼' => 0x12c4,
    '哘' => 0x12c5,
    '哥' => 0x12c6,
    '哦' => 0x12c7,
    '唏' => 0x12c8,
    '唔' => 0x12c9,
    '哽' => 0x12ca,
    '哮' => 0x12cb,
    '哭' => 0x12cc,
    '哺' => 0x12cd,
    '哢' => 0x12ce,
    '唹' => 0x12cf,
    '啀' => 0x12d0,
    '啣' => 0x12d1,
    '啌' => 0x12d2,
    '售' => 0x12d3,
    '啜' => 0x12d4,
    '啅' => 0x12d5,
    '啖' => 0x12d6,
    '啗' => 0x12d7,
    '唸' => 0x12d8,
    '唳' => 0x12d9,
    '啝' => 0x12da,
    '喙' => 0x12db,
    '喀' => 0x12dc,
    '咯' => 0x12dd,
    '喊' => 0x12de,
    '喟' => 0x12df,
    '啻' => 0x12e0,
    '啾' => 0x12e1,
    '喘' => 0x12e2,
    '喞' => 0x12e3,
    '單' => 0x12e4,
    '啼' => 0x12e5,
    '喃' => 0x12e6,
    '喩' => 0x12e7,
    '喇' => 0x12e8,
    '喨' => 0x12e9,
    '嗚' => 0x12ea,
    '嗅' => 0x12eb,
    '嗟' => 0x12ec,
    '嗄' => 0x12ed,
    '嗜' => 0x12ee,
    '嗤' => 0x12ef,
    '嗔' => 0x12f0,
    '嘔' => 0x12f1,
    '嗷' => 0x12f2,
    '嘖' => 0x12f3,
    '嗾' => 0x12f4,
    '嗽' => 0x12f5,
    '嘛' => 0x12f6,
    '嗹' => 0x12f7,
    '噎' => 0x12f8,
    '噐' => 0x12f9,
    '營' => 0x12fa,
    '嘴' => 0x12fb,
    '嘶' => 0x12fc,
    '嘲' => 0x12fd,
    '嘸' => 0x12fe,
    '噫' => 0x1300,
    '噤' => 0x1301,
    '嘯' => 0x1302,
    '噬' => 0x1303,
    '噪' => 0x1304,
    '嚆' => 0x1305,
    '嚀' => 0x1306,
    '嚊' => 0x1307,
    '嚠' => 0x1308,
    '嚔' => 0x1309,
    '嚏' => 0x130a,
    '嚥' => 0x130b,
    '嚮' => 0x130c,
    '嚶' => 0x130d,
    '嚴' => 0x130e,
    '囂' => 0x130f,
    '嚼' => 0x1310,
    '囁' => 0x1311,
    '囃' => 0x1312,
    '囀' => 0x1313,
    '囈' => 0x1314,
    '囎' => 0x1315,
    '囑' => 0x1316,
    '囓' => 0x1317,
    '囗' => 0x1318,
    '囮' => 0x1319,
    '囹' => 0x131a,
    '圀' => 0x131b,
    '囿' => 0x131c,
    '圄' => 0x131d,
    '圉' => 0x131e,
    '圈' => 0x131f,
    '國' => 0x1320,
    '圍' => 0x1321,
    '圓' => 0x1322,
    '團' => 0x1323,
    '圖' => 0x1324,
    '嗇' => 0x1325,
    '圜' => 0x1326,
    '圦' => 0x1327,
    '圷' => 0x1328,
    '圸' => 0x1329,
    '坎' => 0x132a,
    '圻' => 0x132b,
    '址' => 0x132c,
    '坏' => 0x132d,
    '坩' => 0x132e,
    '埀' => 0x132f,
    '垈' => 0x1330,
    '坡' => 0x1331,
    '坿' => 0x1332,
    '垉' => 0x1333,
    '垓' => 0x1334,
    '垠' => 0x1335,
    '垳' => 0x1336,
    '垤' => 0x1337,
    '垪' => 0x1338,
    '垰' => 0x1339,
    '埃' => 0x133a,
    '埆' => 0x133b,
    '埔' => 0x133c,
    '埒' => 0x133d,
    '埓' => 0x133e,
    '堊' => 0x133f,
    '埖' => 0x1340,
    '埣' => 0x1341,
    '堋' => 0x1342,
    '堙' => 0x1343,
    '堝' => 0x1344,
    '塲' => 0x1345,
    '堡' => 0x1346,
    '塢' => 0x1347,
    '塋' => 0x1348,
    '塰' => 0x1349,
    '毀' => 0x134a,
    '塒' => 0x134b,
    '堽' => 0x134c,
    '塹' => 0x134d,
    '墅' => 0x134e,
    '墹' => 0x134f,
    '墟' => 0x1350,
    '墫' => 0x1351,
    '墺' => 0x1352,
    '壞' => 0x1353,
    '墻' => 0x1354,
    '墸' => 0x1355,
    '墮' => 0x1356,
    '壅' => 0x1357,
    '壓' => 0x1358,
    '壑' => 0x1359,
    '壗' => 0x135a,
    '壙' => 0x135b,
    '壘' => 0x135c,
    '壥' => 0x135d,
    '壜' => 0x135e,
    '壤' => 0x135f,
    '壟' => 0x1360,
    '壯' => 0x1361,
    '壺' => 0x1362,
    '壹' => 0x1363,
    '壻' => 0x1364,
    '壼' => 0x1365,
    '壽' => 0x1366,
    '夂' => 0x1367,
    '夊' => 0x1368,
    '夐' => 0x1369,
    '夛' => 0x136a,
    '梦' => 0x136b,
    '夥' => 0x136c,
    '夬' => 0x136d,
    '夭' => 0x136e,
    '夲' => 0x136f,
    '夸' => 0x1370,
    '夾' => 0x1371,
    '竒' => 0x1372,
    '奕' => 0x1373,
    '奐' => 0x1374,
    '奎' => 0x1375,
    '奚' => 0x1376,
    '奘' => 0x1377,
    '奢' => 0x1378,
    '奠' => 0x1379,
    '奧' => 0x137a,
    '奬' => 0x137b,
    '奩' => 0x137c,
    '奸' => 0x1380,
    '妁' => 0x1381,
    '妝' => 0x1382,
    '佞' => 0x1383,
    '侫' => 0x1384,
    '妣' => 0x1385,
    '妲' => 0x1386,
    '姆' => 0x1387,
    '姨' => 0x1388,
    '姜' => 0x1389,
    '妍' => 0x138a,
    '姙' => 0x138b,
    '姚' => 0x138c,
    '娥' => 0x138d,
    '娟' => 0x138e,
    '娑' => 0x138f,
    '娜' => 0x1390,
    '娉' => 0x1391,
    '娚' => 0x1392,
    '婀' => 0x1393,
    '婬' => 0x1394,
    '婉' => 0x1395,
    '娵' => 0x1396,
    '娶' => 0x1397,
    '婢' => 0x1398,
    '婪' => 0x1399,
    '媚' => 0x139a,
    '媼' => 0x139b,
    '媾' => 0x139c,
    '嫋' => 0x139d,
    '嫂' => 0x139e,
    '媽' => 0x139f,
    '嫣' => 0x13a0,
    '嫗' => 0x13a1,
    '嫦' => 0x13a2,
    '嫩' => 0x13a3,
    '嫖' => 0x13a4,
    '嫺' => 0x13a5,
    '嫻' => 0x13a6,
    '嬌' => 0x13a7,
    '嬋' => 0x13a8,
    '嬖' => 0x13a9,
    '嬲' => 0x13aa,
    '嫐' => 0x13ab,
    '嬪' => 0x13ac,
    '嬶' => 0x13ad,
    '嬾' => 0x13ae,
    '孃' => 0x13af,
    '孅' => 0x13b0,
    '孀' => 0x13b1,
    '孑' => 0x13b2,
    '孕' => 0x13b3,
    '孚' => 0x13b4,
    '孛' => 0x13b5,
    '孥' => 0x13b6,
    '孩' => 0x13b7,
    '孰' => 0x13b8,
    '孳' => 0x13b9,
    '孵' => 0x13ba,
    '學' => 0x13bb,
    '斈' => 0x13bc,
    '孺' => 0x13bd,
    '宀' => 0x13be,
    '它' => 0x13c0,
    '宦' => 0x13c1,
    '宸' => 0x13c2,
    '寃' => 0x13c3,
    '寇' => 0x13c4,
    '寉' => 0x13c5,
    '寔' => 0x13c6,
    '寐' => 0x13c7,
    '寤' => 0x13c8,
    '實' => 0x13c9,
    '寢' => 0x13ca,
    '寞' => 0x13cb,
    '寥' => 0x13cc,
    '寫' => 0x13cd,
    '寰' => 0x13ce,
    '寶' => 0x13cf,
    '寳' => 0x13d0,
    '尅' => 0x13d1,
    '將' => 0x13d2,
    '專' => 0x13d3,
    '對' => 0x13d4,
    '尓' => 0x13d5,
    '尠' => 0x13d6,
    '尢' => 0x13d7,
    '尨' => 0x13d8,
    '尸' => 0x13d9,
    '尹' => 0x13da,
    '屁' => 0x13db,
    '屆' => 0x13dc,
    '屎' => 0x13dd,
    '屓' => 0x13de,
    '屐' => 0x13df,
    '屏' => 0x13e0,
    '孱' => 0x13e1,
    '屬' => 0x13e2,
    '屮' => 0x13e3,
    '乢' => 0x13e4,
    '屶' => 0x13e5,
    '屹' => 0x13e6,
    '岌' => 0x13e7,
    '岑' => 0x13e8,
    '岔' => 0x13e9,
    '妛' => 0x13ea,
    '岫' => 0x13eb,
    '岻' => 0x13ec,
    '岶' => 0x13ed,
    '岼' => 0x13ee,
    '岷' => 0x13ef,
    '峅' => 0x13f0,
    '岾' => 0x13f1,
    '峇' => 0x13f2,
    '峙' => 0x13f3,
    '峩' => 0x13f4,
    '峽' => 0x13f5,
    '峺' => 0x13f6,
    '峭' => 0x13f7,
    '嶌' => 0x13f8,
    '峪' => 0x13f9,
    '崋' => 0x13fa,
    '崕' => 0x13fb,
    '崗' => 0x13fc,
    '嵜' => 0x13fd,
    '崟' => 0x13fe,
    '崛' => 0x13ff,
    '崑' => 0x1400,
    '崔' => 0x1401,
    '崢' => 0x1402,
    '崚' => 0x1403,
    '崙' => 0x1404,
    '崘' => 0x1405,
    '嵌' => 0x1406,
    '嵒' => 0x1407,
    '嵎' => 0x1408,
    '嵋' => 0x1409,
    '嵬' => 0x140a,
    '嵳' => 0x140b,
    '嵶' => 0x140c,
    '嶇' => 0x140d,
    '嶄' => 0x140e,
    '嶂' => 0x140f,
    '嶢' => 0x1410,
    '嶝' => 0x1411,
    '嶬' => 0x1412,
    '嶮' => 0x1413,
    '嶽' => 0x1414,
    '嶐' => 0x1415,
    '嶷' => 0x1416,
    '嶼' => 0x1417,
    '巉' => 0x1418,
    '巍' => 0x1419,
    '巓' => 0x141a,
    '巒' => 0x141b,
    '巖' => 0x141c,
    '巛' => 0x141d,
    '巫' => 0x141e,
    '已' => 0x141f,
    '巵' => 0x1420,
    '帋' => 0x1421,
    '帚' => 0x1422,
    '帙' => 0x1423,
    '帑' => 0x1424,
    '帛' => 0x1425,
    '帶' => 0x1426,
    '帷' => 0x1427,
    '幄' => 0x1428,
    '幃' => 0x1429,
    '幀' => 0x142a,
    '幎' => 0x142b,
    '幗' => 0x142c,
    '幔' => 0x142d,
    '幟' => 0x142e,
    '幢' => 0x142f,
    '幤' => 0x1430,
    '幇' => 0x1431,
    '幵' => 0x1432,
    '并' => 0x1433,
    '幺' => 0x1434,
    '麼' => 0x1435,
    '广' => 0x1436,
    '庠' => 0x1437,
    '廁' => 0x1438,
    '廂' => 0x1439,
    '廈' => 0x143a,
    '廐' => 0x143b,
    '廏' => 0x143c,
    '廖' => 0x1440,
    '廣' => 0x1441,
    '廝' => 0x1442,
    '廚' => 0x1443,
    '廛' => 0x1444,
    '廢' => 0x1445,
    '廡' => 0x1446,
    '廨' => 0x1447,
    '廩' => 0x1448,
    '廬' => 0x1449,
    '廱' => 0x144a,
    '廳' => 0x144b,
    '廰' => 0x144c,
    '廴' => 0x144d,
    '廸' => 0x144e,
    '廾' => 0x144f,
    '弃' => 0x1450,
    '弉' => 0x1451,
    '彝' => 0x1452,
    '彜' => 0x1453,
    '弋' => 0x1454,
    '弑' => 0x1455,
    '弖' => 0x1456,
    '弩' => 0x1457,
    '弭' => 0x1458,
    '弸' => 0x1459,
    '彁' => 0x145a,
    '彈' => 0x145b,
    '彌' => 0x145c,
    '彎' => 0x145d,
    '弯' => 0x145e,
    '彑' => 0x145f,
    '彖' => 0x1460,
    '彗' => 0x1461,
    '彙' => 0x1462,
    '彡' => 0x1463,
    '彭' => 0x1464,
    '彳' => 0x1465,
    '彷' => 0x1466,
    '徃' => 0x1467,
    '徂' => 0x1468,
    '彿' => 0x1469,
    '徊' => 0x146a,
    '很' => 0x146b,
    '徑' => 0x146c,
    '徇' => 0x146d,
    '從' => 0x146e,
    '徙' => 0x146f,
    '徘' => 0x1470,
    '徠' => 0x1471,
    '徨' => 0x1472,
    '徭' => 0x1473,
    '徼' => 0x1474,
    '忖' => 0x1475,
    '忻' => 0x1476,
    '忤' => 0x1477,
    '忸' => 0x1478,
    '忱' => 0x1479,
    '忝' => 0x147a,
    '悳' => 0x147b,
    '忿' => 0x147c,
    '怡' => 0x147d,
    '恠' => 0x147e,
    '怙' => 0x1480,
    '怐' => 0x1481,
    '怩' => 0x1482,
    '怎' => 0x1483,
    '怱' => 0x1484,
    '怛' => 0x1485,
    '怕' => 0x1486,
    '怫' => 0x1487,
    '怦' => 0x1488,
    '怏' => 0x1489,
    '怺' => 0x148a,
    '恚' => 0x148b,
    '恁' => 0x148c,
    '恪' => 0x148d,
    '恷' => 0x148e,
    '恟' => 0x148f,
    '恊' => 0x1490,
    '恆' => 0x1491,
    '恍' => 0x1492,
    '恣' => 0x1493,
    '恃' => 0x1494,
    '恤' => 0x1495,
    '恂' => 0x1496,
    '恬' => 0x1497,
    '恫' => 0x1498,
    '恙' => 0x1499,
    '悁' => 0x149a,
    '悍' => 0x149b,
    '惧' => 0x149c,
    '悃' => 0x149d,
    '悚' => 0x149e,
    '悄' => 0x149f,
    '悛' => 0x14a0,
    '悖' => 0x14a1,
    '悗' => 0x14a2,
    '悒' => 0x14a3,
    '悧' => 0x14a4,
    '悋' => 0x14a5,
    '惡' => 0x14a6,
    '悸' => 0x14a7,
    '惠' => 0x14a8,
    '惓' => 0x14a9,
    '悴' => 0x14aa,
    '忰' => 0x14ab,
    '悽' => 0x14ac,
    '惆' => 0x14ad,
    '悵' => 0x14ae,
    '惘' => 0x14af,
    '慍' => 0x14b0,
    '愕' => 0x14b1,
    '愆' => 0x14b2,
    '惶' => 0x14b3,
    '惷' => 0x14b4,
    '愀' => 0x14b5,
    '惴' => 0x14b6,
    '惺' => 0x14b7,
    '愃' => 0x14b8,
    '愡' => 0x14b9,
    '惻' => 0x14ba,
    '惱' => 0x14bb,
    '愍' => 0x14bc,
    '愎' => 0x14bd,
    '慇' => 0x14be,
    '愾' => 0x14bf,
    '愨' => 0x14c0,
    '愧' => 0x14c1,
    '慊' => 0x14c2,
    '愿' => 0x14c3,
    '愼' => 0x14c4,
    '愬' => 0x14c5,
    '愴' => 0x14c6,
    '愽' => 0x14c7,
    '慂' => 0x14c8,
    '慄' => 0x14c9,
    '慳' => 0x14ca,
    '慷' => 0x14cb,
    '慘' => 0x14cc,
    '慙' => 0x14cd,
    '慚' => 0x14ce,
    '慫' => 0x14cf,
    '慴' => 0x14d0,
    '慯' => 0x14d1,
    '慥' => 0x14d2,
    '慱' => 0x14d3,
    '慟' => 0x14d4,
    '慝' => 0x14d5,
    '慓' => 0x14d6,
    '慵' => 0x14d7,
    '憙' => 0x14d8,
    '憖' => 0x14d9,
    '憇' => 0x14da,
    '憬' => 0x14db,
    '憔' => 0x14dc,
    '憚' => 0x14dd,
    '憊' => 0x14de,
    '憑' => 0x14df,
    '憫' => 0x14e0,
    '憮' => 0x14e1,
    '懌' => 0x14e2,
    '懊' => 0x14e3,
    '應' => 0x14e4,
    '懷' => 0x14e5,
    '懈' => 0x14e6,
    '懃' => 0x14e7,
    '懆' => 0x14e8,
    '憺' => 0x14e9,
    '懋' => 0x14ea,
    '罹' => 0x14eb,
    '懍' => 0x14ec,
    '懦' => 0x14ed,
    '懣' => 0x14ee,
    '懶' => 0x14ef,
    '懺' => 0x14f0,
    '懴' => 0x14f1,
    '懿' => 0x14f2,
    '懽' => 0x14f3,
    '懼' => 0x14f4,
    '懾' => 0x14f5,
    '戀' => 0x14f6,
    '戈' => 0x14f7,
    '戉' => 0x14f8,
    '戍' => 0x14f9,
    '戌' => 0x14fa,
    '戔' => 0x14fb,
    '戛' => 0x14fc,
    '戞' => 0x1500,
    '戡' => 0x1501,
    '截' => 0x1502,
    '戮' => 0x1503,
    '戰' => 0x1504,
    '戲' => 0x1505,
    '戳' => 0x1506,
    '扁' => 0x1507,
    '扎' => 0x1508,
    '扞' => 0x1509,
    '扣' => 0x150a,
    '扛' => 0x150b,
    '扠' => 0x150c,
    '扨' => 0x150d,
    '扼' => 0x150e,
    '抂' => 0x150f,
    '抉' => 0x1510,
    '找' => 0x1511,
    '抒' => 0x1512,
    '抓' => 0x1513,
    '抖' => 0x1514,
    '拔' => 0x1515,
    '抃' => 0x1516,
    '抔' => 0x1517,
    '拗' => 0x1518,
    '拑' => 0x1519,
    '抻' => 0x151a,
    '拏' => 0x151b,
    '拿' => 0x151c,
    '拆' => 0x151d,
    '擔' => 0x151e,
    '拈' => 0x151f,
    '拜' => 0x1520,
    '拌' => 0x1521,
    '拊' => 0x1522,
    '拂' => 0x1523,
    '拇' => 0x1524,
    '抛' => 0x1525,
    '拉' => 0x1526,
    '挌' => 0x1527,
    '拮' => 0x1528,
    '拱' => 0x1529,
    '挧' => 0x152a,
    '挂' => 0x152b,
    '挈' => 0x152c,
    '拯' => 0x152d,
    '拵' => 0x152e,
    '捐' => 0x152f,
    '挾' => 0x1530,
    '捍' => 0x1531,
    '搜' => 0x1532,
    '捏' => 0x1533,
    '掖' => 0x1534,
    '掎' => 0x1535,
    '掀' => 0x1536,
    '掫' => 0x1537,
    '捶' => 0x1538,
    '掣' => 0x1539,
    '掏' => 0x153a,
    '掉' => 0x153b,
    '掟' => 0x153c,
    '掵' => 0x153d,
    '捫' => 0x153e,
    '捩' => 0x1540,
    '掾' => 0x1541,
    '揩' => 0x1542,
    '揀' => 0x1543,
    '揆' => 0x1544,
    '揣' => 0x1545,
    '揉' => 0x1546,
    '插' => 0x1547,
    '揶' => 0x1548,
    '揄' => 0x1549,
    '搖' => 0x154a,
    '搴' => 0x154b,
    '搆' => 0x154c,
    '搓' => 0x154d,
    '搦' => 0x154e,
    '搶' => 0x154f,
    '攝' => 0x1550,
    '搗' => 0x1551,
    '搨' => 0x1552,
    '搏' => 0x1553,
    '摧' => 0x1554,
    '摯' => 0x1555,
    '摶' => 0x1556,
    '摎' => 0x1557,
    '攪' => 0x1558,
    '撕' => 0x1559,
    '撓' => 0x155a,
    '撥' => 0x155b,
    '撩' => 0x155c,
    '撈' => 0x155d,
    '撼' => 0x155e,
    '據' => 0x155f,
    '擒' => 0x1560,
    '擅' => 0x1561,
    '擇' => 0x1562,
    '撻' => 0x1563,
    '擘' => 0x1564,
    '擂' => 0x1565,
    '擱' => 0x1566,
    '擧' => 0x1567,
    '舉' => 0x1568,
    '擠' => 0x1569,
    '擡' => 0x156a,
    '抬' => 0x156b,
    '擣' => 0x156c,
    '擯' => 0x156d,
    '攬' => 0x156e,
    '擶' => 0x156f,
    '擴' => 0x1570,
    '擲' => 0x1571,
    '擺' => 0x1572,
    '攀' => 0x1573,
    '擽' => 0x1574,
    '攘' => 0x1575,
    '攜' => 0x1576,
    '攅' => 0x1577,
    '攤' => 0x1578,
    '攣' => 0x1579,
    '攫' => 0x157a,
    '攴' => 0x157b,
    '攵' => 0x157c,
    '攷' => 0x157d,
    '收' => 0x157e,
    '攸' => 0x157f,
    '畋' => 0x1580,
    '效' => 0x1581,
    '敖' => 0x1582,
    '敕' => 0x1583,
    '敍' => 0x1584,
    '敘' => 0x1585,
    '敞' => 0x1586,
    '敝' => 0x1587,
    '敲' => 0x1588,
    '數' => 0x1589,
    '斂' => 0x158a,
    '斃' => 0x158b,
    '變' => 0x158c,
    '斛' => 0x158d,
    '斟' => 0x158e,
    '斫' => 0x158f,
    '斷' => 0x1590,
    '旃' => 0x1591,
    '旆' => 0x1592,
    '旁' => 0x1593,
    '旄' => 0x1594,
    '旌' => 0x1595,
    '旒' => 0x1596,
    '旛' => 0x1597,
    '旙' => 0x1598,
    '无' => 0x1599,
    '旡' => 0x159a,
    '旱' => 0x159b,
    '杲' => 0x159c,
    '昊' => 0x159d,
    '昃' => 0x159e,
    '旻' => 0x159f,
    '杳' => 0x15a0,
    '昵' => 0x15a1,
    '昶' => 0x15a2,
    '昴' => 0x15a3,
    '昜' => 0x15a4,
    '晏' => 0x15a5,
    '晄' => 0x15a6,
    '晉' => 0x15a7,
    '晁' => 0x15a8,
    '晞' => 0x15a9,
    '晝' => 0x15aa,
    '晤' => 0x15ab,
    '晧' => 0x15ac,
    '晨' => 0x15ad,
    '晟' => 0x15ae,
    '晢' => 0x15af,
    '晰' => 0x15b0,
    '暃' => 0x15b1,
    '暈' => 0x15b2,
    '暎' => 0x15b3,
    '暉' => 0x15b4,
    '暄' => 0x15b5,
    '暘' => 0x15b6,
    '暝' => 0x15b7,
    '曁' => 0x15b8,
    '暹' => 0x15b9,
    '曉' => 0x15ba,
    '暾' => 0x15bb,
    '暼' => 0x15bc,
    '曄' => 0x15c0,
    '暸' => 0x15c1,
    '曖' => 0x15c2,
    '曚' => 0x15c3,
    '曠' => 0x15c4,
    '昿' => 0x15c5,
    '曦' => 0x15c6,
    '曩' => 0x15c7,
    '曰' => 0x15c8,
    '曵' => 0x15c9,
    '曷' => 0x15ca,
    '朏' => 0x15cb,
    '朖' => 0x15cc,
    '朞' => 0x15cd,
    '朦' => 0x15ce,
    '朧' => 0x15cf,
    '霸' => 0x15d0,
    '朮' => 0x15d1,
    '朿' => 0x15d2,
    '朶' => 0x15d3,
    '杁' => 0x15d4,
    '朸' => 0x15d5,
    '朷' => 0x15d6,
    '杆' => 0x15d7,
    '杞' => 0x15d8,
    '杠' => 0x15d9,
    '杙' => 0x15da,
    '杣' => 0x15db,
    '杤' => 0x15dc,
    '枉' => 0x15dd,
    '杰' => 0x15de,
    '枩' => 0x15df,
    '杼' => 0x15e0,
    '杪' => 0x15e1,
    '枌' => 0x15e2,
    '枋' => 0x15e3,
    '枦' => 0x15e4,
    '枡' => 0x15e5,
    '枅' => 0x15e6,
    '枷' => 0x15e7,
    '柯' => 0x15e8,
    '枴' => 0x15e9,
    '柬' => 0x15ea,
    '枳' => 0x15eb,
    '柩' => 0x15ec,
    '枸' => 0x15ed,
    '柤' => 0x15ee,
    '柞' => 0x15ef,
    '柝' => 0x15f0,
    '柢' => 0x15f1,
    '柮' => 0x15f2,
    '枹' => 0x15f3,
    '柎' => 0x15f4,
    '柆' => 0x15f5,
    '柧' => 0x15f6,
    '檜' => 0x15f7,
    '栞' => 0x15f8,
    '框' => 0x15f9,
    '栩' => 0x15fa,
    '桀' => 0x15fb,
    '桍' => 0x15fc,
    '栲' => 0x15fd,
    '桎' => 0x15fe,
    '梳' => 0x1600,
    '栫' => 0x1601,
    '桙' => 0x1602,
    '档' => 0x1603,
    '桷' => 0x1604,
    '桿' => 0x1605,
    '梟' => 0x1606,
    '梏' => 0x1607,
    '梭' => 0x1608,
    '梔' => 0x1609,
    '條' => 0x160a,
    '梛' => 0x160b,
    '梃' => 0x160c,
    '檮' => 0x160d,
    '梹' => 0x160e,
    '桴' => 0x160f,
    '梵' => 0x1610,
    '梠' => 0x1611,
    '梺' => 0x1612,
    '椏' => 0x1613,
    '梍' => 0x1614,
    '桾' => 0x1615,
    '椁' => 0x1616,
    '棊' => 0x1617,
    '椈' => 0x1618,
    '棘' => 0x1619,
    '椢' => 0x161a,
    '椦' => 0x161b,
    '棡' => 0x161c,
    '椌' => 0x161d,
    '棍' => 0x161e,
    '棔' => 0x161f,
    '棧' => 0x1620,
    '棕' => 0x1621,
    '椶' => 0x1622,
    '椒' => 0x1623,
    '椄' => 0x1624,
    '棗' => 0x1625,
    '棣' => 0x1626,
    '椥' => 0x1627,
    '棹' => 0x1628,
    '棠' => 0x1629,
    '棯' => 0x162a,
    '椨' => 0x162b,
    '椪' => 0x162c,
    '椚' => 0x162d,
    '椣' => 0x162e,
    '椡' => 0x162f,
    '棆' => 0x1630,
    '楹' => 0x1631,
    '楷' => 0x1632,
    '楜' => 0x1633,
    '楸' => 0x1634,
    '楫' => 0x1635,
    '楔' => 0x1636,
    '楾' => 0x1637,
    '楮' => 0x1638,
    '椹' => 0x1639,
    '楴' => 0x163a,
    '椽' => 0x163b,
    '楙' => 0x163c,
    '椰' => 0x163d,
    '楡' => 0x163e,
    '楞' => 0x163f,
    '楝' => 0x1640,
    '榁' => 0x1641,
    '楪' => 0x1642,
    '榲' => 0x1643,
    '榮' => 0x1644,
    '槐' => 0x1645,
    '榿' => 0x1646,
    '槁' => 0x1647,
    '槓' => 0x1648,
    '榾' => 0x1649,
    '槎' => 0x164a,
    '寨' => 0x164b,
    '槊' => 0x164c,
    '槝' => 0x164d,
    '榻' => 0x164e,
    '槃' => 0x164f,
    '榧' => 0x1650,
    '樮' => 0x1651,
    '榑' => 0x1652,
    '榠' => 0x1653,
    '榜' => 0x1654,
    '榕' => 0x1655,
    '榴' => 0x1656,
    '槞' => 0x1657,
    '槨' => 0x1658,
    '樂' => 0x1659,
    '樛' => 0x165a,
    '槿' => 0x165b,
    '權' => 0x165c,
    '槹' => 0x165d,
    '槲' => 0x165e,
    '槧' => 0x165f,
    '樅' => 0x1660,
    '榱' => 0x1661,
    '樞' => 0x1662,
    '槭' => 0x1663,
    '樔' => 0x1664,
    '槫' => 0x1665,
    '樊' => 0x1666,
    '樒' => 0x1667,
    '櫁' => 0x1668,
    '樣' => 0x1669,
    '樓' => 0x166a,
    '橄' => 0x166b,
    '樌' => 0x166c,
    '橲' => 0x166d,
    '樶' => 0x166e,
    '橸' => 0x166f,
    '橇' => 0x1670,
    '橢' => 0x1671,
    '橙' => 0x1672,
    '橦' => 0x1673,
    '橈' => 0x1674,
    '樸' => 0x1675,
    '樢' => 0x1676,
    '檐' => 0x1677,
    '檍' => 0x1678,
    '檠' => 0x1679,
    '檄' => 0x167a,
    '檢' => 0x167b,
    '檣' => 0x167c,
    '檗' => 0x1680,
    '蘗' => 0x1681,
    '檻' => 0x1682,
    '櫃' => 0x1683,
    '櫂' => 0x1684,
    '檸' => 0x1685,
    '檳' => 0x1686,
    '檬' => 0x1687,
    '櫞' => 0x1688,
    '櫑' => 0x1689,
    '櫟' => 0x168a,
    '檪' => 0x168b,
    '櫚' => 0x168c,
    '櫪' => 0x168d,
    '櫻' => 0x168e,
    '欅' => 0x168f,
    '蘖' => 0x1690,
    '櫺' => 0x1691,
    '欒' => 0x1692,
    '欖' => 0x1693,
    '鬱' => 0x1694,
    '欟' => 0x1695,
    '欸' => 0x1696,
    '欷' => 0x1697,
    '盜' => 0x1698,
    '欹' => 0x1699,
    '飮' => 0x169a,
    '歇' => 0x169b,
    '歃' => 0x169c,
    '歉' => 0x169d,
    '歐' => 0x169e,
    '歙' => 0x169f,
    '歔' => 0x16a0,
    '歛' => 0x16a1,
    '歟' => 0x16a2,
    '歡' => 0x16a3,
    '歸' => 0x16a4,
    '歹' => 0x16a5,
    '歿' => 0x16a6,
    '殀' => 0x16a7,
    '殄' => 0x16a8,
    '殃' => 0x16a9,
    '殍' => 0x16aa,
    '殘' => 0x16ab,
    '殕' => 0x16ac,
    '殞' => 0x16ad,
    '殤' => 0x16ae,
    '殪' => 0x16af,
    '殫' => 0x16b0,
    '殯' => 0x16b1,
    '殲' => 0x16b2,
    '殱' => 0x16b3,
    '殳' => 0x16b4,
    '殷' => 0x16b5,
    '殼' => 0x16b6,
    '毆' => 0x16b7,
    '毋' => 0x16b8,
    '毓' => 0x16b9,
    '毟' => 0x16ba,
    '毬' => 0x16bb,
    '毫' => 0x16bc,
    '毳' => 0x16bd,
    '毯' => 0x16be,
    '麾' => 0x16c0,
    '氈' => 0x16c1,
    '氓' => 0x16c2,
    '气' => 0x16c3,
    '氛' => 0x16c4,
    '氤' => 0x16c5,
    '氣' => 0x16c6,
    '汞' => 0x16c7,
    '汕' => 0x16c8,
    '汢' => 0x16c9,
    '汪' => 0x16ca,
    '沂' => 0x16cb,
    '沍' => 0x16cc,
    '沚' => 0x16cd,
    '沁' => 0x16ce,
    '沛' => 0x16cf,
    '汾' => 0x16d0,
    '汨' => 0x16d1,
    '汳' => 0x16d2,
    '沒' => 0x16d3,
    '沐' => 0x16d4,
    '泄' => 0x16d5,
    '泱' => 0x16d6,
    '泓' => 0x16d7,
    '沽' => 0x16d8,
    '泗' => 0x16d9,
    '泅' => 0x16da,
    '泝' => 0x16db,
    '沮' => 0x16dc,
    '沱' => 0x16dd,
    '沾' => 0x16de,
    '沺' => 0x16df,
    '泛' => 0x16e0,
    '泯' => 0x16e1,
    '泙' => 0x16e2,
    '泪' => 0x16e3,
    '洟' => 0x16e4,
    '衍' => 0x16e5,
    '洶' => 0x16e6,
    '洫' => 0x16e7,
    '洽' => 0x16e8,
    '洸' => 0x16e9,
    '洙' => 0x16ea,
    '洵' => 0x16eb,
    '洳' => 0x16ec,
    '洒' => 0x16ed,
    '洌' => 0x16ee,
    '浣' => 0x16ef,
    '涓' => 0x16f0,
    '浤' => 0x16f1,
    '浚' => 0x16f2,
    '浹' => 0x16f3,
    '浙' => 0x16f4,
    '涎' => 0x16f5,
    '涕' => 0x16f6,
    '濤' => 0x16f7,
    '涅' => 0x16f8,
    '淹' => 0x16f9,
    '渕' => 0x16fa,
    '渊' => 0x16fb,
    '涵' => 0x16fc,
    '淇' => 0x16fd,
    '淦' => 0x16fe,
    '涸' => 0x16ff,
    '淆' => 0x1700,
    '淬' => 0x1701,
    '淞' => 0x1702,
    '淌' => 0x1703,
    '淨' => 0x1704,
    '淒' => 0x1705,
    '淅' => 0x1706,
    '淺' => 0x1707,
    '淙' => 0x1708,
    '淤' => 0x1709,
    '淕' => 0x170a,
    '淪' => 0x170b,
    '淮' => 0x170c,
    '渭' => 0x170d,
    '湮' => 0x170e,
    '渮' => 0x170f,
    '渙' => 0x1710,
    '湲' => 0x1711,
    '湟' => 0x1712,
    '渾' => 0x1713,
    '渣' => 0x1714,
    '湫' => 0x1715,
    '渫' => 0x1716,
    '湶' => 0x1717,
    '湍' => 0x1718,
    '渟' => 0x1719,
    '湃' => 0x171a,
    '渺' => 0x171b,
    '湎' => 0x171c,
    '渤' => 0x171d,
    '滿' => 0x171e,
    '渝' => 0x171f,
    '游' => 0x1720,
    '溂' => 0x1721,
    '溪' => 0x1722,
    '溘' => 0x1723,
    '滉' => 0x1724,
    '溷' => 0x1725,
    '滓' => 0x1726,
    '溽' => 0x1727,
    '溯' => 0x1728,
    '滄' => 0x1729,
    '溲' => 0x172a,
    '滔' => 0x172b,
    '滕' => 0x172c,
    '溏' => 0x172d,
    '溥' => 0x172e,
    '滂' => 0x172f,
    '溟' => 0x1730,
    '潁' => 0x1731,
    '漑' => 0x1732,
    '灌' => 0x1733,
    '滬' => 0x1734,
    '滸' => 0x1735,
    '滾' => 0x1736,
    '漿' => 0x1737,
    '滲' => 0x1738,
    '漱' => 0x1739,
    '滯' => 0x173a,
    '漲' => 0x173b,
    '滌' => 0x173c,
    '漾' => 0x1740,
    '漓' => 0x1741,
    '滷' => 0x1742,
    '澆' => 0x1743,
    '潺' => 0x1744,
    '潸' => 0x1745,
    '澁' => 0x1746,
    '澀' => 0x1747,
    '潯' => 0x1748,
    '潛' => 0x1749,
    '濳' => 0x174a,
    '潭' => 0x174b,
    '澂' => 0x174c,
    '潼' => 0x174d,
    '潘' => 0x174e,
    '澎' => 0x174f,
    '澑' => 0x1750,
    '濂' => 0x1751,
    '潦' => 0x1752,
    '澳' => 0x1753,
    '澣' => 0x1754,
    '澡' => 0x1755,
    '澤' => 0x1756,
    '澹' => 0x1757,
    '濆' => 0x1758,
    '澪' => 0x1759,
    '濟' => 0x175a,
    '濕' => 0x175b,
    '濬' => 0x175c,
    '濔' => 0x175d,
    '濘' => 0x175e,
    '濱' => 0x175f,
    '濮' => 0x1760,
    '濛' => 0x1761,
    '瀉' => 0x1762,
    '瀋' => 0x1763,
    '濺' => 0x1764,
    '瀑' => 0x1765,
    '瀁' => 0x1766,
    '瀏' => 0x1767,
    '濾' => 0x1768,
    '瀛' => 0x1769,
    '瀚' => 0x176a,
    '潴' => 0x176b,
    '瀝' => 0x176c,
    '瀘' => 0x176d,
    '瀟' => 0x176e,
    '瀰' => 0x176f,
    '瀾' => 0x1770,
    '瀲' => 0x1771,
    '灑' => 0x1772,
    '灣' => 0x1773,
    '炙' => 0x1774,
    '炒' => 0x1775,
    '炯' => 0x1776,
    '烱' => 0x1777,
    '炬' => 0x1778,
    '炸' => 0x1779,
    '炳' => 0x177a,
    '炮' => 0x177b,
    '烟' => 0x177c,
    '烋' => 0x177d,
    '烝' => 0x177e,
    '烙' => 0x1780,
    '焉' => 0x1781,
    '烽' => 0x1782,
    '焜' => 0x1783,
    '焙' => 0x1784,
    '煥' => 0x1785,
    '煕' => 0x1786,
    '熈' => 0x1787,
    '煦' => 0x1788,
    '煢' => 0x1789,
    '煌' => 0x178a,
    '煖' => 0x178b,
    '煬' => 0x178c,
    '熏' => 0x178d,
    '燻' => 0x178e,
    '熄' => 0x178f,
    '熕' => 0x1790,
    '熨' => 0x1791,
    '熬' => 0x1792,
    '燗' => 0x1793,
    '熹' => 0x1794,
    '熾' => 0x1795,
    '燒' => 0x1796,
    '燉' => 0x1797,
    '燔' => 0x1798,
    '燎' => 0x1799,
    '燠' => 0x179a,
    '燬' => 0x179b,
    '燧' => 0x179c,
    '燵' => 0x179d,
    '燼' => 0x179e,
    '燹' => 0x179f,
    '燿' => 0x17a0,
    '爍' => 0x17a1,
    '爐' => 0x17a2,
    '爛' => 0x17a3,
    '爨' => 0x17a4,
    '爭' => 0x17a5,
    '爬' => 0x17a6,
    '爰' => 0x17a7,
    '爲' => 0x17a8,
    '爻' => 0x17a9,
    '爼' => 0x17aa,
    '爿' => 0x17ab,
    '牀' => 0x17ac,
    '牆' => 0x17ad,
    '牋' => 0x17ae,
    '牘' => 0x17af,
    '牴' => 0x17b0,
    '牾' => 0x17b1,
    '犂' => 0x17b2,
    '犁' => 0x17b3,
    '犇' => 0x17b4,
    '犒' => 0x17b5,
    '犖' => 0x17b6,
    '犢' => 0x17b7,
    '犧' => 0x17b8,
    '犹' => 0x17b9,
    '犲' => 0x17ba,
    '狃' => 0x17bb,
    '狆' => 0x17bc,
    '狄' => 0x17bd,
    '狎' => 0x17be,
    '狒' => 0x17bf,
    '狢' => 0x17c0,
    '狠' => 0x17c1,
    '狡' => 0x17c2,
    '狹' => 0x17c3,
    '狷' => 0x17c4,
    '倏' => 0x17c5,
    '猗' => 0x17c6,
    '猊' => 0x17c7,
    '猜' => 0x17c8,
    '猖' => 0x17c9,
    '猝' => 0x17ca,
    '猴' => 0x17cb,
    '猯' => 0x17cc,
    '猩' => 0x17cd,
    '猥' => 0x17ce,
    '猾' => 0x17cf,
    '獎' => 0x17d0,
    '獏' => 0x17d1,
    '默' => 0x17d2,
    '獗' => 0x17d3,
    '獪' => 0x17d4,
    '獨' => 0x17d5,
    '獰' => 0x17d6,
    '獸' => 0x17d7,
    '獵' => 0x17d8,
    '獻' => 0x17d9,
    '獺' => 0x17da,
    '珈' => 0x17db,
    '玳' => 0x17dc,
    '珎' => 0x17dd,
    '玻' => 0x17de,
    '珀' => 0x17df,
    '珥' => 0x17e0,
    '珮' => 0x17e1,
    '珞' => 0x17e2,
    '璢' => 0x17e3,
    '琅' => 0x17e4,
    '瑯' => 0x17e5,
    '琥' => 0x17e6,
    '珸' => 0x17e7,
    '琲' => 0x17e8,
    '琺' => 0x17e9,
    '瑕' => 0x17ea,
    '琿' => 0x17eb,
    '瑟' => 0x17ec,
    '瑙' => 0x17ed,
    '瑁' => 0x17ee,
    '瑜' => 0x17ef,
    '瑩' => 0x17f0,
    '瑰' => 0x17f1,
    '瑣' => 0x17f2,
    '瑪' => 0x17f3,
    '瑶' => 0x17f4,
    '瑾' => 0x17f5,
    '璋' => 0x17f6,
    '璞' => 0x17f7,
    '璧' => 0x17f8,
    '瓊' => 0x17f9,
    '瓏' => 0x17fa,
    '瓔' => 0x17fb,
    '珱' => 0x17fc,
    '瓠' => 0x1800,
    '瓣' => 0x1801,
    '瓧' => 0x1802,
    '瓩' => 0x1803,
    '瓮' => 0x1804,
    '瓲' => 0x1805,
    '瓰' => 0x1806,
    '瓱' => 0x1807,
    '瓸' => 0x1808,
    '瓷' => 0x1809,
    '甄' => 0x180a,
    '甃' => 0x180b,
    '甅' => 0x180c,
    '甌' => 0x180d,
    '甎' => 0x180e,
    '甍' => 0x180f,
    '甕' => 0x1810,
    '甓' => 0x1811,
    '甞' => 0x1812,
    '甦' => 0x1813,
    '甬' => 0x1814,
    '甼' => 0x1815,
    '畄' => 0x1816,
    '畍' => 0x1817,
    '畊' => 0x1818,
    '畉' => 0x1819,
    '畛' => 0x181a,
    '畆' => 0x181b,
    '畚' => 0x181c,
    '畩' => 0x181d,
    '畤' => 0x181e,
    '畧' => 0x181f,
    '畫' => 0x1820,
    '畭' => 0x1821,
    '畸' => 0x1822,
    '當' => 0x1823,
    '疆' => 0x1824,
    '疇' => 0x1825,
    '畴' => 0x1826,
    '疊' => 0x1827,
    '疉' => 0x1828,
    '疂' => 0x1829,
    '疔' => 0x182a,
    '疚' => 0x182b,
    '疝' => 0x182c,
    '疥' => 0x182d,
    '疣' => 0x182e,
    '痂' => 0x182f,
    '疳' => 0x1830,
    '痃' => 0x1831,
    '疵' => 0x1832,
    '疽' => 0x1833,
    '疸' => 0x1834,
    '疼' => 0x1835,
    '疱' => 0x1836,
    '痍' => 0x1837,
    '痊' => 0x1838,
    '痒' => 0x1839,
    '痙' => 0x183a,
    '痣' => 0x183b,
    '痞' => 0x183c,
    '痾' => 0x183d,
    '痿' => 0x183e,
    '痼' => 0x1840,
    '瘁' => 0x1841,
    '痰' => 0x1842,
    '痺' => 0x1843,
    '痲' => 0x1844,
    '痳' => 0x1845,
    '瘋' => 0x1846,
    '瘍' => 0x1847,
    '瘉' => 0x1848,
    '瘟' => 0x1849,
    '瘧' => 0x184a,
    '瘠' => 0x184b,
    '瘡' => 0x184c,
    '瘢' => 0x184d,
    '瘤' => 0x184e,
    '瘴' => 0x184f,
    '瘰' => 0x1850,
    '瘻' => 0x1851,
    '癇' => 0x1852,
    '癈' => 0x1853,
    '癆' => 0x1854,
    '癜' => 0x1855,
    '癘' => 0x1856,
    '癡' => 0x1857,
    '癢' => 0x1858,
    '癨' => 0x1859,
    '癩' => 0x185a,
    '癪' => 0x185b,
    '癧' => 0x185c,
    '癬' => 0x185d,
    '癰' => 0x185e,
    '癲' => 0x185f,
    '癶' => 0x1860,
    '癸' => 0x1861,
    '發' => 0x1862,
    '皀' => 0x1863,
    '皃' => 0x1864,
    '皈' => 0x1865,
    '皋' => 0x1866,
    '皎' => 0x1867,
    '皖' => 0x1868,
    '皓' => 0x1869,
    '皙' => 0x186a,
    '皚' => 0x186b,
    '皰' => 0x186c,
    '皴' => 0x186d,
    '皸' => 0x186e,
    '皹' => 0x186f,
    '皺' => 0x1870,
    '盂' => 0x1871,
    '盍' => 0x1872,
    '盖' => 0x1873,
    '盒' => 0x1874,
    '盞' => 0x1875,
    '盡' => 0x1876,
    '盥' => 0x1877,
    '盧' => 0x1878,
    '盪' => 0x1879,
    '蘯' => 0x187a,
    '盻' => 0x187b,
    '眈' => 0x187c,
    '眇' => 0x187d,
    '眄' => 0x187e,
    '眩' => 0x187f,
    '眤' => 0x1880,
    '眞' => 0x1881,
    '眥' => 0x1882,
    '眦' => 0x1883,
    '眛' => 0x1884,
    '眷' => 0x1885,
    '眸' => 0x1886,
    '睇' => 0x1887,
    '睚' => 0x1888,
    '睨' => 0x1889,
    '睫' => 0x188a,
    '睛' => 0x188b,
    '睥' => 0x188c,
    '睿' => 0x188d,
    '睾' => 0x188e,
    '睹' => 0x188f,
    '瞎' => 0x1890,
    '瞋' => 0x1891,
    '瞑' => 0x1892,
    '瞠' => 0x1893,
    '瞞' => 0x1894,
    '瞰' => 0x1895,
    '瞶' => 0x1896,
    '瞹' => 0x1897,
    '瞿' => 0x1898,
    '瞼' => 0x1899,
    '瞽' => 0x189a,
    '瞻' => 0x189b,
    '矇' => 0x189c,
    '矍' => 0x189d,
    '矗' => 0x189e,
    '矚' => 0x189f,
    '矜' => 0x18a0,
    '矣' => 0x18a1,
    '矮' => 0x18a2,
    '矼' => 0x18a3,
    '砌' => 0x18a4,
    '砒' => 0x18a5,
    '礦' => 0x18a6,
    '砠' => 0x18a7,
    '礪' => 0x18a8,
    '硅' => 0x18a9,
    '碎' => 0x18aa,
    '硴' => 0x18ab,
    '碆' => 0x18ac,
    '硼' => 0x18ad,
    '碚' => 0x18ae,
    '碌' => 0x18af,
    '碣' => 0x18b0,
    '碵' => 0x18b1,
    '碪' => 0x18b2,
    '碯' => 0x18b3,
    '磑' => 0x18b4,
    '磆' => 0x18b5,
    '磋' => 0x18b6,
    '磔' => 0x18b7,
    '碾' => 0x18b8,
    '碼' => 0x18b9,
    '磅' => 0x18ba,
    '磊' => 0x18bb,
    '磬' => 0x18bc,
    '磧' => 0x18c0,
    '磚' => 0x18c1,
    '磽' => 0x18c2,
    '磴' => 0x18c3,
    '礇' => 0x18c4,
    '礒' => 0x18c5,
    '礑' => 0x18c6,
    '礙' => 0x18c7,
    '礬' => 0x18c8,
    '礫' => 0x18c9,
    '祀' => 0x18ca,
    '祠' => 0x18cb,
    '祗' => 0x18cc,
    '祟' => 0x18cd,
    '祚' => 0x18ce,
    '祕' => 0x18cf,
    '祓' => 0x18d0,
    '祺' => 0x18d1,
    '祿' => 0x18d2,
    '禊' => 0x18d3,
    '禝' => 0x18d4,
    '禧' => 0x18d5,
    '齋' => 0x18d6,
    '禪' => 0x18d7,
    '禮' => 0x18d8,
    '禳' => 0x18d9,
    '禹' => 0x18da,
    '禺' => 0x18db,
    '秉' => 0x18dc,
    '秕' => 0x18dd,
    '秧' => 0x18de,
    '秬' => 0x18df,
    '秡' => 0x18e0,
    '秣' => 0x18e1,
    '稈' => 0x18e2,
    '稍' => 0x18e3,
    '稘' => 0x18e4,
    '稙' => 0x18e5,
    '稠' => 0x18e6,
    '稟' => 0x18e7,
    '禀' => 0x18e8,
    '稱' => 0x18e9,
    '稻' => 0x18ea,
    '稾' => 0x18eb,
    '稷' => 0x18ec,
    '穃' => 0x18ed,
    '穗' => 0x18ee,
    '穉' => 0x18ef,
    '穡' => 0x18f0,
    '穢' => 0x18f1,
    '穩' => 0x18f2,
    '龝' => 0x18f3,
    '穰' => 0x18f4,
    '穹' => 0x18f5,
    '穽' => 0x18f6,
    '窈' => 0x18f7,
    '窗' => 0x18f8,
    '窕' => 0x18f9,
    '窘' => 0x18fa,
    '窖' => 0x18fb,
    '窩' => 0x18fc,
    '竈' => 0x18fd,
    '窰' => 0x18fe,
    '窶' => 0x1900,
    '竅' => 0x1901,
    '竄' => 0x1902,
    '窿' => 0x1903,
    '邃' => 0x1904,
    '竇' => 0x1905,
    '竊' => 0x1906,
    '竍' => 0x1907,
    '竏' => 0x1908,
    '竕' => 0x1909,
    '竓' => 0x190a,
    '站' => 0x190b,
    '竚' => 0x190c,
    '竝' => 0x190d,
    '竡' => 0x190e,
    '竢' => 0x190f,
    '竦' => 0x1910,
    '竭' => 0x1911,
    '竰' => 0x1912,
    '笂' => 0x1913,
    '笏' => 0x1914,
    '笊' => 0x1915,
    '笆' => 0x1916,
    '笳' => 0x1917,
    '笘' => 0x1918,
    '笙' => 0x1919,
    '笞' => 0x191a,
    '笵' => 0x191b,
    '笨' => 0x191c,
    '笶' => 0x191d,
    '筐' => 0x191e,
    '筺' => 0x191f,
    '笄' => 0x1920,
    '筍' => 0x1921,
    '笋' => 0x1922,
    '筌' => 0x1923,
    '筅' => 0x1924,
    '筵' => 0x1925,
    '筥' => 0x1926,
    '筴' => 0x1927,
    '筧' => 0x1928,
    '筰' => 0x1929,
    '筱' => 0x192a,
    '筬' => 0x192b,
    '筮' => 0x192c,
    '箝' => 0x192d,
    '箘' => 0x192e,
    '箟' => 0x192f,
    '箍' => 0x1930,
    '箜' => 0x1931,
    '箚' => 0x1932,
    '箋' => 0x1933,
    '箒' => 0x1934,
    '箏' => 0x1935,
    '筝' => 0x1936,
    '箙' => 0x1937,
    '篋' => 0x1938,
    '篁' => 0x1939,
    '篌' => 0x193a,
    '篏' => 0x193b,
    '箴' => 0x193c,
    '篆' => 0x193d,
    '篝' => 0x193e,
    '篩' => 0x193f,
    '簑' => 0x1940,
    '簔' => 0x1941,
    '篦' => 0x1942,
    '篥' => 0x1943,
    '籠' => 0x1944,
    '簀' => 0x1945,
    '簇' => 0x1946,
    '簓' => 0x1947,
    '篳' => 0x1948,
    '篷' => 0x1949,
    '簗' => 0x194a,
    '簍' => 0x194b,
    '篶' => 0x194c,
    '簣' => 0x194d,
    '簧' => 0x194e,
    '簪' => 0x194f,
    '簟' => 0x1950,
    '簷' => 0x1951,
    '簫' => 0x1952,
    '簽' => 0x1953,
    '籌' => 0x1954,
    '籃' => 0x1955,
    '籔' => 0x1956,
    '籏' => 0x1957,
    '籀' => 0x1958,
    '籐' => 0x1959,
    '籘' => 0x195a,
    '籟' => 0x195b,
    '籤' => 0x195c,
    '籖' => 0x195d,
    '籥' => 0x195e,
    '籬' => 0x195f,
    '籵' => 0x1960,
    '粃' => 0x1961,
    '粐' => 0x1962,
    '粤' => 0x1963,
    '粭' => 0x1964,
    '粢' => 0x1965,
    '粫' => 0x1966,
    '粡' => 0x1967,
    '粨' => 0x1968,
    '粳' => 0x1969,
    '粲' => 0x196a,
    '粱' => 0x196b,
    '粮' => 0x196c,
    '粹' => 0x196d,
    '粽' => 0x196e,
    '糀' => 0x196f,
    '糅' => 0x1970,
    '糂' => 0x1971,
    '糘' => 0x1972,
    '糒' => 0x1973,
    '糜' => 0x1974,
    '糢' => 0x1975,
    '鬻' => 0x1976,
    '糯' => 0x1977,
    '糲' => 0x1978,
    '糴' => 0x1979,
    '糶' => 0x197a,
    '糺' => 0x197b,
    '紆' => 0x197c,
    '紂' => 0x1980,
    '紜' => 0x1981,
    '紕' => 0x1982,
    '紊' => 0x1983,
    '絅' => 0x1984,
    '絋' => 0x1985,
    '紮' => 0x1986,
    '紲' => 0x1987,
    '紿' => 0x1988,
    '紵' => 0x1989,
    '絆' => 0x198a,
    '絳' => 0x198b,
    '絖' => 0x198c,
    '絎' => 0x198d,
    '絲' => 0x198e,
    '絨' => 0x198f,
    '絮' => 0x1990,
    '絏' => 0x1991,
    '絣' => 0x1992,
    '經' => 0x1993,
    '綉' => 0x1994,
    '絛' => 0x1995,
    '綏' => 0x1996,
    '絽' => 0x1997,
    '綛' => 0x1998,
    '綺' => 0x1999,
    '綮' => 0x199a,
    '綣' => 0x199b,
    '綵' => 0x199c,
    '緇' => 0x199d,
    '綽' => 0x199e,
    '綫' => 0x199f,
    '總' => 0x19a0,
    '綢' => 0x19a1,
    '綯' => 0x19a2,
    '緜' => 0x19a3,
    '綸' => 0x19a4,
    '綟' => 0x19a5,
    '綰' => 0x19a6,
    '緘' => 0x19a7,
    '緝' => 0x19a8,
    '緤' => 0x19a9,
    '緞' => 0x19aa,
    '緻' => 0x19ab,
    '緲' => 0x19ac,
    '緡' => 0x19ad,
    '縅' => 0x19ae,
    '縊' => 0x19af,
    '縣' => 0x19b0,
    '縡' => 0x19b1,
    '縒' => 0x19b2,
    '縱' => 0x19b3,
    '縟' => 0x19b4,
    '縉' => 0x19b5,
    '縋' => 0x19b6,
    '縢' => 0x19b7,
    '繆' => 0x19b8,
    '繦' => 0x19b9,
    '縻' => 0x19ba,
    '縵' => 0x19bb,
    '縹' => 0x19bc,
    '繃' => 0x19bd,
    '縷' => 0x19be,
    '縲' => 0x19c0,
    '縺' => 0x19c1,
    '繧' => 0x19c2,
    '繝' => 0x19c3,
    '繖' => 0x19c4,
    '繞' => 0x19c5,
    '繙' => 0x19c6,
    '繚' => 0x19c7,
    '繹' => 0x19c8,
    '繪' => 0x19c9,
    '繩' => 0x19ca,
    '繼' => 0x19cb,
    '繻' => 0x19cc,
    '纃' => 0x19cd,
    '緕' => 0x19ce,
    '繽' => 0x19cf,
    '辮' => 0x19d0,
    '繿' => 0x19d1,
    '纈' => 0x19d2,
    '纉' => 0x19d3,
    '續' => 0x19d4,
    '纒' => 0x19d5,
    '纐' => 0x19d6,
    '纓' => 0x19d7,
    '纔' => 0x19d8,
    '纖' => 0x19d9,
    '纎' => 0x19da,
    '纛' => 0x19db,
    '纜' => 0x19dc,
    '缸' => 0x19dd,
    '缺' => 0x19de,
    '罅' => 0x19df,
    '罌' => 0x19e0,
    '罍' => 0x19e1,
    '罎' => 0x19e2,
    '罐' => 0x19e3,
    '网' => 0x19e4,
    '罕' => 0x19e5,
    '罔' => 0x19e6,
    '罘' => 0x19e7,
    '罟' => 0x19e8,
    '罠' => 0x19e9,
    '罨' => 0x19ea,
    '罩' => 0x19eb,
    '罧' => 0x19ec,
    '罸' => 0x19ed,
    '羂' => 0x19ee,
    '羆' => 0x19ef,
    '羃' => 0x19f0,
    '羈' => 0x19f1,
    '羇' => 0x19f2,
    '羌' => 0x19f3,
    '羔' => 0x19f4,
    '羞' => 0x19f5,
    '羝' => 0x19f6,
    '羚' => 0x19f7,
    '羣' => 0x19f8,
    '羯' => 0x19f9,
    '羲' => 0x19fa,
    '羹' => 0x19fb,
    '羮' => 0x19fc,
    '羶' => 0x19fd,
    '羸' => 0x19fe,
    '譱' => 0x19ff,
    '翅' => 0x1a00,
    '翆' => 0x1a01,
    '翊' => 0x1a02,
    '翕' => 0x1a03,
    '翔' => 0x1a04,
    '翡' => 0x1a05,
    '翦' => 0x1a06,
    '翩' => 0x1a07,
    '翳' => 0x1a08,
    '翹' => 0x1a09,
    '飜' => 0x1a0a,
    '耆' => 0x1a0b,
    '耄' => 0x1a0c,
    '耋' => 0x1a0d,
    '耒' => 0x1a0e,
    '耘' => 0x1a0f,
    '耙' => 0x1a10,
    '耜' => 0x1a11,
    '耡' => 0x1a12,
    '耨' => 0x1a13,
    '耿' => 0x1a14,
    '耻' => 0x1a15,
    '聊' => 0x1a16,
    '聆' => 0x1a17,
    '聒' => 0x1a18,
    '聘' => 0x1a19,
    '聚' => 0x1a1a,
    '聟' => 0x1a1b,
    '聢' => 0x1a1c,
    '聨' => 0x1a1d,
    '聳' => 0x1a1e,
    '聲' => 0x1a1f,
    '聰' => 0x1a20,
    '聶' => 0x1a21,
    '聹' => 0x1a22,
    '聽' => 0x1a23,
    '聿' => 0x1a24,
    '肄' => 0x1a25,
    '肆' => 0x1a26,
    '肅' => 0x1a27,
    '肛' => 0x1a28,
    '肓' => 0x1a29,
    '肚' => 0x1a2a,
    '肭' => 0x1a2b,
    '冐' => 0x1a2c,
    '肬' => 0x1a2d,
    '胛' => 0x1a2e,
    '胥' => 0x1a2f,
    '胙' => 0x1a30,
    '胝' => 0x1a31,
    '胄' => 0x1a32,
    '胚' => 0x1a33,
    '胖' => 0x1a34,
    '脉' => 0x1a35,
    '胯' => 0x1a36,
    '胱' => 0x1a37,
    '脛' => 0x1a38,
    '脩' => 0x1a39,
    '脣' => 0x1a3a,
    '脯' => 0x1a3b,
    '腋' => 0x1a3c,
    '隋' => 0x1a40,
    '腆' => 0x1a41,
    '脾' => 0x1a42,
    '腓' => 0x1a43,
    '腑' => 0x1a44,
    '胼' => 0x1a45,
    '腱' => 0x1a46,
    '腮' => 0x1a47,
    '腥' => 0x1a48,
    '腦' => 0x1a49,
    '腴' => 0x1a4a,
    '膃' => 0x1a4b,
    '膈' => 0x1a4c,
    '膊' => 0x1a4d,
    '膀' => 0x1a4e,
    '膂' => 0x1a4f,
    '膠' => 0x1a50,
    '膕' => 0x1a51,
    '膤' => 0x1a52,
    '膣' => 0x1a53,
    '腟' => 0x1a54,
    '膓' => 0x1a55,
    '膩' => 0x1a56,
    '膰' => 0x1a57,
    '膵' => 0x1a58,
    '膾' => 0x1a59,
    '膸' => 0x1a5a,
    '膽' => 0x1a5b,
    '臀' => 0x1a5c,
    '臂' => 0x1a5d,
    '膺' => 0x1a5e,
    '臉' => 0x1a5f,
    '臍' => 0x1a60,
    '臑' => 0x1a61,
    '臙' => 0x1a62,
    '臘' => 0x1a63,
    '臈' => 0x1a64,
    '臚' => 0x1a65,
    '臟' => 0x1a66,
    '臠' => 0x1a67,
    '臧' => 0x1a68,
    '臺' => 0x1a69,
    '臻' => 0x1a6a,
    '臾' => 0x1a6b,
    '舁' => 0x1a6c,
    '舂' => 0x1a6d,
    '舅' => 0x1a6e,
    '與' => 0x1a6f,
    '舊' => 0x1a70,
    '舍' => 0x1a71,
    '舐' => 0x1a72,
    '舖' => 0x1a73,
    '舩' => 0x1a74,
    '舫' => 0x1a75,
    '舸' => 0x1a76,
    '舳' => 0x1a77,
    '艀' => 0x1a78,
    '艙' => 0x1a79,
    '艘' => 0x1a7a,
    '艝' => 0x1a7b,
    '艚' => 0x1a7c,
    '艟' => 0x1a7d,
    '艤' => 0x1a7e,
    '艢' => 0x1a80,
    '艨' => 0x1a81,
    '艪' => 0x1a82,
    '艫' => 0x1a83,
    '舮' => 0x1a84,
    '艱' => 0x1a85,
    '艷' => 0x1a86,
    '艸' => 0x1a87,
    '艾' => 0x1a88,
    '芍' => 0x1a89,
    '芒' => 0x1a8a,
    '芫' => 0x1a8b,
    '芟' => 0x1a8c,
    '芻' => 0x1a8d,
    '芬' => 0x1a8e,
    '苡' => 0x1a8f,
    '苣' => 0x1a90,
    '苟' => 0x1a91,
    '苒' => 0x1a92,
    '苴' => 0x1a93,
    '苳' => 0x1a94,
    '苺' => 0x1a95,
    '莓' => 0x1a96,
    '范' => 0x1a97,
    '苻' => 0x1a98,
    '苹' => 0x1a99,
    '苞' => 0x1a9a,
    '茆' => 0x1a9b,
    '苜' => 0x1a9c,
    '茉' => 0x1a9d,
    '苙' => 0x1a9e,
    '茵' => 0x1a9f,
    '茴' => 0x1aa0,
    '茖' => 0x1aa1,
    '茲' => 0x1aa2,
    '茱' => 0x1aa3,
    '荀' => 0x1aa4,
    '茹' => 0x1aa5,
    '荐' => 0x1aa6,
    '荅' => 0x1aa7,
    '茯' => 0x1aa8,
    '茫' => 0x1aa9,
    '茗' => 0x1aaa,
    '茘' => 0x1aab,
    '莅' => 0x1aac,
    '莚' => 0x1aad,
    '莪' => 0x1aae,
    '莟' => 0x1aaf,
    '莢' => 0x1ab0,
    '莖' => 0x1ab1,
    '茣' => 0x1ab2,
    '莎' => 0x1ab3,
    '莇' => 0x1ab4,
    '莊' => 0x1ab5,
    '荼' => 0x1ab6,
    '莵' => 0x1ab7,
    '荳' => 0x1ab8,
    '荵' => 0x1ab9,
    '莠' => 0x1aba,
    '莉' => 0x1abb,
    '莨' => 0x1abc,
    '菴' => 0x1abd,
    '萓' => 0x1abe,
    '菫' => 0x1abf,
    '菎' => 0x1ac0,
    '菽' => 0x1ac1,
    '萃' => 0x1ac2,
    '菘' => 0x1ac3,
    '萋' => 0x1ac4,
    '菁' => 0x1ac5,
    '菷' => 0x1ac6,
    '萇' => 0x1ac7,
    '菠' => 0x1ac8,
    '菲' => 0x1ac9,
    '萍' => 0x1aca,
    '萢' => 0x1acb,
    '萠' => 0x1acc,
    '莽' => 0x1acd,
    '萸' => 0x1ace,
    '蔆' => 0x1acf,
    '菻' => 0x1ad0,
    '葭' => 0x1ad1,
    '萪' => 0x1ad2,
    '萼' => 0x1ad3,
    '蕚' => 0x1ad4,
    '蒄' => 0x1ad5,
    '葷' => 0x1ad6,
    '葫' => 0x1ad7,
    '蒭' => 0x1ad8,
    '葮' => 0x1ad9,
    '蒂' => 0x1ada,
    '葩' => 0x1adb,
    '葆' => 0x1adc,
    '萬' => 0x1add,
    '葯' => 0x1ade,
    '葹' => 0x1adf,
    '萵' => 0x1ae0,
    '蓊' => 0x1ae1,
    '葢' => 0x1ae2,
    '蒹' => 0x1ae3,
    '蒿' => 0x1ae4,
    '蒟' => 0x1ae5,
    '蓙' => 0x1ae6,
    '蓍' => 0x1ae7,
    '蒻' => 0x1ae8,
    '蓚' => 0x1ae9,
    '蓐' => 0x1aea,
    '蓁' => 0x1aeb,
    '蓆' => 0x1aec,
    '蓖' => 0x1aed,
    '蒡' => 0x1aee,
    '蔡' => 0x1aef,
    '蓿' => 0x1af0,
    '蓴' => 0x1af1,
    '蔗' => 0x1af2,
    '蔘' => 0x1af3,
    '蔬' => 0x1af4,
    '蔟' => 0x1af5,
    '蔕' => 0x1af6,
    '蔔' => 0x1af7,
    '蓼' => 0x1af8,
    '蕀' => 0x1af9,
    '蕣' => 0x1afa,
    '蕘' => 0x1afb,
    '蕈' => 0x1afc,
    '蕁' => 0x1b00,
    '蘂' => 0x1b01,
    '蕋' => 0x1b02,
    '蕕' => 0x1b03,
    '薀' => 0x1b04,
    '薤' => 0x1b05,
    '薈' => 0x1b06,
    '薑' => 0x1b07,
    '薊' => 0x1b08,
    '薨' => 0x1b09,
    '蕭' => 0x1b0a,
    '薔' => 0x1b0b,
    '薛' => 0x1b0c,
    '藪' => 0x1b0d,
    '薇' => 0x1b0e,
    '薜' => 0x1b0f,
    '蕷' => 0x1b10,
    '蕾' => 0x1b11,
    '薐' => 0x1b12,
    '藉' => 0x1b13,
    '薺' => 0x1b14,
    '藏' => 0x1b15,
    '薹' => 0x1b16,
    '藐' => 0x1b17,
    '藕' => 0x1b18,
    '藝' => 0x1b19,
    '藥' => 0x1b1a,
    '藜' => 0x1b1b,
    '藹' => 0x1b1c,
    '蘊' => 0x1b1d,
    '蘓' => 0x1b1e,
    '蘋' => 0x1b1f,
    '藾' => 0x1b20,
    '藺' => 0x1b21,
    '蘆' => 0x1b22,
    '蘢' => 0x1b23,
    '蘚' => 0x1b24,
    '蘰' => 0x1b25,
    '蘿' => 0x1b26,
    '虍' => 0x1b27,
    '乕' => 0x1b28,
    '虔' => 0x1b29,
    '號' => 0x1b2a,
    '虧' => 0x1b2b,
    '虱' => 0x1b2c,
    '蚓' => 0x1b2d,
    '蚣' => 0x1b2e,
    '蚩' => 0x1b2f,
    '蚪' => 0x1b30,
    '蚋' => 0x1b31,
    '蚌' => 0x1b32,
    '蚶' => 0x1b33,
    '蚯' => 0x1b34,
    '蛄' => 0x1b35,
    '蛆' => 0x1b36,
    '蚰' => 0x1b37,
    '蛉' => 0x1b38,
    '蠣' => 0x1b39,
    '蚫' => 0x1b3a,
    '蛔' => 0x1b3b,
    '蛞' => 0x1b3c,
    '蛩' => 0x1b3d,
    '蛬' => 0x1b3e,
    '蛟' => 0x1b40,
    '蛛' => 0x1b41,
    '蛯' => 0x1b42,
    '蜒' => 0x1b43,
    '蜆' => 0x1b44,
    '蜈' => 0x1b45,
    '蜀' => 0x1b46,
    '蜃' => 0x1b47,
    '蛻' => 0x1b48,
    '蜑' => 0x1b49,
    '蜉' => 0x1b4a,
    '蜍' => 0x1b4b,
    '蛹' => 0x1b4c,
    '蜊' => 0x1b4d,
    '蜴' => 0x1b4e,
    '蜿' => 0x1b4f,
    '蜷' => 0x1b50,
    '蜻' => 0x1b51,
    '蜥' => 0x1b52,
    '蜩' => 0x1b53,
    '蜚' => 0x1b54,
    '蝠' => 0x1b55,
    '蝟' => 0x1b56,
    '蝸' => 0x1b57,
    '蝌' => 0x1b58,
    '蝎' => 0x1b59,
    '蝴' => 0x1b5a,
    '蝗' => 0x1b5b,
    '蝨' => 0x1b5c,
    '蝮' => 0x1b5d,
    '蝙' => 0x1b5e,
    '蝓' => 0x1b5f,
    '蝣' => 0x1b60,
    '蝪' => 0x1b61,
    '蠅' => 0x1b62,
    '螢' => 0x1b63,
    '螟' => 0x1b64,
    '螂' => 0x1b65,
    '螯' => 0x1b66,
    '蟋' => 0x1b67,
    '螽' => 0x1b68,
    '蟀' => 0x1b69,
    '蟐' => 0x1b6a,
    '雖' => 0x1b6b,
    '螫' => 0x1b6c,
    '蟄' => 0x1b6d,
    '螳' => 0x1b6e,
    '蟇' => 0x1b6f,
    '蟆' => 0x1b70,
    '螻' => 0x1b71,
    '蟯' => 0x1b72,
    '蟲' => 0x1b73,
    '蟠' => 0x1b74,
    '蠏' => 0x1b75,
    '蠍' => 0x1b76,
    '蟾' => 0x1b77,
    '蟶' => 0x1b78,
    '蟷' => 0x1b79,
    '蠎' => 0x1b7a,
    '蟒' => 0x1b7b,
    '蠑' => 0x1b7c,
    '蠖' => 0x1b7d,
    '蠕' => 0x1b7e,
    '蠢' => 0x1b7f,
    '蠡' => 0x1b80,
    '蠱' => 0x1b81,
    '蠶' => 0x1b82,
    '蠹' => 0x1b83,
    '蠧' => 0x1b84,
    '蠻' => 0x1b85,
    '衄' => 0x1b86,
    '衂' => 0x1b87,
    '衒' => 0x1b88,
    '衙' => 0x1b89,
    '衞' => 0x1b8a,
    '衢' => 0x1b8b,
    '衫' => 0x1b8c,
    '袁' => 0x1b8d,
    '衾' => 0x1b8e,
    '袞' => 0x1b8f,
    '衵' => 0x1b90,
    '衽' => 0x1b91,
    '袵' => 0x1b92,
    '衲' => 0x1b93,
    '袂' => 0x1b94,
    '袗' => 0x1b95,
    '袒' => 0x1b96,
    '袮' => 0x1b97,
    '袙' => 0x1b98,
    '袢' => 0x1b99,
    '袍' => 0x1b9a,
    '袤' => 0x1b9b,
    '袰' => 0x1b9c,
    '袿' => 0x1b9d,
    '袱' => 0x1b9e,
    '裃' => 0x1b9f,
    '裄' => 0x1ba0,
    '裔' => 0x1ba1,
    '裘' => 0x1ba2,
    '裙' => 0x1ba3,
    '裝' => 0x1ba4,
    '裹' => 0x1ba5,
    '褂' => 0x1ba6,
    '裼' => 0x1ba7,
    '裴' => 0x1ba8,
    '裨' => 0x1ba9,
    '裲' => 0x1baa,
    '褄' => 0x1bab,
    '褌' => 0x1bac,
    '褊' => 0x1bad,
    '褓' => 0x1bae,
    '襃' => 0x1baf,
    '褞' => 0x1bb0,
    '褥' => 0x1bb1,
    '褪' => 0x1bb2,
    '褫' => 0x1bb3,
    '襁' => 0x1bb4,
    '襄' => 0x1bb5,
    '褻' => 0x1bb6,
    '褶' => 0x1bb7,
    '褸' => 0x1bb8,
    '襌' => 0x1bb9,
    '褝' => 0x1bba,
    '襠' => 0x1bbb,
    '襞' => 0x1bbc,
    '襦' => 0x1bc0,
    '襤' => 0x1bc1,
    '襭' => 0x1bc2,
    '襪' => 0x1bc3,
    '襯' => 0x1bc4,
    '襴' => 0x1bc5,
    '襷' => 0x1bc6,
    '襾' => 0x1bc7,
    '覃' => 0x1bc8,
    '覈' => 0x1bc9,
    '覊' => 0x1bca,
    '覓' => 0x1bcb,
    '覘' => 0x1bcc,
    '覡' => 0x1bcd,
    '覩' => 0x1bce,
    '覦' => 0x1bcf,
    '覬' => 0x1bd0,
    '覯' => 0x1bd1,
    '覲' => 0x1bd2,
    '覺' => 0x1bd3,
    '覽' => 0x1bd4,
    '覿' => 0x1bd5,
    '觀' => 0x1bd6,
    '觚' => 0x1bd7,
    '觜' => 0x1bd8,
    '觝' => 0x1bd9,
    '觧' => 0x1bda,
    '觴' => 0x1bdb,
    '觸' => 0x1bdc,
    '訃' => 0x1bdd,
    '訖' => 0x1bde,
    '訐' => 0x1bdf,
    '訌' => 0x1be0,
    '訛' => 0x1be1,
    '訝' => 0x1be2,
    '訥' => 0x1be3,
    '訶' => 0x1be4,
    '詁' => 0x1be5,
    '詛' => 0x1be6,
    '詒' => 0x1be7,
    '詆' => 0x1be8,
    '詈' => 0x1be9,
    '詼' => 0x1bea,
    '詭' => 0x1beb,
    '詬' => 0x1bec,
    '詢' => 0x1bed,
    '誅' => 0x1bee,
    '誂' => 0x1bef,
    '誄' => 0x1bf0,
    '誨' => 0x1bf1,
    '誡' => 0x1bf2,
    '誑' => 0x1bf3,
    '誥' => 0x1bf4,
    '誦' => 0x1bf5,
    '誚' => 0x1bf6,
    '誣' => 0x1bf7,
    '諄' => 0x1bf8,
    '諍' => 0x1bf9,
    '諂' => 0x1bfa,
    '諚' => 0x1bfb,
    '諫' => 0x1bfc,
    '諳' => 0x1bfd,
    '諧' => 0x1bfe,
    '諤' => 0x1c00,
    '諱' => 0x1c01,
    '謔' => 0x1c02,
    '諠' => 0x1c03,
    '諢' => 0x1c04,
    '諷' => 0x1c05,
    '諞' => 0x1c06,
    '諛' => 0x1c07,
    '謌' => 0x1c08,
    '謇' => 0x1c09,
    '謚' => 0x1c0a,
    '諡' => 0x1c0b,
    '謖' => 0x1c0c,
    '謐' => 0x1c0d,
    '謗' => 0x1c0e,
    '謠' => 0x1c0f,
    '謳' => 0x1c10,
    '鞫' => 0x1c11,
    '謦' => 0x1c12,
    '謫' => 0x1c13,
    '謾' => 0x1c14,
    '謨' => 0x1c15,
    '譁' => 0x1c16,
    '譌' => 0x1c17,
    '譏' => 0x1c18,
    '譎' => 0x1c19,
    '證' => 0x1c1a,
    '譖' => 0x1c1b,
    '譛' => 0x1c1c,
    '譚' => 0x1c1d,
    '譫' => 0x1c1e,
    '譟' => 0x1c1f,
    '譬' => 0x1c20,
    '譯' => 0x1c21,
    '譴' => 0x1c22,
    '譽' => 0x1c23,
    '讀' => 0x1c24,
    '讌' => 0x1c25,
    '讎' => 0x1c26,
    '讒' => 0x1c27,
    '讓' => 0x1c28,
    '讖' => 0x1c29,
    '讙' => 0x1c2a,
    '讚' => 0x1c2b,
    '谺' => 0x1c2c,
    '豁' => 0x1c2d,
    '谿' => 0x1c2e,
    '豈' => 0x1c2f,
    '豌' => 0x1c30,
    '豎' => 0x1c31,
    '豐' => 0x1c32,
    '豕' => 0x1c33,
    '豢' => 0x1c34,
    '豬' => 0x1c35,
    '豸' => 0x1c36,
    '豺' => 0x1c37,
    '貂' => 0x1c38,
    '貉' => 0x1c39,
    '貅' => 0x1c3a,
    '貊' => 0x1c3b,
    '貍' => 0x1c3c,
    '貎' => 0x1c3d,
    '貔' => 0x1c3e,
    '豼' => 0x1c3f,
    '貘' => 0x1c40,
    '戝' => 0x1c41,
    '貭' => 0x1c42,
    '貪' => 0x1c43,
    '貽' => 0x1c44,
    '貲' => 0x1c45,
    '貳' => 0x1c46,
    '貮' => 0x1c47,
    '貶' => 0x1c48,
    '賈' => 0x1c49,
    '賁' => 0x1c4a,
    '賤' => 0x1c4b,
    '賣' => 0x1c4c,
    '賚' => 0x1c4d,
    '賽' => 0x1c4e,
    '賺' => 0x1c4f,
    '賻' => 0x1c50,
    '贄' => 0x1c51,
    '贅' => 0x1c52,
    '贊' => 0x1c53,
    '贇' => 0x1c54,
    '贏' => 0x1c55,
    '贍' => 0x1c56,
    '贐' => 0x1c57,
    '齎' => 0x1c58,
    '贓' => 0x1c59,
    '賍' => 0x1c5a,
    '贔' => 0x1c5b,
    '贖' => 0x1c5c,
    '赧' => 0x1c5d,
    '赭' => 0x1c5e,
    '赱' => 0x1c5f,
    '赳' => 0x1c60,
    '趁' => 0x1c61,
    '趙' => 0x1c62,
    '跂' => 0x1c63,
    '趾' => 0x1c64,
    '趺' => 0x1c65,
    '跏' => 0x1c66,
    '跚' => 0x1c67,
    '跖' => 0x1c68,
    '跌' => 0x1c69,
    '跛' => 0x1c6a,
    '跋' => 0x1c6b,
    '跪' => 0x1c6c,
    '跫' => 0x1c6d,
    '跟' => 0x1c6e,
    '跣' => 0x1c6f,
    '跼' => 0x1c70,
    '踈' => 0x1c71,
    '踉' => 0x1c72,
    '跿' => 0x1c73,
    '踝' => 0x1c74,
    '踞' => 0x1c75,
    '踐' => 0x1c76,
    '踟' => 0x1c77,
    '蹂' => 0x1c78,
    '踵' => 0x1c79,
    '踰' => 0x1c7a,
    '踴' => 0x1c7b,
    '蹊' => 0x1c7c,
    '蹇' => 0x1c80,
    '蹉' => 0x1c81,
    '蹌' => 0x1c82,
    '蹐' => 0x1c83,
    '蹈' => 0x1c84,
    '蹙' => 0x1c85,
    '蹤' => 0x1c86,
    '蹠' => 0x1c87,
    '踪' => 0x1c88,
    '蹣' => 0x1c89,
    '蹕' => 0x1c8a,
    '蹶' => 0x1c8b,
    '蹲' => 0x1c8c,
    '蹼' => 0x1c8d,
    '躁' => 0x1c8e,
    '躇' => 0x1c8f,
    '躅' => 0x1c90,
    '躄' => 0x1c91,
    '躋' => 0x1c92,
    '躊' => 0x1c93,
    '躓' => 0x1c94,
    '躑' => 0x1c95,
    '躔' => 0x1c96,
    '躙' => 0x1c97,
    '躪' => 0x1c98,
    '躡' => 0x1c99,
    '躬' => 0x1c9a,
    '躰' => 0x1c9b,
    '軆' => 0x1c9c,
    '躱' => 0x1c9d,
    '躾' => 0x1c9e,
    '軅' => 0x1c9f,
    '軈' => 0x1ca0,
    '軋' => 0x1ca1,
    '軛' => 0x1ca2,
    '軣' => 0x1ca3,
    '軼' => 0x1ca4,
    '軻' => 0x1ca5,
    '軫' => 0x1ca6,
    '軾' => 0x1ca7,
    '輊' => 0x1ca8,
    '輅' => 0x1ca9,
    '輕' => 0x1caa,
    '輒' => 0x1cab,
    '輙' => 0x1cac,
    '輓' => 0x1cad,
    '輜' => 0x1cae,
    '輟' => 0x1caf,
    '輛' => 0x1cb0,
    '輌' => 0x1cb1,
    '輦' => 0x1cb2,
    '輳' => 0x1cb3,
    '輻' => 0x1cb4,
    '輹' => 0x1cb5,
    '轅' => 0x1cb6,
    '轂' => 0x1cb7,
    '輾' => 0x1cb8,
    '轌' => 0x1cb9,
    '轉' => 0x1cba,
    '轆' => 0x1cbb,
    '轎' => 0x1cbc,
    '轗' => 0x1cbd,
    '轜' => 0x1cbe,
    '轢' => 0x1cc0,
    '轣' => 0x1cc1,
    '轤' => 0x1cc2,
    '辜' => 0x1cc3,
    '辟' => 0x1cc4,
    '辣' => 0x1cc5,
    '辭' => 0x1cc6,
    '辯' => 0x1cc7,
    '辷' => 0x1cc8,
    '迚' => 0x1cc9,
    '迥' => 0x1cca,
    '迢' => 0x1ccb,
    '迪' => 0x1ccc,
    '迯' => 0x1ccd,
    '邇' => 0x1cce,
    '迴' => 0x1ccf,
    '逅' => 0x1cd0,
    '迹' => 0x1cd1,
    '迺' => 0x1cd2,
    '逑' => 0x1cd3,
    '逕' => 0x1cd4,
    '逡' => 0x1cd5,
    '逍' => 0x1cd6,
    '逞' => 0x1cd7,
    '逖' => 0x1cd8,
    '逋' => 0x1cd9,
    '逧' => 0x1cda,
    '逶' => 0x1cdb,
    '逵' => 0x1cdc,
    '逹' => 0x1cdd,
    '迸' => 0x1cde,
    '遏' => 0x1cdf,
    '遐' => 0x1ce0,
    '遑' => 0x1ce1,
    '遒' => 0x1ce2,
    '逎' => 0x1ce3,
    '遉' => 0x1ce4,
    '逾' => 0x1ce5,
    '遖' => 0x1ce6,
    '遘' => 0x1ce7,
    '遞' => 0x1ce8,
    '遨' => 0x1ce9,
    '遯' => 0x1cea,
    '遶' => 0x1ceb,
    '隨' => 0x1cec,
    '遲' => 0x1ced,
    '邂' => 0x1cee,
    '遽' => 0x1cef,
    '邁' => 0x1cf0,
    '邀' => 0x1cf1,
    '邊' => 0x1cf2,
    '邉' => 0x1cf3,
    '邏' => 0x1cf4,
    '邨' => 0x1cf5,
    '邯' => 0x1cf6,
    '邱' => 0x1cf7,
    '邵' => 0x1cf8,
    '郢' => 0x1cf9,
    '郤' => 0x1cfa,
    '扈' => 0x1cfb,
    '郛' => 0x1cfc,
    '鄂' => 0x1cfd,
    '鄒' => 0x1cfe,
    '鄙' => 0x1cff,
    '鄲' => 0x1d00,
    '鄰' => 0x1d01,
    '酊' => 0x1d02,
    '酖' => 0x1d03,
    '酘' => 0x1d04,
    '酣' => 0x1d05,
    '酥' => 0x1d06,
    '酩' => 0x1d07,
    '酳' => 0x1d08,
    '酲' => 0x1d09,
    '醋' => 0x1d0a,
    '醉' => 0x1d0b,
    '醂' => 0x1d0c,
    '醢' => 0x1d0d,
    '醫' => 0x1d0e,
    '醯' => 0x1d0f,
    '醪' => 0x1d10,
    '醵' => 0x1d11,
    '醴' => 0x1d12,
    '醺' => 0x1d13,
    '釀' => 0x1d14,
    '釁' => 0x1d15,
    '釉' => 0x1d16,
    '釋' => 0x1d17,
    '釐' => 0x1d18,
    '釖' => 0x1d19,
    '釟' => 0x1d1a,
    '釡' => 0x1d1b,
    '釛' => 0x1d1c,
    '釼' => 0x1d1d,
    '釵' => 0x1d1e,
    '釶' => 0x1d1f,
    '鈞' => 0x1d20,
    '釿' => 0x1d21,
    '鈔' => 0x1d22,
    '鈬' => 0x1d23,
    '鈕' => 0x1d24,
    '鈑' => 0x1d25,
    '鉞' => 0x1d26,
    '鉗' => 0x1d27,
    '鉅' => 0x1d28,
    '鉉' => 0x1d29,
    '鉤' => 0x1d2a,
    '鉈' => 0x1d2b,
    '銕' => 0x1d2c,
    '鈿' => 0x1d2d,
    '鉋' => 0x1d2e,
    '鉐' => 0x1d2f,
    '銜' => 0x1d30,
    '銖' => 0x1d31,
    '銓' => 0x1d32,
    '銛' => 0x1d33,
    '鉚' => 0x1d34,
    '鋏' => 0x1d35,
    '銹' => 0x1d36,
    '銷' => 0x1d37,
    '鋩' => 0x1d38,
    '錏' => 0x1d39,
    '鋺' => 0x1d3a,
    '鍄' => 0x1d3b,
    '錮' => 0x1d3c,
    '錙' => 0x1d40,
    '錢' => 0x1d41,
    '錚' => 0x1d42,
    '錣' => 0x1d43,
    '錺' => 0x1d44,
    '錵' => 0x1d45,
    '錻' => 0x1d46,
    '鍜' => 0x1d47,
    '鍠' => 0x1d48,
    '鍼' => 0x1d49,
    '鍮' => 0x1d4a,
    '鍖' => 0x1d4b,
    '鎰' => 0x1d4c,
    '鎬' => 0x1d4d,
    '鎭' => 0x1d4e,
    '鎔' => 0x1d4f,
    '鎹' => 0x1d50,
    '鏖' => 0x1d51,
    '鏗' => 0x1d52,
    '鏨' => 0x1d53,
    '鏥' => 0x1d54,
    '鏘' => 0x1d55,
    '鏃' => 0x1d56,
    '鏝' => 0x1d57,
    '鏐' => 0x1d58,
    '鏈' => 0x1d59,
    '鏤' => 0x1d5a,
    '鐚' => 0x1d5b,
    '鐔' => 0x1d5c,
    '鐓' => 0x1d5d,
    '鐃' => 0x1d5e,
    '鐇' => 0x1d5f,
    '鐐' => 0x1d60,
    '鐶' => 0x1d61,
    '鐫' => 0x1d62,
    '鐵' => 0x1d63,
    '鐡' => 0x1d64,
    '鐺' => 0x1d65,
    '鑁' => 0x1d66,
    '鑒' => 0x1d67,
    '鑄' => 0x1d68,
    '鑛' => 0x1d69,
    '鑠' => 0x1d6a,
    '鑢' => 0x1d6b,
    '鑞' => 0x1d6c,
    '鑪' => 0x1d6d,
    '鈩' => 0x1d6e,
    '鑰' => 0x1d6f,
    '鑵' => 0x1d70,
    '鑷' => 0x1d71,
    '鑽' => 0x1d72,
    '鑚' => 0x1d73,
    '鑼' => 0x1d74,
    '鑾' => 0x1d75,
    '钁' => 0x1d76,
    '鑿' => 0x1d77,
    '閂' => 0x1d78,
    '閇' => 0x1d79,
    '閊' => 0x1d7a,
    '閔' => 0x1d7b,
    '閖' => 0x1d7c,
    '閘' => 0x1d7d,
    '閙' => 0x1d7e,
    '閠' => 0x1d80,
    '閨' => 0x1d81,
    '閧' => 0x1d82,
    '閭' => 0x1d83,
    '閼' => 0x1d84,
    '閻' => 0x1d85,
    '閹' => 0x1d86,
    '閾' => 0x1d87,
    '闊' => 0x1d88,
    '濶' => 0x1d89,
    '闃' => 0x1d8a,
    '闍' => 0x1d8b,
    '闌' => 0x1d8c,
    '闕' => 0x1d8d,
    '闔' => 0x1d8e,
    '闖' => 0x1d8f,
    '關' => 0x1d90,
    '闡' => 0x1d91,
    '闥' => 0x1d92,
    '闢' => 0x1d93,
    '阡' => 0x1d94,
    '阨' => 0x1d95,
    '阮' => 0x1d96,
    '阯' => 0x1d97,
    '陂' => 0x1d98,
    '陌' => 0x1d99,
    '陏' => 0x1d9a,
    '陋' => 0x1d9b,
    '陷' => 0x1d9c,
    '陜' => 0x1d9d,
    '陞' => 0x1d9e,
    '陝' => 0x1d9f,
    '陟' => 0x1da0,
    '陦' => 0x1da1,
    '陲' => 0x1da2,
    '陬' => 0x1da3,
    '隍' => 0x1da4,
    '隘' => 0x1da5,
    '隕' => 0x1da6,
    '隗' => 0x1da7,
    '險' => 0x1da8,
    '隧' => 0x1da9,
    '隱' => 0x1daa,
    '隲' => 0x1dab,
    '隰' => 0x1dac,
    '隴' => 0x1dad,
    '隶' => 0x1dae,
    '隸' => 0x1daf,
    '隹' => 0x1db0,
    '雎' => 0x1db1,
    '雋' => 0x1db2,
    '雉' => 0x1db3,
    '雍' => 0x1db4,
    '襍' => 0x1db5,
    '雜' => 0x1db6,
    '霍' => 0x1db7,
    '雕' => 0x1db8,
    '雹' => 0x1db9,
    '霄' => 0x1dba,
    '霆' => 0x1dbb,
    '霈' => 0x1dbc,
    '霓' => 0x1dbd,
    '霎' => 0x1dbe,
    '霑' => 0x1dbf,
    '霏' => 0x1dc0,
    '霖' => 0x1dc1,
    '霙' => 0x1dc2,
    '霤' => 0x1dc3,
    '霪' => 0x1dc4,
    '霰' => 0x1dc5,
    '霹' => 0x1dc6,
    '霽' => 0x1dc7,
    '霾' => 0x1dc8,
    '靄' => 0x1dc9,
    '靆' => 0x1dca,
    '靈' => 0x1dcb,
    '靂' => 0x1dcc,
    '靉' => 0x1dcd,
    '靜' => 0x1dce,
    '靠' => 0x1dcf,
    '靤' => 0x1dd0,
    '靦' => 0x1dd1,
    '靨' => 0x1dd2,
    '勒' => 0x1dd3,
    '靫' => 0x1dd4,
    '靱' => 0x1dd5,
    '靹' => 0x1dd6,
    '鞅' => 0x1dd7,
    '靼' => 0x1dd8,
    '鞁' => 0x1dd9,
    '靺' => 0x1dda,
    '鞆' => 0x1ddb,
    '鞋' => 0x1ddc,
    '鞏' => 0x1ddd,
    '鞐' => 0x1dde,
    '鞜' => 0x1ddf,
    '鞨' => 0x1de0,
    '鞦' => 0x1de1,
    '鞣' => 0x1de2,
    '鞳' => 0x1de3,
    '鞴' => 0x1de4,
    '韃' => 0x1de5,
    '韆' => 0x1de6,
    '韈' => 0x1de7,
    '韋' => 0x1de8,
    '韜' => 0x1de9,
    '韭' => 0x1dea,
    '齏' => 0x1deb,
    '韲' => 0x1dec,
    '竟' => 0x1ded,
    '韶' => 0x1dee,
    '韵' => 0x1def,
    '頏' => 0x1df0,
    '頌' => 0x1df1,
    '頸' => 0x1df2,
    '頤' => 0x1df3,
    '頡' => 0x1df4,
    '頷' => 0x1df5,
    '頽' => 0x1df6,
    '顆' => 0x1df7,
    '顏' => 0x1df8,
    '顋' => 0x1df9,
    '顫' => 0x1dfa,
    '顯' => 0x1dfb,
    '顰' => 0x1dfc,
    '顱' => 0x1e00,
    '顴' => 0x1e01,
    '顳' => 0x1e02,
    '颪' => 0x1e03,
    '颯' => 0x1e04,
    '颱' => 0x1e05,
    '颶' => 0x1e06,
    '飄' => 0x1e07,
    '飃' => 0x1e08,
    '飆' => 0x1e09,
    '飩' => 0x1e0a,
    '飫' => 0x1e0b,
    '餃' => 0x1e0c,
    '餉' => 0x1e0d,
    '餒' => 0x1e0e,
    '餔' => 0x1e0f,
    '餘' => 0x1e10,
    '餡' => 0x1e11,
    '餝' => 0x1e12,
    '餞' => 0x1e13,
    '餤' => 0x1e14,
    '餠' => 0x1e15,
    '餬' => 0x1e16,
    '餮' => 0x1e17,
    '餽' => 0x1e18,
    '餾' => 0x1e19,
    '饂' => 0x1e1a,
    '饉' => 0x1e1b,
    '饅' => 0x1e1c,
    '饐' => 0x1e1d,
    '饋' => 0x1e1e,
    '饑' => 0x1e1f,
    '饒' => 0x1e20,
    '饌' => 0x1e21,
    '饕' => 0x1e22,
    '馗' => 0x1e23,
    '馘' => 0x1e24,
    '馥' => 0x1e25,
    '馭' => 0x1e26,
    '馮' => 0x1e27,
    '馼' => 0x1e28,
    '駟' => 0x1e29,
    '駛' => 0x1e2a,
    '駝' => 0x1e2b,
    '駘' => 0x1e2c,
    '駑' => 0x1e2d,
    '駭' => 0x1e2e,
    '駮' => 0x1e2f,
    '駱' => 0x1e30,
    '駲' => 0x1e31,
    '駻' => 0x1e32,
    '駸' => 0x1e33,
    '騁' => 0x1e34,
    '騏' => 0x1e35,
    '騅' => 0x1e36,
    '駢' => 0x1e37,
    '騙' => 0x1e38,
    '騫' => 0x1e39,
    '騷' => 0x1e3a,
    '驅' => 0x1e3b,
    '驂' => 0x1e3c,
    '驀' => 0x1e3d,
    '驃' => 0x1e3e,
    '騾' => 0x1e40,
    '驕' => 0x1e41,
    '驍' => 0x1e42,
    '驛' => 0x1e43,
    '驗' => 0x1e44,
    '驟' => 0x1e45,
    '驢' => 0x1e46,
    '驥' => 0x1e47,
    '驤' => 0x1e48,
    '驩' => 0x1e49,
    '驫' => 0x1e4a,
    '驪' => 0x1e4b,
    '骭' => 0x1e4c,
    '骰' => 0x1e4d,
    '骼' => 0x1e4e,
    '髀' => 0x1e4f,
    '髏' => 0x1e50,
    '髑' => 0x1e51,
    '髓' => 0x1e52,
    '體' => 0x1e53,
    '髞' => 0x1e54,
    '髟' => 0x1e55,
    '髢' => 0x1e56,
    '髣' => 0x1e57,
    '髦' => 0x1e58,
    '髯' => 0x1e59,
    '髫' => 0x1e5a,
    '髮' => 0x1e5b,
    '髴' => 0x1e5c,
    '髱' => 0x1e5d,
    '髷' => 0x1e5e,
    '髻' => 0x1e5f,
    '鬆' => 0x1e60,
    '鬘' => 0x1e61,
    '鬚' => 0x1e62,
    '鬟' => 0x1e63,
    '鬢' => 0x1e64,
    '鬣' => 0x1e65,
    '鬥' => 0x1e66,
    '鬧' => 0x1e67,
    '鬨' => 0x1e68,
    '鬩' => 0x1e69,
    '鬪' => 0x1e6a,
    '鬮' => 0x1e6b,
    '鬯' => 0x1e6c,
    '鬲' => 0x1e6d,
    '魄' => 0x1e6e,
    '魃' => 0x1e6f,
    '魏' => 0x1e70,
    '魍' => 0x1e71,
    '魎' => 0x1e72,
    '魑' => 0x1e73,
    '魘' => 0x1e74,
    '魴' => 0x1e75,
    '鮓' => 0x1e76,
    '鮃' => 0x1e77,
    '鮑' => 0x1e78,
    '鮖' => 0x1e79,
    '鮗' => 0x1e7a,
    '鮟' => 0x1e7b,
    '鮠' => 0x1e7c,
    '鮨' => 0x1e7d,
    '鮴' => 0x1e7e,
    '鯀' => 0x1e7f,
    '鯊' => 0x1e80,
    '鮹' => 0x1e81,
    '鯆' => 0x1e82,
    '鯏' => 0x1e83,
    '鯑' => 0x1e84,
    '鯒' => 0x1e85,
    '鯣' => 0x1e86,
    '鯢' => 0x1e87,
    '鯤' => 0x1e88,
    '鯔' => 0x1e89,
    '鯡' => 0x1e8a,
    '鰺' => 0x1e8b,
    '鯲' => 0x1e8c,
    '鯱' => 0x1e8d,
    '鯰' => 0x1e8e,
    '鰕' => 0x1e8f,
    '鰔' => 0x1e90,
    '鰉' => 0x1e91,
    '鰓' => 0x1e92,
    '鰌' => 0x1e93,
    '鰆' => 0x1e94,
    '鰈' => 0x1e95,
    '鰒' => 0x1e96,
    '鰊' => 0x1e97,
    '鰄' => 0x1e98,
    '鰮' => 0x1e99,
    '鰛' => 0x1e9a,
    '鰥' => 0x1e9b,
    '鰤' => 0x1e9c,
    '鰡' => 0x1e9d,
    '鰰' => 0x1e9e,
    '鱇' => 0x1e9f,
    '鰲' => 0x1ea0,
    '鱆' => 0x1ea1,
    '鰾' => 0x1ea2,
    '鱚' => 0x1ea3,
    '鱠' => 0x1ea4,
    '鱧' => 0x1ea5,
    '鱶' => 0x1ea6,
    '鱸' => 0x1ea7,
    '鳧' => 0x1ea8,
    '鳬' => 0x1ea9,
    '鳰' => 0x1eaa,
    '鴉' => 0x1eab,
    '鴈' => 0x1eac,
    '鳫' => 0x1ead,
    '鴃' => 0x1eae,
    '鴆' => 0x1eaf,
    '鴪' => 0x1eb0,
    '鴦' => 0x1eb1,
    '鶯' => 0x1eb2,
    '鴣' => 0x1eb3,
    '鴟' => 0x1eb4,
    '鵄' => 0x1eb5,
    '鴕' => 0x1eb6,
    '鴒' => 0x1eb7,
    '鵁' => 0x1eb8,
    '鴿' => 0x1eb9,
    '鴾' => 0x1eba,
    '鵆' => 0x1ebb,
    '鵈' => 0x1ebc,
    '鵝' => 0x1ec0,
    '鵞' => 0x1ec1,
    '鵤' => 0x1ec2,
    '鵑' => 0x1ec3,
    '鵐' => 0x1ec4,
    '鵙' => 0x1ec5,
    '鵲' => 0x1ec6,
    '鶉' => 0x1ec7,
    '鶇' => 0x1ec8,
    '鶫' => 0x1ec9,
    '鵯' => 0x1eca,
    '鵺' => 0x1ecb,
    '鶚' => 0x1ecc,
    '鶤' => 0x1ecd,
    '鶩' => 0x1ece,
    '鶲' => 0x1ecf,
    '鷄' => 0x1ed0,
    '鷁' => 0x1ed1,
    '鶻' => 0x1ed2,
    '鶸' => 0x1ed3,
    '鶺' => 0x1ed4,
    '鷆' => 0x1ed5,
    '鷏' => 0x1ed6,
    '鷂' => 0x1ed7,
    '鷙' => 0x1ed8,
    '鷓' => 0x1ed9,
    '鷸' => 0x1eda,
    '鷦' => 0x1edb,
    '鷭' => 0x1edc,
    '鷯' => 0x1edd,
    '鷽' => 0x1ede,
    '鸚' => 0x1edf,
    '鸛' => 0x1ee0,
    '鸞' => 0x1ee1,
    '鹵' => 0x1ee2,
    '鹹' => 0x1ee3,
    '鹽' => 0x1ee4,
    '麁' => 0x1ee5,
    '麈' => 0x1ee6,
    '麋' => 0x1ee7,
    '麌' => 0x1ee8,
    '麒' => 0x1ee9,
    '麕' => 0x1eea,
    '麑' => 0x1eeb,
    '麝' => 0x1eec,
    '麥' => 0x1eed,
    '麩' => 0x1eee,
    '麸' => 0x1eef,
    '麪' => 0x1ef0,
    '麭' => 0x1ef1,
    '靡' => 0x1ef2,
    '黌' => 0x1ef3,
    '黎' => 0x1ef4,
    '黏' => 0x1ef5,
    '黐' => 0x1ef6,
    '黔' => 0x1ef7,
    '黜' => 0x1ef8,
    '點' => 0x1ef9,
    '黝' => 0x1efa,
    '黠' => 0x1efb,
    '黥' => 0x1efc,
    '黨' => 0x1efd,
    '黯' => 0x1efe,
    '黴' => 0x1f00,
    '黶' => 0x1f01,
    '黷' => 0x1f02,
    '黹' => 0x1f03,
    '黻' => 0x1f04,
    '黼' => 0x1f05,
    '黽' => 0x1f06,
    '鼇' => 0x1f07,
    '鼈' => 0x1f08,
    '皷' => 0x1f09,
    '鼕' => 0x1f0a,
    '鼡' => 0x1f0b,
    '鼬' => 0x1f0c,
    '鼾' => 0x1f0d,
    '齊' => 0x1f0e,
    '齒' => 0x1f0f,
    '齔' => 0x1f10,
    '齣' => 0x1f11,
    '齟' => 0x1f12,
    '齠' => 0x1f13,
    '齡' => 0x1f14,
    '齦' => 0x1f15,
    '齧' => 0x1f16,
    '齬' => 0x1f17,
    '齪' => 0x1f18,
    '齷' => 0x1f19,
    '齲' => 0x1f1a,
    '齶' => 0x1f1b,
    '龕' => 0x1f1c,
    '龜' => 0x1f1d,
    '龠' => 0x1f1e,
    '堯' => 0x1f1f,
    '槇' => 0x1f20,
    '遙' => 0x1f21,
    '瑤' => 0x1f22,
    '凜' => 0x1f23,
    '熙' => 0x1f24,
)
